
write-b -- ----------------------------------------------- --;
write   -- Requtes du chapitre 7 : Le langage SQL DML (1) --;
write   -- ----------------------------------------------- --;

openDB CLICOM.db;

write-b -- ------------------------- --;
write   -- 7.1 Requtes lmentaires --;
write-a -- ------------------------- --;

   select NCLI,NOM,LOCALITE 
   from   CLIENT;

   select NCLI,NOM 
   from   CLIENT 
   where  LOCALITE = 'Toulouse';

   select LOCALITE 
   from   CLIENT
   where  CAT = 'C1'; 

   select distinct LOCALITE
   from   CLIENT
   where  CAT = 'C1'; 

   select NCLI 
   from   COMMANDE;

   select distinct NCLI 
   from   COMMANDE;

   select *
   from   CLIENT 
   where  CAT is null;

   select *
   from   CLIENT 
   where  CAT in ('C1','C2','C3');

   select *
   from   CLIENT 
   where  COMPTE between 1000 and 4000;

   select *
   from   CLIENT 
   where  CAT like '_1';

   select *
   from   CLIENT 
   where  ADRESSE like '%Neuve%';

   select *
   from   COMMANDE 
   where  DATECOM like '2015%';

   select *
   from   COMMANDE 
   where  cast(DATECOM as char) like '2015%';

   select NOM,ADRESSE,COMPTE
   from   CLIENT
   where  LOCALITE = 'Toulouse' and COMPTE < 0; 

   select *
   from   CLIENT 
   where  COMPTE > 0
   and   (CAT = 'C1' or LOCALITE = 'Paris');


write-b -- ----------------------------------------- --;
write   -- 7.2 Donnes extraites et donnes drives --;
write-a -- ----------------------------------------- --;

   select 'TVA de ',NPRO,' = ',0.21*PRIX*QSTOCK
   from   PRODUIT 
   where  QSTOCK > 500;

   select NPRO as Produit, 0.21*PRIX*QSTOCK as Valeur_TVA
   from   PRODUIT 
   where  QSTOCK > 500;


write-b -- --------------------- --;
write   -- 7.3 Les fonctions SQL --;
write-a -- --------------------- --;

   select trim(ADRESSE)||', '||upper(LOCALITE)
   from   CLIENT;

   select NCLI as Client,
          --case substring(CAT from 1 for 1)
          case substr(CAT,1,1)
             when 'A' then 'bon'
             when 'B' then 'moyen'
             when 'C' then 'occasionnel'
             else coalesce(CAT,'inconnu')
          end as Score,
          LOCALITE as Localit
   from CLIENT;


write-b -- -------------------------------- --;
write   -- 7.4 Ordre des lignes du rsultat --;
write-a -- -------------------------------- --;

   select NCLI,NOM,LOCALITE
   from   CLIENT 
   order by LOCALITE,NCLI desc;


write-b -- ----------------------------- --;
write   -- 7.5 Les fonctions agrgatives --;
write-a -- ----------------------------- --;

   select 'Namur',avg(COMPTE) as Moyenne,
          max(COMPTE)-min(COMPTE) as Ecart_max,
          count(*) as Nombre
   from   CLIENT 
   where  LOCALITE = 'Namur'; 

   select sum(QSTOCK*PRIX) as Sapin
   from   PRODUIT 
   where  LIBELLE like '%SAPIN%'; 

   select count(NCLI) as Numeros,
          count(NOM) as Noms,
          count(LOCALITE) as Localites,
          count(CAT) as Categories
   from   CLIENT;

   select count(distinct NCLI) as Numeros,
          count(distinct NOM) as Noms,
          count(distinct LOCALITE) as Localites,
          count(distinct CAT) as Categories
   from   CLIENT;

-- L'indicateur null apparat par dfaut sous la forme '--'
-- Modifiable via le paramtre dispNull.

   select count(*) as Nombre, sum(COMPTE) as Somme,
          max(CAT) as Max
   from   CLIENT
   where  LOCALITE = 'Alger';


write-b -- --------------------- --;
write   -- 7.6 Les sous-requtes --;
write-a -- --------------------- --;

   select NCOM,DATECOM
   from   COMMANDE
   where  NCLI in ('C123','S127','B062','L422');

   select NCOM,DATECOM
   from   COMMANDE
   where  NCLI in (select NCLI
                   from   CLIENT 
                   where  LOCALITE = 'Namur');

   select *
   from   PRODUIT
   where  NPRO in 
              (select NPRO
               from   DETAIL
               where  NCOM in
                          (select NCOM
                           from   COMMANDE
                           where  NCLI in
                                      (select NCLI
                                       from   CLIENT 
                                       where  LOCALITE='Namur')));

   select *
   from   CLIENT 
   where  COMPTE > (select COMPTE
                    from   CLIENT where NCLI = 'C400');

   select NCOM,DATECOM,NCLI
   from   COMMANDE
   where  NCOM not in (select NCOM
                       from   DETAIL
                       where  NPRO = 'PA60');

   select NCOM,DATECOM,NCLI 
   from   COMMANDE
   where  NCOM in (select NCOM
                   from   DETAIL
                   where  NPRO <> 'PA60');

   select * 
   from  CLIENT
   where LOCALITE = 'POITIERS'
   and   NCLI not in (select NCLI
                      from   COMMANDE
                      where  DATECOM like '2015%')

   select NCOM,COM.DATECOM
   from   COMMANDE as COM
   where  COM.NCLI in (select CLI.NCLI
                       from   CLIENT as CLI
                       where  LOCALITE = 'Poitiers');

   select NCLI,NOM,LOCALITE,COMPTE
   from   CLIENT as CLI
   where  COMPTE > (select avg(COMPTE)
                    from   CLIENT
                    where  LOCALITE = CLI.LOCALITE);

   select NCOM,DATECOM,NCLI from COMMANDE C
   where  (select count(*)  from DETAIL
           where  NCOM = C.NCOM) >= 3;

   select NCLI from CLIENT
   where  CAT in (select CAT
                  from   CLIENT
                  where  NCLI = 'D063');


write-b -- ------------------------------------ --;
write   -- 7.7 Les quantificateurs ensemblistes --;
write-a -- ------------------------------------ --;

   select NPRO,LIBELLE
   from   PRODUIT as P
   where  exists (select *
                  from   DETAIL
                  where  NPRO = P.NPRO);

   --select distinct NCOM
   --from   DETAIL
   --where  QCOM <= all (select QCOM
   --                    from   DETAIL
   --                    where  NPRO = 'PA60')
   --and    NPRO = 'PA60';

   -- La requte prcdente n'est pas accepte par SQLite. 
   -- Utiliser plutt la suivente.

   select distinct NCOM
   from   DETAIL
   where  QCOM <= (select min(QCOM)
                   from   DETAIL
                   where  NPRO = 'PA60')
   and    NPRO = 'PA60';

   --select *
   --from   DETAIL
   --where  QCOM > any (select QCOM
   --                   from   DETAIL
   --                   where  NPRO = 'PA60')
   --and    NPRO = 'PA60';

   -- La requte prcdente n'est pas accepte par SQLite. 
   -- Utiliser plutt la suivente.

   select *
   from   DETAIL
   where  QCOM > (select min(QCOM)
                  from   DETAIL
                  where  NPRO = 'PA60')
   and    NPRO = 'PA60';


write-b -- ------------- --;
write   -- 7.8 Exercices --;
write-a -- ------------- --;

write-b -- Exercice 7.1 --; 
   select distinct LOCALITE
   from   CLIENT;

write-b -- Exercice 7.2 --;
   select NCLI, NOM, LOCALITE
   from   CLIENT
   where  CAT = 'C1'
   and    LOCALITE <> 'Toulouse';

write-b -- Exercice 7.3 --;
   select NCLI, NOM, COMPTE
   from   CLIENT
   where  LOCALITE in ('Poitiers','Bruxelles')
   and   COMPTE > 0;

write-b -- Exercice 7.4 --;
   select distinct CAT
   from   CLIENT
   where  LOCALITE = 'Toulouse'
   and    CAT is not null;

write-b -- Exercice 7.5 --;
   select NCLI, NOM, LOCALITE
   from   CLIENT
   where  NOM < LOCALITE;

write-b -- Exercice 7.6 --;
   select distinct LOCALITE
   from   CLIENT
   where  NCLI in (select NCLI
                   from   COMMANDE
                   where  NCOM in (select NCOM
                                   from   DETAIL
                                   where  NPRO = 'CS464'));

write-b -- Exercice 7.7 --;
   select NPRO
   from   PRODUIT
   where  LIBELLE like '%SAPIN%'
   and exists (select * 
               from   DETAIL
               where  NPRO = PRODUIT.NPRO);

-- 	ou

   select NPRO
   from   PRODUIT
   where  LIBELLE like '%SAPIN%'
   and    NPRO in (select NPRO
                   from   DETAIL);

write-b -- Exercice 7.8 --;
   select sum(QSTOCK*PRIX) as Total
   from   PRODUIT;

write-b -- Exercice 7.9 --;
   select count(*)
   from   COMMANDE
   where  NCOM in (select NCOM
                   from   DETAIL
                   where  NPRO in (select NPRO
                                   from PRODUIT
                                   where LIBELLE like '%ACIER%'));

write-b -- Exercice 7.10 --;
   select NCLI,NOM 
   from   CLIENT
   where  NCLI not in 
              (select NCLI
               from   COMMANDE
               where  NCOM in
                          (select NCOM
                           from   DETAIL
                           where  NPRO in
                                     (select NPRO
                                      from   PRODUIT
                                      where  LIBELLE like '%SAPIN%')));

write-b -- Exercice 7.11 --;
   select NPRO, LIBELLE
   from   PRODUIT
   where  NPRO not in (select NPRO
                       from   DETAIL 
                       where  NCOM in (select NCOM
                                       from COMMANDE
                                       where  DATECOM like '%2015%'));

write-b -- Exercice 7.12 --;
   select NCLI
   from   CLIENT C
   where not exists (select *
                     from   PRODUIT
                     where  NPRO not in 
                                (select NPRO
                                 from   DETAIL 
                                 where  NCOM in 
                                            (select NCOM
                                             from   COMMANDE
                                             where  NCLI = C.NCLI)));

write-b -- Exercice 7.13 --;
   select distinct LOCALITE
   from   CLIENT
   where  LOCALITE not in (select LOCALITE
                           from   CLIENT C
                           where exists (select *
                                         from   COMMANDE
                                         where  NCLI = C.NCLI));

write-b -- Exercice 7.14 --;
   select distinct LOCALITE
   from CLIENT C
   where  not exists (select *
                      from  CLIENT 
                      where LOCALITE = C.LOCALITE
                      and   NCLI not in (select NCLI
                                         from COMMANDE));
write;

closeDB;

