
-- ------------------------------------- --
-- Reprsentation de tableaux de donnes --
-- ------------------------------------- --

write-b -- ------------------------------------- --;
write   -- Reprsentation de tableaux de donnes --;
write   -- Voir Annexe 8                         --;
write   -- ------------------------------------- --;

write-b -- ------------------------------------------------------------------- --;
write   -- Premier essai : tableaux complets; Q = 0 si ingrdient pas utilis) --;
write   -- ------------------------------------------------------------------- --;

createOrReplaceDB PIVOT.db;

create table T(Pro char(3) not null,
               Ing char(3) not null,
               Q   integer not null);

insert into T values('P1','I1',2),
                    ('P1','I2',0),
                    ('P1','I3',0),
                    ('P1','I4',0),
                    ('P1','I5',3),
                    ('P2','I1',0),
                    ('P2','I2',4),
                    ('P2','I3',0),
                    ('P2','I4',5),
                    ('P2','I5',0),
                    ('P3','I1',5),
                    ('P3','I2',8),
                    ('P3','I3',1),
                    ('P3','I4',0),
                    ('P3','I5',4),
                    ('P4','I1',0),
                    ('P4','I2',0),
                    ('P4','I3',8),
                    ('P4','I4',0),
                    ('P4','I5',2);

write-b TableT;
select * from T;

write-b Tableau de gauche, 1re technique;
select T1.Pro,T1.Q as "I1",T2.Q as "I2",T3.Q as "I3",
       T4.Q as "I4",T5.Q as "I5" 
from   T T1,T T2,T T3,T T4,T T5
where                      T1.Ing = 'I1'
and    T2.Pro = T1.Pro and T2.Ing = 'I2'
and    T3.Pro = T1.Pro and T3.Ing = 'I3'
and    T4.Pro = T1.Pro and T4.Ing = 'I4'
and    T5.Pro = T1.Pro and T5.Ing = 'I5';

write-b Tableau de gauche, 2e technique (avec "else 0");
select Pro,
       max(case when Ing = 'I1' then Q else 0 end) as "I1",
       max(case when Ing = 'I2' then Q else 0 end) as "I2",
       max(case when Ing = 'I3' then Q else 0 end) as "I3",
       max(case when Ing = 'I4' then Q else 0 end) as "I4",
       max(case when Ing = 'I5' then Q else 0 end) as "I5" 
from   T
group by Pro;

write-b Tableau de gauche, 2e technique (sans "else 0");
select Pro,
       max(case when Ing = 'I1' then Q end) as "I1",
       max(case when Ing = 'I2' then Q end) as "I2",
       max(case when Ing = 'I3' then Q end) as "I3",
       max(case when Ing = 'I4' then Q end) as "I4",
       max(case when Ing = 'I5' then Q end) as "I5" 
from   T
group by Pro;

write-b Tableau de droite, 2e technique (avec "else 0");
select Ing,
       max(case when Pro = 'P1' then Q else 0 end) as "P1",
       max(case when Pro = 'P2' then Q else 0 end) as "P2",
       max(case when Pro = 'P3' then Q else 0 end) as "P3",
       max(case when Pro = 'P4' then Q else 0 end) as "P4" 
from   T
group by Ing;

write-b -- Tableau produit automatiquement --;
extract Query = select 'select Pro,'||group_concat('max(case when Ing = '''||Ing||''' then Q end) as "'||Ing||'"',',')||' from T group by Pro' as Query
from (select distinct Ing
      from T
      order by Ing);

$Query$;

closeDB;


write-b -- --------------------------------------------------------------- --;
write   -- Tableaux incomplets; ligne manquante si ingrdient pas utilis) --;
write   -- --------------------------------------------------------------- --;


createOrReplaceDB PIVOT.db;

create table T(Pro char(3) not null,
               Ing char(3) not null,
               Q   integer not null);

insert into T values('P1','I1',2),
                    ('P1','I5',3),
                    ('P2','I2',4),
                    ('P2','I4',5),
                    ('P3','I1',5),
                    ('P3','I2',8),
                    ('P3','I3',1),
                    ('P3','I5',4),
                    ('P4','I3',8),
                    ('P4','I5',2);

write-b TableT;
select * from T;

write-b Tableau de gauche, 1re technique (ne marche pas);
select T1.Pro,T1.Q as "I1",T2.Q as "I2",T3.Q as "I3",
       T4.Q as "I4",T5.Q as "I5" 
from   T T1,T T2,T T3,T T4,T T5
where                      T1.Ing = 'I1'
and    T2.Pro = T1.Pro and T2.Ing = 'I2'
and    T3.Pro = T1.Pro and T3.Ing = 'I3'
and    T4.Pro = T1.Pro and T4.Ing = 'I4'
and    T5.Pro = T1.Pro and T5.Ing = 'I5';

write-b Tableau de gauche, 2e technique (avec "else 0");
select Pro,
       max(case when Ing = 'I1' then Q else 0 end) as "I1",
       max(case when Ing = 'I2' then Q else 0 end) as "I2",
       max(case when Ing = 'I3' then Q else 0 end) as "I3",
       max(case when Ing = 'I4' then Q else 0 end) as "I4",
       max(case when Ing = 'I5' then Q else 0 end) as "I5" 
from   T
group by Pro;

write-b Tableau de gauche, 2e technique (sans "else 0");
select Pro,
       max(case when Ing = 'I1' then Q end) as "I1",
       max(case when Ing = 'I2' then Q end) as "I2",
       max(case when Ing = 'I3' then Q end) as "I3",
       max(case when Ing = 'I4' then Q end) as "I4",
       max(case when Ing = 'I5' then Q end) as "I5" 
from   T
group by Pro;

write-b Tableau de droite, 2e technique (avec "else 0");
select Ing,
       max(case when Pro = 'P1' then Q else 0 end) as "P1",
       max(case when Pro = 'P2' then Q else 0 end) as "P2",
       max(case when Pro = 'P3' then Q else 0 end) as "P3",
       max(case when Pro = 'P4' then Q else 0 end) as "P4" 
from   T
group by Ing;

write-b -- Tableau produit automatiquement --;
extract Query = select 'select Pro,'||group_concat('max(case when Ing = '''||Ing||''' then Q end) as "'||Ing||'"',',')||' from T group by Pro' as Query
from (select distinct Ing
      from T
      order by Ing);

$Query$;

closeDB;

deleteDB $dbDirectory$/PIVOT.db

write-b Fin de script;

