
write-b -- ----------------------------------------------- --;
write   -- Requtes du chapitre 8 : Le langage SQL DML (2) --;
write   -- ----------------------------------------------- --;

openDB CLICOM.db;

write-b -- -------------------------------------------------------- --;
write   -- 8.2 Extraction de donnes de plusieurs tables (jointure) --;
write-a -- -------------------------------------------------------- --;

     select NCOM,CLIENT.NCLI,DATECOM,NOM,LOCALITE
     from   COMMANDE, CLIENT
     where  COMMANDE.NCLI = CLIENT.NCLI;

     select CLIENT.NCLI,NOM,DATECOM,NPRO
     from   CLIENT,COMMANDE,DETAIL
     where  CLIENT.NCLI = COMMANDE.NCLI
     and    COMMANDE.NCOM = DETAIL.NCOM;

write-ab 8.2.2 Conditions de jointure et conditions de slection;

     select NCOM,CLIENT.NCLI,DATECOM,NOM,ADRESSE
     from   COMMANDE, CLIENT
     where  COMMANDE.NCLI = CLIENT.NCLI
     and    CAT = 'C1'
     and    DATECOM < '2015-12-31';

write-ab 8.2.3 Lignes clibataires et jointures externes;

     select null as NCOM,NCLI,null as DATECOM,NOM,LOCALITE
     from   CLIENT
     where  not exists (select *
                        from COMMANDE 
                        where NCLI = CLIENT.NCLI);

     select NCOM,C.NCLI,DATECOM,NOM,LOCALITE
     from    CLIENT C left outer join COMMANDE M
            on (M.NCLI = C.NCLI)
	 order by C.NCLI,NCOM;


write-b -- ------------------------------- --;
write   -- 8.3 Les oprateurs ensemblistes --;
write-a -- ------------------------------- --;

     select LOCALITE from CLIENT where CAT = 'C1';

     select LOCALITE from CLIENT where CAT = 'C1'
     union
     select LOCALITE from CLIENT where COMPTE < 0;

     select LOCALITE from CLIENT where CAT = 'C1'
     union all
     select LOCALITE from CLIENT where COMPTE < 0;


write-b -- ------------------------------- --;
write   -- 8.4 Le produit relationnel      --;
write-a -- ------------------------------- --;

     select NCOM,COMMANDE.NCLI,CLIENT.NCLI,DATECOM,NOM,ADRESSE
     from   COMMANDE,CLIENT;

     select distinct LOCALITE, NPRO
     from   CLIENT,PRODUIT;

     select distinct LOCALITE,NPRO
     from   CLIENT C,COMMANDE M,DETAIL D
     where  C.NCLI=M.NCLI
     and    M.NCOM=D.NCOM;

     select LOCALITE, NPRO
     from   CLIENT, PRODUIT
        except
     select LOCALITE,NPRO
     from   CLIENT C,COMMANDE M,DETAIL D
     where  C.NCLI=M.NCLI
     and    M.NCOM=D.NCOM;


write-b -- --------------------------------------------- --;
write   -- 8.5 Variantes syntaxiques de la jointure      --;
write-a -- --------------------------------------------- --;

     select * 
     from   CLIENT cross join COMMANDE;

     select * 
     from   CLIENT join COMMANDE;

     select * 
     from   CLIENT natural join COMMANDE;

     select * 
     from   CLIENT join COMMANDE using (NCLI);

     select * 
     from CLIENT inner join COMMANDE using (NCLI);
	 
     select * 
     from   CLIENT C join COMMANDE M
            on (C.NCLI = M.NCLI);

	 select C.NCLI,NOM,ADRESSE,LOCALITE,CAT,COMPTE,NCOM,DATECOM 
     from   CLIENT C, COMMANDE M
     where  C.NCLI = M.NCLI;

     select * 
     from   CLIENT C join COMMANDE M on (C.NCLI = M.NCLI)
            join DETAIL D on (M.NCOM = D.NCOM)
            join PRODUIT P on (D.NPRO = P.NPRO);

     select *
     from   CLIENT C,COMMANDE M, DETAIL D,PRODUIT P
     where  C.NCLI = M.NCLI
     and    M.NCOM = D.NCOM
     and    D.NPRO = P.NPRO;


write-b -- --------------------------------------------- --;
write   -- 8.6 Les tables statiques                      --;
write-a -- --------------------------------------------- --;

	select * from (values ('CS464',25),('PA60',12));

	select distinct NPRO,QCOM from DETAIL 
	union 
	values ('CS464',25),('PA60',12);


write-b -- --------------------------------------------- --;
write   -- 8.7 Requtes sur des structures cycliques     --;
write-a -- --------------------------------------------- --;

   create temporary table PERSONNE ( 
          NPERS       char(4) not null primary key,
          NOM         varchar(25) not null,
          RESPONSABLE char(4),
          foreign key (RESPONSABLE) references PERSONNE on delete no action);

   insert into PERSONNE(NPERS,NOM) values ('p1','Mercier');
   insert into PERSONNE(NPERS,NOM) values ('p2','Durant');
   insert into PERSONNE(NPERS,NOM,RESPONSABLE) values ('p3','Noirons','p1');
   insert into PERSONNE(NPERS,NOM,RESPONSABLE) values ('p4','Dupont','p1');
   insert into PERSONNE(NPERS,NOM,RESPONSABLE) values ('p5','Verger','p4');
   insert into PERSONNE(NPERS,NOM,RESPONSABLE) values ('p6','Dupont','p4');
   insert into PERSONNE(NPERS,NOM,RESPONSABLE) values ('p7','Dermiez','p6');
   insert into PERSONNE(NPERS,NOM,RESPONSABLE) values ('p8','Anciers','p2');

     select * from PERSONNE;
	 
     select S.NPERS,R.NPERS,R.NOM
     from   PERSONNE S, PERSONNE R
     where  S.RESPONSABLE = R.NPERS;

     select S.NPERS, R.NPERS, R.NOM
     from   PERSONNE S, PERSONNE R
     where  S.RESPONSABLE = R.NPERS
     and    S.NOM = 'Dupont'
     union
     select NPERS, '--', '--'
     from   PERSONNE
     where  RESPONSABLE is null and NOM = 'Dupont';

     select R.NPERS, R.NOM, SS.NPERS, SS.NOM
     from   PERSONNE R, PERSONNE S, PERSONNE SS
     where  R.NPERS = 'p4'
     and    R.NPERS = S.RESPONSABLE
     and    S.NPERS = SS.RESPONSABLE;

   create temporary table PPRODUIT (
          NPRO     char(10) not null primary key,
          LIBELLE  char(8)  not null,
          PRIX_U   decimal (6,2),
          POIDS_U  decimal (6,2));

   create temporary table COMPOSITION (
          COMPOSE   char(10)   not null,
          COMPOSANT char(10)   not null,
          QTE       decimal (6,2) not null,
          primary key (COMPOSE,COMPOSANT),
          foreign key (COMPOSE) references PPRODUIT
              on delete cascade
              on update cascade,
          foreign key (COMPOSANT) references PPRODUIT
              on delete cascade
              on update cascade);

   insert into PPRODUIT(NPRO,LIBELLE) values ('p1','A-200');
   insert into PPRODUIT(NPRO,LIBELLE) values ('p2','A-056');
   insert into PPRODUIT(NPRO,LIBELLE) values ('p3','B-661');
   insert into PPRODUIT(NPRO,LIBELLE) values ('p4','B-122');
   insert into PPRODUIT(NPRO,LIBELLE) values ('p5','B-326');
   insert into PPRODUIT(NPRO,LIBELLE,PRIX_U,POIDS_U) values ('p6','D-822',3.5,0.70);
   insert into PPRODUIT(NPRO,LIBELLE,PRIX_U,POIDS_U) values ('p7','D-507',8.0,0.25);
   insert into PPRODUIT(NPRO,LIBELLE,PRIX_U,POIDS_U) values ('p8','G-993',5.0,1.15);
   insert into PPRODUIT(NPRO,LIBELLE) values ('p9','F-016');
   insert into PPRODUIT(NPRO,LIBELLE) values ('p10','J-500');
   insert into PPRODUIT(NPRO,LIBELLE,PRIX_U,POIDS_U) values ('p11','J-544',0.5,0.90);
   insert into PPRODUIT(NPRO,LIBELLE,PRIX_U,POIDS_U) values ('p12','L-009',1.7,2.30);

   insert into COMPOSITION values ('p1','p2',2);
   insert into COMPOSITION values ('p1','p3',1);
   insert into COMPOSITION values ('p1','p4',2);
   insert into COMPOSITION values ('p2','p7',8);
   insert into COMPOSITION values ('p2','p8',2);
   insert into COMPOSITION values ('p3','p8',5);
   insert into COMPOSITION values ('p4','p8',4);
   insert into COMPOSITION values ('p4','p9',5);
   insert into COMPOSITION values ('p4','p10',5);
   insert into COMPOSITION values ('p5','p4',2);
   insert into COMPOSITION values ('p5','p6',7);
   insert into COMPOSITION values ('p9','p11',2);
   insert into COMPOSITION values ('p10','p11',4);
   insert into COMPOSITION values ('p10','p12',3);

   commitDB;
   
     select * from PPRODUIT;
	 select * from COMPOSITION;
	 
     select H.NPRO,H.LIBELLE,C.QTE,B.NPRO,B.LIBELLE
     from   PPRODUIT H, COMPOSITION C, PPRODUIT B
     where  C.COMPOSE = H.NPRO
     and    C.COMPOSANT = B.NPRO
     and    H.NPRO = 'p4';

write-b -- --------------------------------------------- --;
write   -- 8.8 Complments sur les jointures             --;
write-a -- --------------------------------------------- --;

write-ab 8.8.1 Sous-requte ou jointure ?;

     select NCOM,DATECOM
     from   COMMANDE
     where  NCLI in (select NCLI
                     from   CLIENT
                     where  LOCALITE = 'Poitiers');

     select NCOM,DATECOM
     from   COMMANDE, CLIENT
     where  COMMANDE.NCLI = CLIENT.NCLI
     and    LOCALITE = 'Poitiers';

     select NCOM, DATECOM, NCLI
     from   COMMANDE
     where  NCOM in (select NCOM
                     from   DETAIL
                     where  NPRO = 'PA60'
                     and    QCOM < (select QCOM
                                    from   DETAIL
                                    where  NPRO = 'PA60'
                                    and    NCOM = '30182'));

     select distinct M.NCOM, DATECOM, NCLI
     from   COMMANDE M, DETAIL D1, DETAIL D2 
     where  M.NCOM = D1.NCOM
     and    D1.NPRO = 'PA60'
     and    D2.NCOM = '30182'
     and    D2.NPRO = 'PA60'
     and    D1.QCOM < D2.QCOM;

     select NCOM, DATECOM, NCLI 
     from   COMMANDE
     where  NCOM not in (select NCOM
                         from   DETAIL
                         where  NPRO = 'PA60');

     select NCOM, DATECOM,NCLI
     from   COMMANDE C
     where  not exists (select 1
                        from  DETAIL
                        where NCOM = C.NCOM
						and   NPRO = 'PA60');
						
     select distinct COMMANDE.NCOM, DATECOM, NCLI 
     from   COMMANDE, DETAIL
     where  COMMANDE.NCOM = DETAIL.NCOM
     and    NPRO <> 'PA60';

     select distinct COMMANDE.NCOM, DATECOM, NCLI 
     from   COMMANDE, DETAIL
     where  COMMANDE.NCOM <> DETAIL.NCOM
     and    NPRO = 'PA60';

     select C.NCLI,NOM
     from   CLIENT C left outer join COMMANDE M 
            on (C.NCLI = M.NCLI)
     where  M.NCOM is null;

write-ab 8.8.2 Valeurs drives dans une jointure;

     select NCOM, D.NPRO, QCOM*PRIX
     from   DETAIL D, PRODUIT P 
     where  D.NPRO = P.NPRO;


     select 'Montant commande 30184 = ', sum(QCOM*PRIX)
     from   DETAIL D, PRODUIT P 
     where  D.NCOM = '30184'
     and    D.NPRO = P.NPRO;

write-ab 8.8.3 Les jointures gnralises; 

   abortDB;
   create temporary table VENTE(
          CHAINE   char(20)     not null,
          PRODUIT  char(20)     not null,
		  PRIX     integer      not null);
		  
   create temporary table IMPLANTATION(
          CHAINE   char(20)     not null,
		  VILLE    varchar(30)  not null);
		  
   create temporary table CLASSE_CPT(
          MIN_CPT  decimal(9,2) not null,
          MAX_CPT  decimal(9,2) not null,
		  CODE_CPT char(1)      not null);
   
   insert into VENTE values('SUPER_U','Chocolat',6);
   insert into VENTE values('MAMMOUTH','Sucre',2);
   insert into VENTE values('MAMMOUTH','Chocolat',5);
   insert into VENTE values('MATCH','Sel',2);
   insert into VENTE values('MAMMOUTH','Sel',2);
   
   insert into IMPLANTATION values('SUPER_U','LILLE');
   insert into IMPLANTATION values('SUPER_U','ANNECY');
   insert into IMPLANTATION values('MAMMOUTH','LYON');
   insert into IMPLANTATION values('MAMMOUTH','LILLE');
   insert into IMPLANTATION values('MATCH','PARIS');
   insert into IMPLANTATION values('MATCH','LILLE');
   insert into IMPLANTATION values('MATCH','TOURNAI');
   insert into IMPLANTATION values('CORA','CHARLEROI');
   
   insert into CLASSE_CPT values(10000,32000,'A');
   insert into CLASSE_CPT values(5000,10000,'B');
   insert into CLASSE_CPT values(2000,5000,'C');
   insert into CLASSE_CPT values(1000,2000,'D');
   insert into CLASSE_CPT values(500,1000,'F');
   insert into CLASSE_CPT values(0,500,'G');
   insert into CLASSE_CPT values(-500,0,'U');
   insert into CLASSE_CPT values(-1000,-500,'V');
   insert into CLASSE_CPT values(-2000,-1000,'W');
   insert into CLASSE_CPT values(-5000,-2000,'X');
   insert into CLASSE_CPT values(-10000,-5000,'Y');
   insert into CLASSE_CPT values(-32000,-10000,'Z');
   
   commitDB;
   
     select distinct PRODUIT,VILLE,PRIX
     from   VENTE V, IMPLANTATION I 
     where  V.CHAINE = I.CHAINE;

     select NCLI, NOM, CODE_CPT
     from   CLIENT, CLASSE_CPT
     where  CAT = 'C1'
     and    COMPTE >= MIN_CPT and COMPTE < MAX_CPT
     order by NCLI;

     select C.NCLI,NOM,LOCALITE
     from   CLIENT C, COMMANDE M
     where  M.NCLI = C.NCLI;

     select COMMANDE.NCOM,DATECOM,NCLI
     from   COMMANDE,DETAIL
     where  COMMANDE.NCOM = DETAIL.NCOM;

     select D.NCOM,D.NPRO,LOCALITE,LIBELLE
     from   CLIENT CLI,COMMANDE COM,DETAIL D,PRODUIT P
     where  CLI.NCLI = COM.NCLI
     and    COM.NCOM = D.NCOM
     and    D.NPRO = P.NPRO;

write-ab Identifiant d'une jointure;

     select LOCALITE,LIBELLE
     from   CLIENT CLI,COMMANDE COM,DETAIL D,PRODUIT P
     where  CLI.NCLI = COM.NCLI
     and    COM.NCOM = D.NCOM
     and    D.NPRO = P.NPRO;


write-b -- --------------------------------------------- --;
write   -- 8.9 Extraction de donnes groupes            --;
write-a -- --------------------------------------------- --;

write-ab 8.9.1 Notion de groupe de lignes;

     select LOCALITE,
            count(*) as Nombre,
            round(avg(COMPTE),1) as Moyenne
     from   CLIENT
     group by LOCALITE;

write-ab 8.9.2 Slection de groupes et slection de lignes;

     select LOCALITE, count(*) as Nombre, round(avg(COMPTE),1) as Moyenne
     from   CLIENT
     group by LOCALITE 
     having Nombre >= 3;

     select LOCALITE, count(*) as Nombre, round(avg(COMPTE),1) as Moyenne
     from   CLIENT
     group by LOCALITE 
     having count(*) >= 3;

     select NCLI, count(*) as Nombre
     from   COMMANDE
     group by NCLI
     having Nombre >= 2;

     select NCLI, count(*) as Nombre
     from   COMMANDE
     where  NCOM in ( select NCOM
                      from   DETAIL
                      where  NPRO = 'PA45')
     group by NCLI
     having Nombre >= 2; 

write-ab 8.9.3 Groupes et jointures;

     select NCLI, count(*) as Nombre, sum(QCOM) as Quantite
     from   COMMANDE M, DETAIL D
     where  M.NCOM = D.NCOM
     and    NPRO = 'PA45'
     group by NCLI 
     having Nombre >= 2;

     select 'Montant d par ',M.NCLI,' = ',sum(QCOM*PRIX)
     from   CLIENT C, COMMANDE M, DETAIL D, PRODUIT P 
     where  LOCALITE = 'Poitiers'
     and    M.NCLI = C.NCLI
     and    M.NCOM = D.NCOM
     and    D.NPRO = P.NPRO
     group by M.NCLI;

write-ab 8.9.4 Composition de la liste select;

     select P.NPRO, QSTOCK - sum(D.QCOM) as SOLDE
     from   DETAIL D, PRODUIT P 
     where  D.NPRO = P.NPRO
     group by P.NPRO, QSTOCK;

write-ab 8.9.5 Composition du critre de groupement;

     select LOCALITE,P.NPRO,sum(QCOM*PRIX) as Montant
     from   CLIENT C, COMMANDE M, DETAIL D, PRODUIT P 
     where  M.NCLI = C.NCLI
     and    M.NCOM = D.NCOM
     and    D.NPRO = P.NPRO
     group by LOCALITE, P.NPRO;

     --select substring(CAT from 1 for 1) as Cat1, count(*) as N
     select substr(CAT,1,1) as Cat1, count(*) as N
     from   CLIENT
     group by substr(CAT,1,1);
     --group by substring(CAT from 1 for 1);

	 select int(COMPTE/1000)*1000 + case sign2(COMPTE) when -1 then -1000 else 0 end as Min,
			int(COMPTE/1000)*1000 + case sign2(COMPTE) when -1 then -1 else 999 end as Max,
			count(*) as N
	 from CLIENT
	 group by int(COMPTE/1000);
	 
write-ab 8.9.6 Attention aux groupements multi-niveaux;

     select LOCALITE,sum(COMPTE),count(*)
     from   CLIENT C, COMMANDE M
     where  C.NCLI = M.NCLI
     group by LOCALITE;

     select LOCALITE,sum(COMPTE),(select count(*) from COMMANDE
                                  where NCLI = C.NCLI) as Nombre
     from   CLIENT C
     group by LOCALITE;

     select M.NCLI,count(distinct M.NCOM),sum(QCOM*PRIX)
     from   COMMANDE M, DETAIL D, PRODUIT P
     where  M.NCOM = D.NCOM
     and    D.NPRO = P.NPRO
     group by M.NCLI;

write-ab 8.9.7 Peut-on viter l'utilisation de donnes groupes ?;

     select D.NPRO
     from   DETAIL D, COMMANDE M
     where  D.NCOM = M.NCOM
     and    DATECOM like '2015%'
     group by D.NPRO
     having sum(QCOM) > 50;

     select NPRO from PRODUIT P
     where  (select sum(QCOM) from DETAIL
             where NPRO = P.NPRO
             and NCOM in (select NCOM from COMMANDE
                          where DATECOM like '2015%')) > 50;


write-b -- ----------------------------------------------- --;
write   -- 8.10 Extension de la structure des requtes SFW --;
write-a -- ----------------------------------------------- --;

write-ab 8.10.1 Extension de la clause select;

     select NCOM, (select sum(QCOM*PRIX)
                   from   DETAIL D, PRODUIT P
                   where  D.NPRO = P.NPRO
                   and    D.NCOM = M.NCOM) as MONTANT
     from   COMMANDE M
     where  MONTANT > 1000;

write-ab 8.10.2 Extension de la clause from;

     select int(avg(MONTANT)) 
     from  (select NCOM, sum(QCOM*PRIX) as MONTANT
            from   DETAIL D, PRODUIT P
            where  D.NPRO = P.NPRO
            group by NCOM);

	 abortDB;
	 create temporary table PROSPECT(NCLI char(10), NOM char(32), LOCALITE char(30));
	 insert into PROSPECT values ('X999','DUPONT','Poitiers');
	 create temporary view BON_CLIENT as select NCLI,NOM,LOCALITE from CLIENT where COMPTE > 0.0;
	 
     select NCLI, NOM
     from (select NCLI,NOM,LOCALITE from CLIENT
            except
           select NCLI,NOM,LOCALITE from BON_CLIENT
            union
           select NCLI,NOM,LOCALITE from PROSPECT)
     where LOCALITE = 'Poitiers';

	 -- Variante SQLite
     select NPRO,TOTAL_QTE 
     from  ( select NPRO, 0 as TOTAL_QTE
           	 from   PRODUIT
             where  NPRO not in (select NPRO from DETAIL)
                union 
             select NPRO, sum(QCOM) as TOTAL_QTE
	     from   DETAIL
             group by NPRO
           )
              as DP
     where TOTAL_QTE < 1000;


write-b -- ----------------------------------------------- --;
write   -- 8.11 Limitation de la taille d'un rsultat      --;
write-a -- ----------------------------------------------- --;

	select * from CLIENT 
	order by NCLI
    limit 5 offset 4 ;


write-b -- ----------------------------------------------- --;
write   -- 8.13 Modification des donnes                   --;
write-a -- ----------------------------------------------- --;

write-ab 8.13.1 Ajout de lignes;

     insert into DETAIL values ('30185','PA45',12);

     insert into CLIENT (NCLI,NOM,ADRESSE,COMPTE,LOCALITE)
     values ('C402','BERNIER','avenue de France, 28',
             -2500,'Lausanne');

     insert into DETAIL values ('30178','PA45',12),
                               ('30178','CS262',5);

	 abortDB;
     create temporary table CLI_TOULOUSE(NCLI char(10),NOM char(32),ADRESSE char(30));

     insert into CLI_TOULOUSE
     select NCLI, NOM, ADRESSE
     from   CLIENT
     where  LOCALITE = 'Toulouse';
	 
	 select * from CLI_TOULOUSE;

write-ab 8.13.2 Suppression de lignes;

     delete from  CLIENT
     where NCLI = 'B062';

     delete from  DETAIL
     where NPRO in (select NPRO
                    from   PRODUIT
                    where  QSTOCK <= 0);

write-ab 8.13.3 Modification de lignes;

     update CLIENT
     set    ADRESSE = '29, av. de la Magne', LOCALITE = 'Niort' 
     where  NCLI = 'F011';

     update PRODUIT
     set    PRIX = PRIX * 1.05
     where  LIBELLE like '%SAPIN%';

	 -- variante SQLite
     update PRODUIT
     set    QSTOCK = QSTOCK - (select sum(QCOM)
                               from   DETAIL
                               where  NPRO = PRODUIT.NPRO)
     where  exists (select *
	                from DETAIL
					where NPRO = PRODUIT.NPRO);
	 abortDB;


write-ab 8.13.6 Dterminisme des requtes de modification;

	 update CLIENT set ADRESSE = LOCALITE,
                       LOCALITE = ADRESSE
	 where CAT = 'C1';
					   
	 select * from CLIENT;
	 abortDB;

	 onError continue;
	 select * from PERSONNE;
     delete from PERSONNE where NPERS = 'p2'; 
     delete from PERSONNE where NPERS = 'p8'; 
	 select * from PERSONNE;
	 abortDB;

     delete from PERSONNE where NPERS = 'p8'; 
	 delete from PERSONNE where NPERS = 'p2'; 
	 select * from PERSONNE;
	 abortDB;
	 onError stop;

	 
write-b -- ----------------------------------------------- --;
write   -- 8.17 Exercices                                  --;
write-a -- ----------------------------------------------- --;

write-b Exercice 8.1;

   select D.NCOM, P.NPRO, QCOM*PRIX as MONTANT
   from   COMMANDE M, DETAIL D, PRODUIT P
   where  D.NCOM = M.NCOM
   and    D.NPRO = P.NPRO
   and    NCLI = 'C400';

write-b Exercice 8.2;

   select sum(QCOM*PRIX) as MONTANT
   from   DETAIL D,PRODUIT P
   where  D.NPRO = P.NPRO
   and    P.LIBELLE like '%SAPIN%';

write-b Exercice 8.3 (3);

   select LOCALITE, CAT, sum(COMPTE), int(avg(COMPTE)), count(*)
   from   CLIENT
   group by LOCALITE, CAT;

write-b Exercice 8.4;

   select count(distinct M.NCOM)
   from   COMMANDE M, DETAIL D, PRODUIT P
   where  M.NCOM = D.NCOM and D.NPRO = P.NPRO
   and    LIBELLE like '%ACIER%';

write-b Exercice 8.5;

   abortDB;
   create temporary table DETAIL_COM(NCOM char(12),DATECOM date,QCOM decimal(8),
                                     NPRO char(15),PRIX decimal(6),MONTANT decimal(8));
   insert into DETAIL_COM(NCOM,DATECOM,QCOM,NPRO,PRIX,MONTANT)
   select M.NCOM, DATECOM, QCOM, P.NPRO, PRIX, QCOM*PRIX
   from   COMMANDE M, DETAIL D, PRODUIT P
   where  M.NCOM = D.NCOM and D.NPRO = P.NPRO;
   
   select * from DETAIL_COM;

write-b Exercice 8.6;

   update CLIENT set COMPTE = 0
   where  COMPTE < 0 and CAT = 'C1';
   
   select * from CLIENT;

write-b Exercice 8.7;

   select CAT,P.NPRO,sum(QCOM*PRIX) as Valeur
   from   CLIENT C, COMMANDE M, DETAIL D, PRODUIT P
   where  C.NCLI = M.NCLI and M.NCOM = D.NCOM and D.NPRO = P.NPRO
   group by CAT, P.NPRO;

write-b Exercice 8.8;

   select NPRO
   from   PPRODUIT
   where  NPRO not in (select COMPOSE from COMPOSITION);

   select NPRO
   from   PPRODUIT
   where  NPRO not in (select COMPOSANT from COMPOSITION);

   select NPRO
   from   PPRODUIT
   where  NPRO in (select COMPOSE   from COMPOSITION)
   and    NPRO in (select COMPOSANT from COMPOSITION);

   select PH.NPRO,sum(QTE*PB.PRIX_U) as Prix,sum(QTE*PB.POIDS_U) as Poids
   from   PPRODUIT PH, COMPOSITION C, PPRODUIT PB
   where  PH.NPRO = C.COMPOSE
   and    C.COMPOSANT = PB.NPRO
   and  not exists (select *
                    from  COMPOSITION CC, PPRODUIT BB
                    where CC.COMPOSANT = BB.NPRO
					and   CC.COMPOSE = PH.NPRO
                    and  (BB.PRIX_U is null or BB.POIDS_U is null))
   group by PH.NPRO;

write-b Exercice 8.9;

   select NCLI, sum(QCOM*PRIX)
   from   COMMANDE M, DETAIL D, PRODUIT P
   where  M.NCOM = D.NCOM
   and    D.NPRO = P.NPRO
   group by NCLI
     union
   select NCLI, 0 from CLIENT C
   where  not exists (select * 
                      from   COMMANDE
					  where  NCLI = C.NCLI);

write-b Exercice 8.10;

   select LOCALITE, LIBELLE from CLIENT C, COMMANDE M, DETAIL D, PRODUIT P
   where  C.NCLI = M.NCLI and M.NCOM = D.NCOM and D.NPRO = P.NPRO
   group by LOCALITE, LIBELLE order by LOCALITE, LIBELLE;

write-b Exercice 8.11;

   select distinct L.LOCALITE, C.CAT
   from   CLIENT L, CLIENT C
   where  C.CAT is not null
   and not exists (select *
		           from  CLIENT
		           where LOCALITE = L.LOCALITE
		           and   CAT = C.CAT);

write-b Exercice 8.12;

   update PPRODUIT
   set PRIX_U = (select sum(QTE*PB.PRIX_U)
                 from   COMPOSITION C, PPRODUIT PB
                 where  PPRODUIT.NPRO = C.COMPOSE
				 and    C.COMPOSANT = PB.NPRO)
   where  PRIX_U is null
   and    not exists (select *
                     from  COMPOSITION CC, PPRODUIT BB
                     where CC.COMPOSANT = BB.NPRO
					 and   CC.COMPOSE = PPRODUIT.NPRO
                     and   BB.PRIX_U is null);
   select * from PPRODUIT;
   abortDB;
   
write-b Exercice 8.13;

   select VILLE, PRODUIT, avg(PRIX)
   from   VENTE V, IMPLANTATION I
   where  V.CHAINE = I.CHAINE
   group by VILLE, PRODUIT;

write-b Exercice 8.14;

   create temporary view NOMBRE as
      select NCOM, count(*) as NBRE
      from   DETAIL
      group by NCOM;

   select avg(NBRE) from NOMBRE;

write-b Exercice 8.15;

   select D.NPRO, LOCALITE, sum(QCOM)
   from CLIENT C, COMMANDE M, DETAIL D
   where  C.NCLI = M.NCLI and M.NCOM = D.NCOM
   group by D.NPRO,LOCALITE
   having sum(QCOM) > 100;

closeDB;

write-b Fin de script;
