write-b -- -------------------------- --;
write   -- Les requtes du chapitre 9 --;
write   -- Les requtes rcursives    --;
write   --       PERSONNE             --;
write-a -- -------------------------- --;

createOrReplaceDB PERSONNE.db;

while (True);
  ask Max = Nombre de carrs:;
  if ('$DIALOGbutton$' = 'Cancel' or '$Max$' = '') exit;

  with recursive CARRES(N,Carre)
  as (values (1,1)
        union all
      select N+1,(N+1)*(N+1)
      from   CARRES where  N < $Max$)
      select * from CARRES order by N;
endwhile;

create table PERSONNE(
    NPERS       char(4)  not null primary key,
    NOM         char(24) not null,
    RESPONSABLE char(4),
    foreign key (RESPONSABLE) references PERSONNE
            on delete set null
            on update cascade);

-- Lgre modification des donnes : p02 est dclare subordonn de p01.
insert into PERSONNE values ('p01','Mercier',null);
insert into PERSONNE values ('p02','Durant','p01');
insert into PERSONNE values ('p03','Noirons','p01');
insert into PERSONNE values ('p04','Dupont','p01');
insert into PERSONNE values ('p05','Verger','p04');
insert into PERSONNE values ('p06','Dupont','p04');
insert into PERSONNE values ('p07','Dermiez','p06');
insert into PERSONNE values ('p08','Anciers','p02');

while (True);
  ask pers = Id d'une personne:[!select NPERS from PERSONNE];
  if ('$DIALOGbutton$' = 'Cancel' or '$pers$' = '') exit;

  with recursive ORGA(NIVEAU,NPERS)
  as (values (1,'$pers$')
        union all
      select O.NIVEAU + 1, P.NPERS
      from   ORGA O, PERSONNE P 
      where  O.NPERS = P.RESPONSABLE)
      select NIVEAU,P.NPERS,NOM,RESPONSABLE 
      from   ORGA O,PERSONNE P where O.NPERS = P.NPERS;
endwhile;

with recursive ORGA(Premier,Dernier,Longueur,Chemin)
as (select NPERS,NPERS,0,'.'||NPERS||'.' from PERSONNE
      union all
    select O.Premier, P.NPERS,O.Longueur + 1, O.Chemin||P.NPERS||'.'
    from   ORGA O, PERSONNE P 
    where  O.Dernier = P.RESPONSABLE)
    select * from ORGA order by Chemin;

-- On cre un circuit dans la table PERSONNE --
update PERSONNE set RESPONSABLE = 'p07' where NPERS = 'p01';

while (True);
   ask pers = [/b Contrle des circuits] Id d'une personne:[!select NPERS from PERSONNE];
   if ('$DIALOGbutton$' = 'Cancel' or '$pers$' = '') exit;

   with recursive ORG(Niveau,NPERS,Chemin)
   as (select 1,'$pers$','.$pers$.'
         union all
       select Niveau+1,P.NPERS,Chemin||P.NPERS||'.'
       from   ORG O, PERSONNE P
       where  O.NPERS = P.RESPONSABLE
       and    Niveau < 10
       )
   select * from ORG;

   extract N = select count(*) from PERSONNE;
   with recursive ORG(Niveau,NPERS,Chemin)
   as (select 1,'$pers$','.$pers$.'
         union all
       select Niveau+1,P.NPERS,Chemin||P.NPERS||'.'
       from   ORG O, PERSONNE P
       where  O.NPERS = P.RESPONSABLE
       and    Niveau < $N$
       )
   select * from ORG;

   with recursive ORG(Niveau,NPERS,Chemin)
   as (select 1,'$pers$','.$pers$.'
         union all
       select Niveau+1,P.NPERS,Chemin||P.NPERS||'.'
       from   ORG O, PERSONNE P
       where  O.NPERS = P.RESPONSABLE
       and    Chemin not like '%.'||P.NPERS||'.%'
       )
   select * from ORG;

endWhile;

closeDB;

write-b Fin de script;
