
write-b -- ------------------------------------------------------ --;
write   --                                                        --;
write   --        EXPERIMENTATION DES FONCTIONS "WINDOW"          --;
write   --                                                        --;
write   -- (certaines sections lmentaires restent  dvelopper) --;
write-a -- ------------------------------------------------------ --;


set Labels = CREER,AFFICHER,CLASSIQUES,FILTER,EXEMPLE,PARTITIONS,ORDRES,AGREGATIVES,RANKING,VALEURS,FRAME,SOMMES,MOYENNES,QUANTILES,CENTRALES,CLEAR;

label SELECT;
selectOne oper = [/Selectionner une catgorie d'exemples]
                  {Gnralits : extensions}
                 |Crer la table CLIENT
                 |Afficher la table CLIENT
                 |Quelques requtes statistiques classiques
                 |"filter", "rollup" et "cube"
                 |"Window" : un premier exemple complet
                 |{Partitions et ordres}
                 |Les partitions
                 |Les ordres
                 |{Les fonctions de calcul}
                 |Les fonctions agrgatives classiques
                 |Les fonctions de "ranking"
                 |Les fonctions de "valeur"
                 |{Les "frames"}
                 |"rows", "groups" et "ranges"
                 ||{Applications}
                 |Les sommes
                 --|Sommes et sommes cumules
                 --|Sommes mobiles
                 |Les moyennes
                 --|Calcul moyenne (formes classiques)
                 --|Calcul moyenne (fonction Window)
                 --|Moyennes mobiles
                 |Les quantiles
                 |Valeurs centrales et dispersion
                 |{Divers}
                 |Effacer
                 ;
    if ('$DIALOGbutton$' = 'Cancel' or $oper$ = 0);
        closeDB;
        write-b End of script;
        return;
    endif;

compute item = item('$Labels$',$oper$,',');
goto $item$;

           -- ======================================== --
           --         {Gnralits : extensions}       --
           -- ======================================== --

-- ---------------------------------------------------------
label CREER;
-- ---------------------------------------------------------

closeDB;
createDB InMemory;

create table CLIENT (
        NCLI     char(10)    not null,
        NOM      char(32)    not null,
        LOCALITE char(30)    not null,
        CAT      char(2),
        COMPTE   decimal(9,2) not null);

insert into CLIENT values 
   ('B112','HANSENNE', 'Poitiers', 'C1',  125),
   ('C123','MERCIER',  'Namur',    'C1', -230),
   ('B332','MONTI',    'Genve',   'B2',    0),
   ('F010','TOUSSAINT','Poitiers', 'C1', -120),
   ('K111','VANBIST',  'Lille',    'B3',  148),
   ('S127','VANDERKA', 'Namur',    'C1', -258),
   ('B512','GILLET',   'Toulouse', 'B1', -150),
   ('B062','GOFFIN',   'Namur',    'B2', -120),
   ('C400','FERARD',   'Poitiers', 'C3',  245),
   ('C003','AVRON',    'Toulouse', 'B1',  125),
   ('K729','NEUMAN',   'Toulouse',  null,   0),
   ('F011','PONCELET', 'Toulouse', 'B2',   42),
   ('L422','FRANCK',   'Namur',    'C1',   60),
   ('S705','GUILLAUME','Paris',    'B1',   60),
   ('D063','MERCIER',  'Toulouse',  null, -30),
   ('F400','JACOB',    'Bruxelles','C2',   60),
   ('S022','DEWIT',    'Lille','C3',       75),
   ('K190','BERNARD',  'Paris','C4',       92),
   ('W184','WINSTON',  'Paris','C3',      105),
   ('A910','BERNARD',  'Lausanne','C2',   210);

goto SELECT;

-- ---------------------------------------------------------
label AFFICHER;
-- ---------------------------------------------------------

write-b -- Contenu de la table CLIENT selon diffrents critres d'ordre --;
write   -- ------------------------------------------------------------ --;
write-b -- ORDER BY "NCLI" --;
   select * from CLIENT order by NCLI;
write-b -- ORDER BY "LOCALITE" --;
   select * from CLIENT order by LOCALITE;
write-b -- ORDER BY "CAT" --;
   select * from CLIENT order by CAT;
write-b -- ORDER BY "COMPTE" --;
   select * from CLIENT order by COMPTE;

goto SELECT;

-- ---------------------------------------------------------
label CLASSIQUES;
-- ---------------------------------------------------------

write-b -- Calculer, pour chaque client, la moyenne des comptes de sa localit --;
write   -- de manire  situer ce client par rapport  ses voisins             --; 
select NCLI,LOCALITE,COMPTE,
       round((select avg(COMPTE)
              from   CLIENT 
              where  LOCALITE = CLI.LOCALITE),2) as MOY_LOC
from   CLIENT CLI
order by LOCALITE;

write-b -- Calculer pour chaque client la diffrence entre son compte --;
write   -- et la moyenne des comptes de sa localit                   --;
select NCLI,LOCALITE,COMPTE,
       round((select avg(COMPTE) from CLIENT where LOCALITE = CLI.LOCALITE) - COMPTE,2) as DIFF
from   CLIENT CLI
order by LOCALITE;

write-b -- Afficher, pour chaque localit, le(s) client(s) ayant le compte le plus lev --;
write   -- Deux formules quivalentes.                                                   --;
select LOCALITE,NCLI,NOM,LOCALITE,COMPTE
from   CLIENT
where  (LOCALITE,COMPTE) in (select LOCALITE,max(COMPTE)
                             from   CLIENT
                             group by LOCALITE)

select C.LOCALITE,C.NCLI,C.NOM,C.COMPTE
from   CLIENT C, (select LOCALITE,max(COMPTE) as MCOMPTE
                  from   CLIENT
                  group by LOCALITE) as M
where  (C.LOCALITE,C.COMPTE) = (M.LOCALITE,MCOMPTE)
order by C.LOCALITE,C.COMPTE;

goto SELECT;

-- ---------------------------------------------------------
label FILTER;
-- ---------------------------------------------------------

write-b -- --------------------------------------- --;
write   -- Extensions "FILTER", "ROLLUP" et "CUBE" --;
write   -- --------------------------------------- --;

write-b -- La clause "FILTER" associe  une fonction agrgative --;
write   -- permet de rduire le contenu de chaque groupe aux     --;
write   -- lignes qui satisfont une condition spcifique.        --;
write   -- Ici : comptage des comptes ngatifs,  zro           --;
write   -- et positifs par localit.                             --;
--
select LOCALITE,  
       count(*) filter(where COMPTE < 0) as Negatif,
       count(*) filter(where COMPTE = 0) as Equilibre,
       count(*) filter(where COMPTE > 0) as Positif
from CLIENT
group by LOCALITE

write-b -- La clause "group by rollup(LOCALITE,CAT)"           --;
write   -- gnre en un seul rsultat tous les niveaux         --;
write   -- hirarchiques du critre de groupement.             --;
--
write   -- Cette forme n'tant pas encore disponible en SQLite --;
write   -- on en donne l'quivalent en requte classique.      --;
write   -- Note: 'null's exclus pour viter confusion avec     --;
write   -- l'absence de "CAT" dans le critre                  --;
--
select *
      -- 'null's exclus pour viter confusion avec l'absence de "CAT" dans le critre
from (select LOCALITE,null as CAT,count(*) as Nombre
      from   CLIENT
      where   CAT is not null
      group by LOCALITE
         union
      select LOCALITE,CAT,count(*) as Nombre
      from   CLIENT
      where  CAT is not null
      group by LOCALITE,CAT
         union
      select null as LOCALITE,null as CAT,count(*) as Number
      from   CLIENT
      where  CAT is not null)
order by CAT nulls last,LOCALITE nulls last;

write-b -- La clause "group by cube(LOCALITE,CAT)" gnre en un seul --;
write   -- rsultat les groupements de toutes les combinaisons       --;
write   -- possibles des composants du critre de groupement.        --;
--
write   -- Cette forme n'tant pas encore disponible en SQLite       --;
write   -- on en donne l'quivalent en requte classique.            --;
write   -- Note: 'null's exclus ...                                  --;
--
select *
from (select LOCALITE,null as CAT,count(*) as Nombre
      from   CLIENT
      where   CAT is not null
      group by LOCALITE
         union
      select null as LOCALITE,CAT,count(*) as Nombre
      from   CLIENT
      where   CAT is not null
      group by CAT
         union
      select LOCALITE,CAT,count(*) as Nombre
      from   CLIENT
      where  CAT is not null
      group by LOCALITE,CAT
         union
      select null as LOCALITE,null as CAT,count(*) as Number
      from   CLIENT
      where  CAT is not null)
order by CAT nulls last,LOCALITE nulls last;

goto SELECT;

-- ---------------------------------------------------------
label EXEMPLE;
-- ---------------------------------------------------------

write-b -- ---------------------------------------------- --;
write   -- Fonction "Window" : un premier exemple complet --;
write   -- ---------------------------------------------- --;

write-b -- Calculer pour chaque ligne de chaque localit  --;
write   -- la moyenne de COMPTE des deux lignes voisines  --;
--
write-b @s select NCLI,NOM,LOCALITE,COMPTE,;
write   @s        avg(COMPTE) over (partition by LOCALITE;
write   @s                          order by COMPTE ;
write   @s 	                  rows between 1 preceding;
write   @s 	                       and     1 following;
write   @s 	                  exclude current row) as Moyenne;
write   @s from CLIENT;
write   @s order by LOCALITE,COMPTE;;
write;
--
select NCLI,NOM,LOCALITE,COMPTE,
       avg(COMPTE) over (partition by LOCALITE
                         order by COMPTE 
	                 rows between 1 preceding
	                      and     1 following
	                 exclude current row) as Moyenne
from CLIENT
order by LOCALITE,COMPTE;

goto SELECT;

           -- ======================================== --
           --          {Partitions et ordres}          --
           -- ======================================== --

-- ---------------------------------------------------------
label PARTITIONS;
-- ---------------------------------------------------------

write-b -- -------------------------------- --;
write   -- Les partitions                   --;
write   -- -------------------------------- --;

write-b A dvelopper.

goto SELECT;


-- ---------------------------------------------------------
label ORDRES;
-- ---------------------------------------------------------

write-b -- -------------------------------- --;
write   -- Les ordres                       --;
write   -- -------------------------------- --;

write-b A dvelopper.

goto SELECT;


           -- ======================================== --
           --         {Les fonctions de calcul}        --
           -- ======================================== --


-- ---------------------------------------------------------
label AGREGATIVES;
-- ---------------------------------------------------------

write-b -- -------------------------------- --;
write   -- Les fonctions agrgatives        --;
write   -- -------------------------------- --;

write-b A dvelopper.

goto SELECT;

-- ---------------------------------------------------------
label RANKING;
-- ---------------------------------------------------------

write-b -- -------------------------------- --;
write   -- Les fonctions de "ranking"       --;
write   -- -------------------------------- --;

write-b -- Fonctions calcules sur toute la "slection", ordonne sur COMPTE :   --;
write   -- - row_number : numro de squence de la ligne dans la fentre.        --;
write   -- - rank : Cf. "row_number" mais les lignes d'un groupe ont mme numro --;
write   --     + saut dans la numrotation.                                      --;
write   -- - dense_rank() : cf. "rank" mais pas de saut dans la numrotation.    --; 
write   -- - percent_rank : proportion des *autres lignes* de la fentre dont    --;
write   --     la valeur de COMPTE est strictement infrieure  celle            --;
write   --     de la ligne courante.                                             --;
write   -- - cume_dist : "distribution cumulative". Proportion de lignes de      --;
write   --     la fentre dont la valeur de COMPTE est                           --;
write   --     * infrieure ou gale (ordre ascendant) ou suprieure             --;
write   --     * ou gale (ordre descendant)  celle de la ligne courante.       --;
write   -- - ntile(n) : les lignes tries sont rparties en 'n' sous-squences   --;
write   --     de mme taille. La valeur de la fonction est le numro d'ordre    --;
write   --     cette sous-squence.                                              --;
--
select NCLI,COMPTE,
       row_number() over (order by COMPTE) as "row_number",
       rank()       over (order by COMPTE) as "rank",
       dense_rank() over (order by COMPTE) as "dense_rank",
       round(percent_rank() over (order by COMPTE),2) as "percent_rank",
       round(cume_dist()    over (order by COMPTE),2) as "cume_dist",
       ntile(5)     over (order by COMPTE) as "ntile(5)"
from   CLIENT order by COMPTE;

write-b -- Mmes fonctions calcules pour les partitions selon LOCALITE --;
--
select NCLI,COMPTE,LOCALITE,
       row_number() over (partition by LOCALITE order by COMPTE) as "row_number",
       rank()       over (partition by LOCALITE order by COMPTE) as "rank",
       dense_rank() over (partition by LOCALITE order by COMPTE) as "dense_rank",
       round(percent_rank() over (partition by LOCALITE order by COMPTE),2) as "percent_rank",
       round(cume_dist()    over (partition by LOCALITE order by COMPTE),2) as "cume_dist",
       ntile(5)     over (partition by LOCALITE order by COMPTE) as "Ntile(5)"
from   CLIENT order by LOCALITE,COMPTE;

write-b -- Calcul de "cume_dist" selon les deux ordres 'asc' et 'desc'.             --;
write   -- La distribution cumulative indique la proportion de valeurs de COMPTE,   --;
write   -- et donc de lignes, qui sont <= (DistAsc) et >= (DistDesc)  la           --;
write   -- valeur de COMPTE de la ligne courante.                                   --;
write   -- NOTE. (DistAsc + DistDesc - 1.0) = proportion des lignes de mme valeur  --;
write   --   de COMPTE que la ligne courante.                                       --;
write   --   Exemple : 0.4+0.7-1 = 0.1 indique que 10% des lignes ont une valeur 0. --;
--
select NCLI,LOCALITE,COMPTE,
       cume_dist() over (order by COMPTE asc)  as DistAsc,
       cume_dist() over (order by COMPTE desc) as DistDesc,
       cume_dist() over (order by COMPTE asc) + cume_dist() over (order by COMPTE desc) -1 as "Mme valeur"
from CLIENT
order by COMPTE;

write-b -- Afficher, pour chaque client, le quartile de son COMPTE --;
select NCLI,NOM,LOCALITE,COMPTE,
       ntile(4) over (order by COMPTE) as Quartile
from CLIENT;

goto SELECT;

-- ---------------------------------------------------------
label VALEURS;
-- ---------------------------------------------------------

write-b -- -------------------------------- --;
write   -- Les fonctions de valeurs         --;
write   -- -------------------------------- --;

write-b -- Afficher, pour chaque client, le compte prcdent et la diffrence de COMPTE avec le celui-ci --;
select NCLI,NOM,LOCALITE,COMPTE,
       lag(COMPTE,1) over (partition by LOCALITE order by COMPTE) as Precedent,
       COMPTE - lag(COMPTE,1) over (partition by LOCALITE order by COMPTE) as Increment
from CLIENT;

goto SELECT;


           -- ======================================== --
           --              {Les "frames"}              --
           -- ======================================== --


-- ---------------------------------------------------------
label FRAME;
-- ---------------------------------------------------------

write-b -- -------------------------------- --;
write   -- Les "frames"                     --;
write   -- -------------------------------- --;

write-b A dvelopper.

goto SELECT;


           -- ======================================== --
           --              {Applications}              --
           -- ======================================== --


-- ---------------------------------------------------------
label SOMMES;
-- ---------------------------------------------------------

write-b -- -------------------------------- --;
write   -- Les sommes                       --;
write   -- -------------------------------- --;

write-b A dvelopper.

goto SELECT;


-- ---------------------------------------------------------
label MOYENNES;
-- ---------------------------------------------------------

write-b -- --------------------------------------- --;
write   -- Calcul des moyennes (formes classiques) --;
write   -- --------------------------------------- --;

write-b A rappeler.


write-b -- ------------------------------------- --;
write   -- Calcul des moyennes (fonction Window) --;
write   -- ------------------------------------- --;

write-b -- Idem: associer  chaque client la moyenne de sa localit.       --;
write   -- Ici, la moyenne "MOY_LOC" est calcule sur la "slection" c--d --;
write   -- les lignes de la localit qui satisfont "CAT in ('B1','B2')".   --;
select NCLI,LOCALITE,COMPTE,
       round(avg(COMPTE) over (partition by LOCALITE),2) as MOY_LOC
from   CLIENT
where  CAT in ('B1','B2')
order by LOCALITE,COMPTE;

write-b -- La "slection" est la table entire mais le calcul des moyennes est    --;
write   -- limit aux lignes dont "CAT in ('B1','B2')" grce  la clause "filter" --;
write   -- applique aux lignes de la partition                                   --;  
select NCLI,LOCALITE,COMPTE,
       round(avg(COMPTE) filter (where CAT in ('B1','B2'))
                         over (partition by LOCALITE),2) as MOY_LOC
from   CLIENT
order by LOCALITE,COMPTE;

write-b -- Plusieurs moyennes dans la mme requte --;
write   -- - par LOCALITE                          --;
write   -- - par CAT                               --;
select NCLI,LOCALITE,COMPTE,CAT,
       round(avg(COMPTE) over (partition by LOCALITE),2) as MOY_LOC,
       round(avg(COMPTE) over (partition by CAT),2)      as MOY_CAT
from   CLIENT
order by LOCALITE;

write-b -- Plus complexe : la slection rsulte d'un "group by". --;
write   -- Calculer la population dans chaque localit ainsi que --;
write   -- son pourcentage de la population totale.              --;
select LOCALITE,
       count(*) as Nombre,
       100.0*count(*)/sum(count(*)) over () as "Pourcentage"
from   CLIENT 
group by LOCALITE;

write-b -- Version minimaliste : moyenne de COMPTE calcule sur la "slection" --;
select NCLI,NOM,round(avg(COMPTE) over(),2) as MOY_TOT
from   CLIENT
where  CAT in ('B1','B2');

goto SELECT;


-- ---------------------------------------------------------
label QUANTILES;
-- ---------------------------------------------------------

write-b -- ------------------------------------ --;
write   -- Mode, quartiles et autres quantiles  --;
write   -- ------------------------------------ --;

-- https://www.greelane.com/fr/science-technologie-mathmatiques/math/what-is-a-quantile-3126239/

extract taille = select count(*) from CLIENT;

write-b -- Nombre de clients : $taille$.;
set n = 4;
write-b -- Calcul des quartiles "ntile(4)". 4 groupes de 5 lignes --;
create temp view QUARTILE as
   select NCLI,NOM,COMPTE,
		  ntile($n$) over (order by COMPTE) as N
   from   CLIENT order by N;

select * from QUARTILE;

write-b -- Moyenne de COMPTE des 3 premiers quartiles --;
select N, max(COMPTE) as "Moyenne quartile"
from   QUARTILE
where  N < 4
group by N;

drop view QUARTILE;

write-b -- Calcul de la mdiane (1).                         --;
write   -- on constitue 2 groupes de 10 lignes ("ntile(2)"). --;
select NCLI,NOM,COMPTE,
	   ntile(2) over (order by COMPTE) as N
from   CLIENT order by N;

write-b -- Calcul de la mdiane (2).              --;
write   -- On extrait le maximum du 1er quantile. --;
select 'Mdiane',max(COMPTE) as Mediane
from  (select COMPTE,
	          ntile(2) over (order by COMPTE) as N
	   from CLIENT)
where N = 1;

write-b -- Moyennes par quantile(5). 5 groupes de 4 lignes --;
write   -- et moyenne dans chaque groupe.                  --;
select N,avg(COMPTE)
from (select ntile(5) over (order by COMPTE) as N,
             NCLI,NOM,COMPTE
      from   CLIENT)
group by N
order by N;

write-b -- Moyennes par quantile(10). 10 groupes de 2 lignes --;
write   -- et moyenne dans chaque groupe.                  --;
select N,avg(COMPTE)
from (select ntile(10) over (order by COMPTE) as N,
             NCLI,NOM,COMPTE
      from   CLIENT)
group by N
order by N;

write-b -- Moyennes par quantile(10). 10 groupes de 2 lignes --;
write   -- Elimination des quantiles extrmes (10) --;
select N,avg(COMPTE)
from (select ntile(10) over (order by COMPTE) as N,
             NCLI,NOM,COMPTE
      from   CLIENT)
group by N
having N between 2 and 10-1
order by N;

write-b -- Identification des valeurs anormales (1) --;
write   -- Moyenne du quantile (10)                 --;
select N,NCLI,NOM,COMPTE,
       avg(COMPTE) over (partition by N) as MOY
from  (select ntile(10) over (order by COMPTE) as N,NCLI,NOM,COMPTE from CLIENT);

write-b -- Identification des valeurs anormales (2)    --;
write   -- Rapport entre COMPTE et moyenne du quantile --;
select N,NCLI,NOM,COMPTE,
       avg(COMPTE) over (partition by N) as MOY,
       round(coalesce(COMPTE/avg(COMPTE) over (partition by N),1),2) as RAPPORT
from  (select ntile(10) over (order by COMPTE) as N,NCLI,NOM,COMPTE from CLIENT);

write-b -- Rduction d'une distribution par plage --;
write-b -- On dfinit des plages de 2 lignes --;
select COMPTE,ntile(10) over (order by COMPTE) as Plage 
from   CLIENT 
order by COMPTE;

write-b -- On calcule les extrmes et la somme par plage --;
select Plage,min(COMPTE) as Minimum, max(COMPTE) as Maximum, sum(COMPTE) as Valeur
from  (select COMPTE,ntile(10) over (order by COMPTE) as Plage 
       from   CLIENT)
group by Plage
order by Plage;

goto SELECT;

-- ---------------------------------------------------------
label CENTRALES;
-- ---------------------------------------------------------

write-b -- --------------------------------------------- --;
write   -- Mesure des valeurs centrales et de dispersion --;
write   -- --------------------------------------------- --;

write-b -- 1. Mesure des valeurs centrales --;
write-b -- 1.1 Moyenne;
select avg(COMPTE) as Moyenne from CLIENT;

write-b -- 1.2 Mdiane;

write-b -- Calcul de la mdiane (nombre pair de lignes);
write   -- Ligne ('ABC','','',null,-350) ajoute.         --;
write   -- Ligne ('XYZ','','',null,-300) ajoute.         --;
insert into CLIENT values ('ABC','','',null,-300);
insert into CLIENT values ('XYZ','','',null,-350);
select row_number() over(order by COMPTE) as RN,* from CLIENT order by COMPTE;
select avg(COMPTE) as Mediane,group_concat(RN)  as Rows
from  (select COMPTE,
              row_number() over (order by COMPTE) as RN, 
			  count(*) over () as N
	   from CLIENT)
where  case when N%2 then RN = N/2 + 1
            else RN between N/2 and N/2 + 1
	   end;
delete from CLIENT where NCLI in ('ABC','XYZ');

write-b -- Calcul de la mdiane (nombre impair de lignes) --;
write   -- Ligne ('ABC','','',null,-300) ajoute.         --;
insert into CLIENT values ('XYZ','','',null,-350);
select row_number() over(order by COMPTE) as RN,* from CLIENT order by COMPTE;
select avg(COMPTE) as Mediane,group_concat(RN)  as Rows
from  (select COMPTE,
              row_number() over (order by COMPTE) as RN, 
			  count(*) over () as N
	   from CLIENT)
where  case N%2 when 1 then RN = N/2 + 1
                when 0 then RN between N/2 and N/2 + 1
	   end;
delete from CLIENT where NCLI = 'XYZ';


write-b -- 1.3 Mode et modes multiples --;

select COMPTE, count(*) as Population
from   CLIENT
group by COMPTE
order by Population desc;

select LOCALITE, count(*) as Population
from   CLIENT
group by LOCALITE
order by Population desc;

select CAT, count(*) as Population
from   CLIENT
group by CAT
order by Population desc;

write-b -- 2. Mesures de la dispersion;
write   -- 2.1 Etendue;
write   -- 2.2 Ecart interquartile;
write   -- 2.3 Variance;
write   -- 2.4 Ecart-type;

write-b A dvelopper.

goto SELECT;


-- ---------------------------------------------------------
label CLEAR;
-- ---------------------------------------------------------

outputOpen window;
goto SELECT;

stop;

