-- ----------------------------------- --
-- Bases de donnes Blockchain         --
-- ----------------------------------- --

closeDB;

createOrReplaceDB BLOCKCHAIN.db;

create table COMPTE(
   AdresseCPT  varchar(48)   not null primary key,
   NomPrive    varchar(48)   not null,
   CleSecrete  varchar(360)  not null unique,
   DateEnreg   datetime      not null);

create table REPERTOIRE(
   AdresseCPT  varchar(48)   not null unique,
   ClePublique varchar(1400) not null,
   Mineur      integer       not null default 0);

create table BTRANSACTION(
   CleTrans    integer      not null primary key autoincrement,
   IDTrans     varchar(72)  not null unique,
   IDBloc      varchar(64)  references BLOC(IDBloc),
   Operation   char(12)     not null,
   Source      varchar(48),
   Destin      varchar(48),
   Montant     decimal(16,10),
   DateEnreg   datetime     not null,
   Signature   varchar(512) not null);

create table BLOC(
   CleBloc     integer      not null primary key autoincrement,
   IDBloc      varchar(48)  not null unique,
   Transact    integer      not null,
   Nonce       varchar(32),
   DateEnreg   datetime     not null,
   Statut      char(1)      not null default 0,
   BlocPrec    varchar(48) references BLOC(IDBloc));

closeDB;

write-b Base de donnes BLOCK_CHAIN.db cre.;
