-- ---------------------------- --
-- Examiner les transactions    --
-- ---------------------------- --

openDB BLOCKCHAIN.db;

write-b Transactions;
select Source,Operation,Montant,Destinataire,DateCreation,InBloc
from (
   select S.NomPrive as Source,Operation,null as Montant,null as Destinataire,
          T.DateEnreg as DateCreation,case when IDBloc is null then null else 'oui' end as InBloc
   from   COMPTE S, BTRANSACTION T
   where  T.Source = S.AdresseCPT
   and    Operation = 'REGISTER'
      union all
   select null as Source,Operation,Montant,M.NomPrive as Destinataire,
          T.DateEnreg as DateCreation,case when IDBloc is null then null else 'oui' end as InBloc
   from   BTRANSACTION T, COMPTE as M
   where  T.Destin = M.AdresseCPT
   and    Operation = 'DEPOSIT'
      union all
   select S.NomPrive as Source,Operation,Montant,R.NomPrive as Destinataire,
          T.DateEnreg as DateCreation,case when IDBloc is null then null else 'oui' end as InBloc
   from   COMPTE S, BTRANSACTION T, COMPTE R
   where  T.Source = S.AdresseCPT
   and    T.Destin  = R.AdresseCPT
   and    Operation = 'TRANSFER'
      )
order by DateCreation;

write-b Solde des comptes;
select Compte, sum(plusD) as "Dpt",
               sum(plusT) as "Reu",
              -sum(minus) as "Transfr",
       sum(plusD) + sum(plusT) - sum(minus) as Solde
from (
   select M.NomPrive as Compte,Montant as plusD,0 as plusT,0 as minus
   from   BTRANSACTION T, COMPTE M
   where  T.Destin = M.AdresseCPT
   and    Operation = 'DEPOSIT'
      union all
   select M.NomPrive as Compte,0 as plusD,Montant as plusT,0 as minus
   from   BTRANSACTION T, COMPTE M
   where  T.Destin = M.AdresseCPT
   and    Operation = 'TRANSFER'
      union all
   select M.NomPrive as Compte,0 as plusD,0 as plusT,Montant as minus
   from   BTRANSACTION T, COMPTE M
   where  T.Source = M.AdresseCPT
   and    Operation = 'TRANSFER'   
      )
group by Compte;
write;

closeDB;
