-- ---------------------- --
-- Executer un transfert  --
-- ---------------------- --

openDB BLOCKCHAIN.db;

extract NC = select count(*) from COMPTE;
if ($NC$ = 0);
   showMessage Aucun compte n'a encore t cr.@nOpration annule.;
   goto END;
endif;

ask compte,destin,montant = [/bIntroduire les donnes du transfert]
          Votre nom:[!select NomPrive,AdresseCPT from COMPTE order by NomPrive]
         |Destinataire:[!select NomPrive,AdresseCPT from COMPTE order by NomPrive]
         |Montant:;
if ('$DIALOGbutton$' = 'Cancel') goto END;

if ('$compte$' = '' or '$destin$' = '' or '$montant$' = '' or isNotNumeric('$montant$'));
   showMessage Donnes incorrectes;
   goto END;
endif;

if ($montant$ <= 0);
   showMessage Montant incorrect;
   goto END;
endif;

if ('$compte$' = '$destin$');
   showMessage Vous ne pouvez vous transfrer  vous-mme !;
   goto END;
endif;

extract cleSecrete = select CleSecrete from COMPTE where AdresseCPT = '$compte$';

set dateEnreg = $dateclock$;
set idTrans   = $compte$-$date$_$clock$;
set operation = TRANSFER;

function signature = LStr:encryptRSA {$idTrans$;$operation$;$compte$;$destin$;$montant$;$dateEnreg$},
                                     {$cleSecrete$};

extract plusD = select coalesce(sum(Montant),0) from BTRANSACTION
                where  operation = 'DEPOSIT' and Destin = '$compte$';
extract plusT = select coalesce(sum(Montant),0) from BTRANSACTION
                where  operation = 'TRANSFER' and Destin = '$compte$';
extract minus = select coalesce(sum(Montant),0) from BTRANSACTION
                where  operation = 'TRANSFER' and Source = '$compte$';
compute solde = $plusD$ + $plusT$ - $minus$;

if ($solde$ < $montant$);
   showMessage Solde insuffisant.@nOperation annule.;
   goto END;
endif;

insert into BTRANSACTION (IDTrans,Operation,Source,Destin,Montant,DateEnreg,Signature)
       values ('$idTrans$','$operation$','$compte$','$destin$',$montant$,'$dateEnreg$','$signature$');
commitDB;

if ($showData$) execSQL $path$/_BC_Contenu_tables.sql;

label END;

closeDB;

return;
