-- ---------------------------------------------------------------------------- --
-- Evaluation d'un rgime                                                       --
-- ---------------------------------------------------------------------------- --

openDB ZOO.db;

set nani,dat = ,;

-- Slectionner un regime = animal + date. Si n'existe pas, recommencer --
-- -------------------------------------------------------------------- --
set buttonYES,buttonNO = Valider,Annuler;
while (True);
   ask-u nani,dat = [/bSlectionner le rgime d'un animal]
                     Animal:[!select R.NOM_ANIMAL||' ('||NOM_ESPECE||')',
                                     R.NOM_ANIMAL
                             from   REGIME R, ANIMAL A
                             where  A.NOM_ANIMAL = R.NOM_ANIMAL
                             order by R.NOM_ANIMAL]
                    |Date:[select DATE_REGIME from REGIME order by DATE_REGIME];
   if ('$DIALOGbutton$' = 'Annuler') return;
   extract exists = select count(*) from REGIME
                    where  NOM_ANIMAL = '$nani$' and DATE_REGIME = '$dat$';
   if ($exists$) exit;
   showMessage Il n'y a pas de rgime pour cet animal  cette date;
endwhile;


-- NORME_ANIMAL : Besoins normaux de chaque animal  --
create temp view if not exists NORME_ANIMAL(NomEspece,NomAnimal,NomNutriment,Min,Max) as
    select A.NOM_ESPECE,A.NOM_ANIMAL,B.NOM_NUTRIMENT,B.MIN*A.POIDS,B.MAX*A.POIDS
    from   ANIMAL A, BESOINS B
    where  A.NOM_ESPECE = B.NOM_ESPECE;

-- BILAN_REGIME : bilan en nutriments de chaque regime --
create temp view if not exists BILAN_REGIME(NomAnimal,DateRegime,NomNutriment,Effectif) as
    select C.NOM_ANIMAL,C.DATE_REGIME,T.NOM_NUTRIMENT,sum(C.QUANTITE*T.QUANTITE)
    from   COMPOSITION C, INGREDIENT I, TENEUR T
    where  C.NOM_INGREDIENT = I.NOM_INGREDIENT
    and    I.NOM_INGREDIENT = T.NOM_INGREDIENT
    group by C.NOM_ANIMAL,C.DATE_REGIME,T.NOM_NUTRIMENT;

write-b -- Donnes de rfrence de "$nani$" --;
select NomNutriment,Min,Max 
from   NORME_ANIMAL
where  NomAnimal = '$nani$'
order by NomNutriment;

write-b -- Contenu effectif du rgime de "$nani$" le "$dat$" --;
select NomNutriment as "Nutriment",Effectif as "Effectif"
from   BILAN_REGIME
where  NomAnimal = '$nani$'
and    DateRegime = '$dat$'
order by NomNutriment;

write-b -- Evaluation du rgime de "$nani$" le "$dat$" --;
select NA.NomNutriment as "Nutriment",
       NA.Min as "Minimum",BR.Effectif as "Effectif",NA.Max as "Maximum",
       case when BR.Effectif <= NA.Min then 'Dficit'
            when BR.Effectif >= NA.Max then 'Dpassement'
            else 'OK'
       end as Evaluation
from   NORME_ANIMAL NA, BILAN_REGIME BR
where  NA.NomAnimal = BR.NomAnimal
and    NA.NomNutriment = BR.NomNutriment
and    NA.NomAnimal = '$nani$'
and    BR.DateRegime = '$dat$'

