
-- Insert the CUSTORDER row --
-- ------------------------ --

insert into CUSTORDER(OrdID,DateOrd,CustID,ItemID,Qty,State)
       values ($oid$,'$dat$','$cus$','$itm$',$qty$,'');
if ('$SQLdiag$' <> 'OK');
   set success = 0;
   return;
else;
   set success = 1;
endif;


-- A customer order has been created successfully --
-- ---------------------------------------------- --

extract pri,qoh,qav,qeco = select Price,QonHand,Qavail,Qeco
                           from   ITEM where ItemID = '$itm$';
extract inv = select coalesce(max(InvID),0)+1 from CUSTINVOICE;

if ($qty$ <= $qoh$);
   -- ---------------------------------------------- --
   -- "Quantity on hand" is sufficient               --
   -- ---------------------------------------------- --

   -- Adjust ITEM quantities --;
   update ITEM
   set   QonHand = QonHand - $qty$,
         Qavail  = Qavail - $qty$
   where ItemID = '$itm$';

   -- Update customer order --;
   update CUSTORDER
   set    Price = $pri$,
          State = 'invoiced'
   where  OrdID = $oid$;

  -- Create an invoice (sent): --;
   insert into CUSTINVOICE(InvID,DateInv,OrdID,CustID,ItemID,Price,Qty,Amount,State)
          values ($inv$,'$dat$',$oid$,'$cus$','$itm$',$pri$,$qty$,$pri$*$qty$,'sent');

   -- Send invoice --;
   execSQL $dir$/_RETAIL-Send-Invoice.sql;

   -- Update Account of CUSTOMER --;
   update CUSTOMER
   set    Account = Account - $pri$*$qty$
   where  CustID = '$cus$';

else;
   -- ---------------------------------------------- --
   -- "Quantity on hand" is NOT sufficient           --
   -- ---------------------------------------------- --
   if ($qty$ <= $qav$);
      -- ---------------------------------------------- --
      -- "Quantity available" is sufficient             --
      -- ---------------------------------------------- --

      -- Adjust item quantities:
      update ITEM
      set   QonHand = QonHand - $qty$,
            Qavail  = Qavail - $qty$
      where ItemID = '$itm$';

   else;
      -- ---------------------------------------------- --
      -- "Quantity available" is NOT sufficient         --
      -- ---------------------------------------------- --

      -- mQeco = smallest multiple of Qeco such that new Qavail becomes positive --
      -- (precondition: qty > qav)
      compute mQeco = $qeco$ * (truncate(1.*($qty$ - $qav$)/$qeco$) + 1);

      -- Adjust item quantities (with supplier order):
      update ITEM
      set   QonHand = QonHand - $qty$,
            Qord    = Qord + $mQeco$,
            Qavail  = Qavail - $qty$ + $mQeco$
      where ItemID = '$itm$';

      -- Identify best offer if not selected yet:
      update ITEM
      set   (SuppID,SuppPrice) = (select SuppID,Price from OFFER
                                  where  ItemID = '$itm$'
                                  order by Price,Delay limit 1)
      where ItemID = '$itm$'
      and   SuppID is null;

      extract sup,spri = select SuppID,SuppPrice from ITEM
                         where  ItemID = '$itm$';

      -- Create a supplier order
      extract sord = select coalesce(max(OrdID),0) + 1 from SUPPORDER;
      -- write Check: ($sord$, '$dat$', '$itm$', '$sup$', $spri$, $mQeco$, 'assigned');
      insert into SUPPORDER(OrdID,DateOrd,ItemID,SuppID,Price,Qty,State)
             values ($sord$,'$dat$','$itm$','$sup$',$spri$,$mQeco$,'assigned');
   endif;

   -- ---------------------------------------------- --
   -- In both cases                                  --
   -- ---------------------------------------------- --

   -- Update customer order:
   update CUSTORDER
   set    Price = $pri$,
          State = 'pending'
   where  OrdID = $oid$;

   -- Create a pending invoice:
   insert into CUSTINVOICE(InvID,DateInv,OrdID,CustID,ItemID,Price,Qty,Amount,State)
          values ($inv$,'$dat$',$oid$,'$cus$','$itm$',$pri$,$qty$,$pri$*$qty$,'pending');

endif;
return;
