
-- Reinitialize quantities of replenished item
update ITEM
set  QonHand = QonHand + (select sum(Qty)
                          from   SUPPORDER 
                          where  ItemID = '$itm$' and SuppID = '$sup$'),
     Qord = 0
where ItemID = '$itm$';

-- Re-evaluate the best offer
update ITEM
set   (SuppID,SuppPrice) = (select SuppID,Price from OFFER
                            where  ItemID = '$itm$'
                            order by Price,Delay limit 1)
where ItemID = '$itm$';

-- Close supplier orders
update SUPPORDER
set   State = 'closed'
where SuppID = '$sup$' and ItemID = '$itm$' and State = 'assigned';

-- Update the state of pending customer orders
update CUSTORDER
set   State = 'invoiced'
where ItemID = '$itm$'
and   State = 'pending';

-- For each customer invoice, 
--   update customer account
--   send invoice.
for inv,cus,amt,dat,qty,pri = [select InvID,CustID,Amount,DateInv,Qty,Price
                               from CUSTINVOICE
                               where  ItemID = '$itm$' and State = 'pending'];
   update CUSTOMER
   set    Account = Account - $amt$
   where  CustID = '$cus$';

   execSQL $dir$/_RETAIL-Send-Invoice.sql;
endfor;

-- Update state of pending customer invoices
update CUSTINVOICE
set   State = 'sent'
where ItemID = '$itm$'
and   State = 'pending';

return;
