write-b -- ------------------------------- --;
write   -- Active databases                --;
write   -- Alerters                        --;
write-a -- ------------------------------- --;


-- Values for UNamur server:
ask host,login,pw = [Initialize mail parameters]
                     Host:|Login:|Pw:;
if ('$DIALOGbutton$' = '$buttonNO$') return;

set from = alert@SQLfast.applications;
set to   = jean-luc.hainaut@unamur.be;
set subj1 = Replenishment required;
set subj2 = Replenishment executed;

set ; = ;;

createDB InMemory;

create table STOCK(
       ProdID   char(4) not null primary key,
       QonHand  integer not null,
       QSupply  integer not null);

create trigger TRG_STOCK_ALERT
after update of QonHand on STOCK
for each row
begin
  -- When quantity on hand drops below resupply quantity --
  select sendMail('$host$','$login$','$pw$',
                  '$from$','$to$','',
                  'html','subj1',
                  'Quantity on hand of item <b>#'
                ||old.ProdID
                ||'</b><br>has dropped from <b>'
                ||cast(old.QonHand as char)||'</b> to <b>'
                ||cast(new.QonHand as char)
                ||'</b><br>on '
                ||datetime(current_timestamp,'localtime'),'')
  where  old.QonHand >= new.QSupply and new.QonHand < new.QSupply $;$
  --
  -- When quantity on hand increases --
  select sendMail('$host$','$login$','$pw$',
                  '$from$','$to$','',
                  'html','subj2',
                  'Quantity on hand of item <b>#'
                ||old.ProdID
                ||'</b><br>has increased from <b>'
                ||cast(old.QonHand as char)||'</b> to <b>'
                ||cast(new.QonHand as char)
                ||'</b><br>on '
                ||datetime(current_timestamp,'localtime'),'')
  where  new.QonHand > old.QonHand $;$
end;

write-b -- Initialize STOCK --;
insert into STOCK values ('P001',50,20),
                         ('P002',40,10),
                         ('P003',90,40);

select * from STOCK;

write-b -- Consume products --;
update STOCK set QonHand = QonHand - 35 where ProdID = 'P001';
update STOCK set QonHand = QonHand - 25 where ProdID = 'P002';
update STOCK set QonHand = QonHand - 60 where ProdID = 'P003';

select * from STOCK;

write-b -- Replenish STOCK --;
update STOCK set QonHand = QonHand + 20 where ProdID = 'P001';
update STOCK set QonHand = QonHand + 20 where ProdID = 'P002';
update STOCK set QonHand = QonHand + 20 where ProdID = 'P003';
update STOCK set QonHand = QonHand + 20 where ProdID = 'P003';

select * from STOCK;

commitDB;

closeDB;

write-ab End of script;
return;