-- ------------------ --
-- Create an account  --
-- ------------------ --

openDB BLOCK_CHAIN.db;

-- Get the private name --
ask prName = [/bEnter your private name@n(will be used for experimentation only)] Private name:;
if ('$DIALOGbutton$' = 'Cancel' or '$pname$' = '') goto END;

start-timer;

-- Generate RSA keys "secretKey" and "publicKey" (stripped PEM format) --
function secretKey,publicKey = LStr:generateRSAkeys 1700;

-- Compute AccountID (hash of public key) + transaction data
function accountID = LStr:hash {$publicKey$},2;
set      recTime   = $dateclock$;
set      transID   = $accountID$-$date$_$clock$;
set      operation = REGISTER;
function signature = LStr:encryptRSA {$transID$;$operation$;$accountID$;$recTime$},{$secretKey$};

-- insert data into ACCOUNT, DIRECTORY, BTRANSACTION
insert into ACCOUNT (AccountID,PrivName,SecretKey,RecTime)
       values ('$accountID$','prName','$secretKey$','$recTime$');
insert into DIRECTORY (AccountID,PublicKey)
       values ('$accountID$','$publicKey$');
insert into BTRANSACTION (TransID,Operation,Source,RecTime,Signature)
       values ('$transID$','$operation$','$accountID$','$recTime$','$signature$');

commitDB;

write-b Account created in $timer$ s.;

if ($showData$) execSQL $path$/_BC_Display_tables.sql;

label END;

closeDB;

return;


