-- ----------------------- --
-- Examine blockchain      --
-- ----------------------- --

openDB BLOCK_CHAIN.db;

execSQL UTIL-SELECT-parameters-standard-1.sql;

for bId,hash,NT,nonce,recTime,status,prev
           = [select BlockKey,Bhash,Transact,Nonce,RecTime,Status,
                     case when Bprev is null then '--' else Bprev end
              from   BLOCK order by RecTime desc];
   write-b Block n $bId$;
   write @S4Block hash:    $hash$;
   write @S4Nbr transact:  $NT$;
   write @S4Nonce:         $nonce$;
   write @S4Record Time:   $recTime$;
   write @S4Status:        $status$;
   write @S4Hash previous: $prev$;

   set bar11 = @S4+-;
   set head1 = @S4| ;
   set bar21 = @S4+-;
   set data1 = @S4| ;
   set bar31 = @S4+-;

   select Source,Operation,Amount,Recipient,TimeCreated
   from (
      select S.PrivName as Source,Operation,null as Amount,null as Recipient,
             T.RecTime as TimeCreated
      from   ACCOUNT S, BTRANSACTION T
      where  T.Source = S.AccountID
      and    T.Bhash = '$hash$'
      and    operation = 'REGISTER'
         union all
      select null as Source,Operation,Amount,M.PrivName as Recipient,
             T.RecTime as TimeCreated
      from   BTRANSACTION T, ACCOUNT as M
      where  T.Recip = M.AccountID
      and    T.Bhash = '$hash$'
      and    operation = 'DEPOSIT'
         union all
      select S.PrivName as Source,Operation,Amount,R.PrivName as Recipient,
             T.RecTime as TimeCreated
      from   ACCOUNT S, BTRANSACTION T, ACCOUNT R
      where  T.Source = S.AccountID
      and    T.Recip  = R.AccountID
      and    T.Bhash  = '$hash$'
      and    operation = 'TRANSFER'
         )
   order by TimeCreated;

endfor;

write-b Pending transactions (not yet in block);
select Source,Operation,Amount,Recipient,TimeCreated
from (
   select S.PrivName as Source,operation,null as Amount,null as Recipient,
          T.RecTime as TimeCreated
   from   ACCOUNT S, BTRANSACTION T
   where  T.Source = S.AccountID
   and    T.Bhash is null
   and    operation = 'REGISTER'
      union all
   select null as Source,operation,Amount,M.PrivName as Recipient,
          T.RecTime as TimeCreated
   from   BTRANSACTION T, ACCOUNT as M
   where  T.Recip = M.AccountID
   and    T.Bhash is null
   and    operation = 'DEPOSIT'
      union all
   select S.PrivName as Source,operation,Amount,R.PrivName as Recipient,
          T.RecTime as TimeCreated
   from   ACCOUNT S, BTRANSACTION T, ACCOUNT R
   where  T.Source = S.AccountID
   and    T.Recip  = R.AccountID
   and    T.Bhash is null
   and    operation = 'TRANSFER'
      )
order by TimeCreated;

write;

closeDB;

execSQL UTIL-SELECT-parameters-standard-1.sql;

