-- ----------------------------------------- --
-- Create or replace DIRECTORY database      -- 
-- ----------------------------------------- --

if (fileExists('dbDirectory/DIRECTORY.db'));
   showMessage Database DIRECTORY.db already exists.@nDo you want to replace it?;
   if ('$DIALOGbutton$' = 'Cancel') return;
endif;

deleteDB DIRECTORY.db;

createDB DIRECTORY.db;

create table DIRECTORY(
       DirID      integer not null primary key autoincrement,
       DirName    varchar(1024) not null,
       DirNick    varchar(1024) not null unique);

create table INSTANCE(
       InstID     integer not null primary key autoincrement,
       DirID      integer not null references DIRECTORY on delete cascade,
       InstDate   date not null,
       InstTime   time not null,
       unique (DirID,InstDate,InstTime));
 
create table NODE(
       NodeID     integer not null primary key autoincrement,
       InstID     integer not null references INSTANCE on delete cascade,
       NType      char(1) not null,
       ParentID   integer references NODE on delete set null,
       FullName   varchar(2048),
       Prefix     varchar(2048),
       LocalName  varchar(256),
       Extension  varchar(32),
       Size       integer,
       LastUpdate char(19),
       LastAccess char(19),
       Path       varchar(2048),
       Level      integer,
       Hash       char(64));

create index ndxFullName on NODE(InstID,FullName);
create index ndxParentID on NODE(ParentID);

commitDB;
closeDB;
  
return;
