-- -------------------------------------- --
-- Describe duplicates within an instance --
-- -------------------------------------- --

if (not fileExists('dbDirectory/DIRECTORY.db'));
   showMessage Database "DIRECTORY.db" not found;
   return;
endif;

openDB DIRECTORY.db;

set inst, mul = , 2;
ask-u inst,mul = Instance:[!$listInstances$] | Min multiplicity:;
if ('$DIALOGbutton$' = 'Cancel' or '$inst$' = '') goto EXIT;

extract iName = $instName$;
write-ab -- Duplicate files and directories in directory instance "$iName$" --;

set curDispNull = $dispNull$;
set dispNull = ;

select
       "Node name" as "This node",
       Source as "appears in ...",
       Size,
       LastUpdate as "Last update"
from
   (select distinct
           case when NType = 'F'
                then LocalName
                else '['||LocalName||']'
           end as "Node name",
           '' as Source,
           '' as Size,
           '' as LastUpdate,
           LocalName||'A' as Sort
    from   NODE 
    where  InstID = $inst$
    and    LocalName in (select LocalName from NODE
                         where  InstID = $inst$
                         group by LocalName
                         having count(*) >= $mul$)
        union
    select
           '' as "Node name",
           Prefix as Source,
           frame(thousandSep(Size,' '),13,'>',' ') as "Size",
           LastUpdate,
           LocalName||'B' as Sort
    from   NODE 
    where  InstID = $inst$
    and    LocalName in (select LocalName from NODE
                         where  InstID = $inst$
                         group by LocalName
                         having count(*) >= $mul$)
   )
order by Sort; 

set DispNull = $curDispNull$;

label EXIT;
   closeDB;

return;