-- -------------------------------------- --
-- Identify duplicates within an instance --
-- -------------------------------------- --

if (not fileExists('dbDirectory/DIRECTORY.db'));
   showMessage Database "DIRECTORY.db" not found;
   return;
endif;

openDB DIRECTORY.db;

set inst, mul =  , 2;
ask-u inst,mul = Instance:[!$listInstances$] | Min multiplicity:;
if ('$DIALOGbutton$' = 'Cancel' or '$inst$' = '') goto EXIT;

extract iName = $instName$;
write-ab -- List of duplicates in Directory instance "$iName$" --;

select case when NType = 'F'
            then LocalName
            else '['||LocalName||']'
       end as Nodes, 
       count(*) as Nbr
from NODE where InstID = $inst$
group by Nodes 
having Nbr >= $mul$
order by Nbr desc, Nodes;

label EXIT;
   closeDB;

return;