-- --------------------------------------------  --
-- Identify clone candidates among two instances --
-- --------------------------------------------  --

if (not fileExists('dbDirectory/DIRECTORY.db'));
   showMessage Database "DIRECTORY.db" not found;
   return;
endif;

openDB DIRECTORY.db;

set inst = ;
ask inst1,inst2 = Instance 1:[!$listInstances$]
                 |Instance 2:[!$listInstances$];
if ('$DIALOGbutton$' = 'Cancel' or '$inst1$' = '' or '$inst2$' = '')
   goto EXIT;

set inst = $inst1$;
extract iName1 = $instName$;
set inst = $inst2$;
extract iName2 = $instName$;
write-b -- List of clone files among Directory instances:;
write   --           <1> "$iName1$";
write-a --       and <2> "$iName2$";

select Hash as "Group",LocalName as Clone, Prefix as Source
from (select $hashDigest$ as "Hash",
             '' as LocalName,'' as Prefix,
             Hash||'C0' as Sort
      from   NODE
      where  Hash in ($cloneHash2$)
         union 
      select '' as "Hash",
             LocalName,'<1>'||Prefix as Prefix,
             Hash||'F1' as Sort
      from   NODE
      where  Hash in ($cloneHash2$) and InstID = $inst1$
         union 
      select '' as "Hash",
             LocalName,'<2>'||Prefix as Prefix,
             Hash||'F2' as Sort
      from   NODE
      where  Hash in ($cloneHash2$) and InstID = $inst2$)
order by Sort;

label EXIT;
   closeDB;

return;
