createOrReplaceDB GAMEBOOK.db;

create table EPISODE(
   EPID integer not null primary key,
   TEXT varchar(4096)
   );

create table BRANCH(
   EPID   integer not null,
   SEQNBR integer not null,
   PROMPT varchar(256),
   TARGET integer not null,
   primary key (EPID,SEQNBR)
   );


-- SECTION 1
-- ---------
insert into EPISODE values (1,'It is a truth of every Ranger''s life that theirs'' must be a solitary existence. For the long years of their duty they hunt the creatures that would do harm in the realms of Men, and in that service have proven both ruthless and determined. You are a Ranger of the Watch, a warrior and protector, and one that has learned the value of patience. For two nights you have waited in the undergrowth surrounding the tower, watching as shadowed figures moved purposefully to and from the abandoned structure. You could have taken any one of them alone, but to have them all within the confines of the Tower will ensure that none can escape your sword. In the twilight of the third evening you believe you have them all accounted for, and decide that it is time to begin.
\n\nWith the suns of Arborell setting against the horizon you move forward, taking to the tower''s broken entranceway and silently moving into an open area on the ground floor. In the half-shadows of evening you can see well enough to make out that you have entered a large open space, one that would have served as a common area for the soldiers that once manned the tower. To the west there is an archway leading to a Kitchen, to the east a chamber that would have served as an Armoury, and to the north a Laundry annexe. In the north-west corner is a stairway rising to the First Level above, and upon the floor in the north-east quarter you see what appears to be a trapdoor. The floor itself is covered in a thick layer of dust upon which you can discern a host of bootprints and drag marks. There can be no doubt that the tower is indeed the centre of an enterprise its inhabitants have taken considerable trouble to keep secret.
\n\nOutside the remains of the day flee westwards and with their passing a chill wind grows, blustering from the north and whistling around the old tower. In the distance you can hear the low rumble of thunder and you have no doubt that a storm is on the march. It is cold, it is dark, and without hesitation you begin your mission.');

insert into BRANCH values (1,1,'You would investigate the Armoury to the east first',28);
insert into BRANCH values (1,2,'The Kitchen seems a good place to start',18);
insert into BRANCH values (1,3,'You would rather head north and search the Laundry',21);
insert into BRANCH values (1,4,'You would take a closer look at the bootprints',9);
insert into BRANCH values (1,5,'You are curious about the trapdoor to the north-east',14);
insert into BRANCH values (1,6,'You would rather leave this floor and take to the stairs in the north-west corner',30);


-- SECTION 2
-- ---------
insert into EPISODE values (2,'Surveying the First Floor from the stairs you see evidence of a long occupation here. The Hordim have used the tower as a base of operations and it is an incursion that must be brought to an end. Outside a peal of thunder crashes against the stone walls about you and in its rolling aftermath you see a form rise from one of the sleeping alcoves. Immediately the Hresh sees you and starts to cry out, but its attempt at raising an alarm is smothered by another shuddering roll of thunder. Before the creature can fill its lungs with air again you charge it down, crashing into its side and splaying it bodily upon the floor. The warrior does not remain still. In one swift movement the Hresh regains its feet and attacks.
\n\nClothed in a loose-fitting uniform and wielding a scimitar the Hordim closes upon you. The Hresh Warrior has a combat value of 14 and an endurance of 10. If you win this combat continue with your mission. If not, it will be here that your adventure will end.');

insert into BRANCH values (2,1,'You loose this combat',0);
insert into BRANCH values (2,2,'You win and you conduct a general search of the level',24);
insert into BRANCH values (2,3,'You win and you search a large alcove you have noticed in the south-east corner of the level',27);
insert into BRANCH values (2,4,'You win and you choose one of the sleeping alcoves and search it for further evidence of the Hordims'' purpose here',25);
insert into BRANCH values (2,5,'You win and you use the stairway in the south-western corner to ascend to the Second Level of this watchtower',12);


-- SECTION 2a (201)
-- ---------------
insert into EPISODE values (201,'From behind the central stairway there arises a blur of shadow, one that rushes towards you, a glint of metal in the darkness the only hint of its intent. The shadow is a Hresh Warrior and as it closes you prepare yourself for the violence to come.
\n\nThe Hresh Warrior has a combat value of 15 and an endurance of 10. If you win this combat continue with your mission. If not, it will be here that your adventure will end.');

insert into BRANCH values (201,1,'You loose the combat',0);
insert into BRANCH values (201,2,'You have not yet done so and would begin a general search of the Observation Level',22);
insert into BRANCH values (201,3,'You would make directly for the row of beds against the northern wall',20);
insert into BRANCH values (201,4,'There is good cause to make for the stairway to the battlements above',17);
insert into BRANCH values (201,5,'You look at the articles resting upon the table in the south-western corner of the level',15);


-- SECTION 2b (202)
-- ---------------
insert into EPISODE values (202,'The battlements are old and neglected, and in the dark you can see little except the dark forms of ballista mountings in each corner. These old stone mounts are each enclosed within a protective stone wall and anything might be hidden within them. Carefully you move towards the first of the emplacements but are brought to a halt by the sounds of something running up the central staircase. As a dark shadow a warrior rushes onto the battlement and calls out to someone else you have not yet seen. Only for a moment does the Hordim remain still before turning towards you. The shadow is a Hresh Warrior and as it closes you prepare yourself for the violence to come.
\n\nThe Hresh Warrior has a combat value of 15 and an endurance of 9. If you win this combat continue with your mission. If not, it will be here that your adventure will end.
\n\nThe Hresh had called out to another Hordim on the battlement but you cannot yet see him. The Hordim must be on the other side of the level, your view obscured by the pile of crates and the all encompassing gloom of night. Quickly you move to find him.');

insert into BRANCH values (202,1,'Continue',2801);


-- SECTION 3
-- ---------
insert into EPISODE values (3,'With the key in hand you test the lock and hear its tumbler turn. With a muffled click the trapdoor unlocks and you heave it sideways, uncovering a long flight of stairs and the sounds of movement below. For a moment you listen, the muffled clink of chains and the low murmur of voices all you can discern against the rumble of the growing storm. Carefully you descend into the darkness and find more than a dozen villagers chained within a large cellar below. Placing your finger to your lips you quell their pleas and break the lock that holds them captive. With sword in hand you lead them back to the Ground Floor and then motion for all to make for the exit and the safety beyond. Only when the last of their number has disappeared into the night do you turn and consider your next move.
\n\nThese villagers have been freed and no alarm has yet been raised. Carefully you consider what you should now do.');

insert into BRANCH values (3,1,'You would investigate the Armoury to the east',28);
insert into BRANCH values (3,2,'The Kitchen seems a good place to start',18);
insert into BRANCH values (3,3,'You would rather head north and search the Laundry',21);
insert into BRANCH values (3,4,'You would take a closer look at the bootprints',9);
insert into BRANCH values (3,5,'You would rather leave this floor and take to the stairs in the north-west corner',30);


-- SECTION 4
-- ---------
insert into EPISODE values (4,'The laundry is a dank and odorous chamber and as you move to search its confines you smell something dangerously familiar. From a large clay jar in the corner there comes a steady fume that quickly corrupts the air about you. You have triggered a gas trap and have only a few moments to live. Test your Agility by throwing one dice. If you throw a number equal to, or less than your Agility value you are able to escape the spreading fume and can continue with your mission. If you throw a greater number then the gas will overwhelm you and your quest here will be over.
\n\nIf you survive this trap you will have been forced from the Laundry back out into the common area of the Ground Floor and are indeed lucky to be alive. If this is your fate you have the following options before you.');

insert into BRANCH values (4,1,'You would investigate the Armoury to the east',28);
insert into BRANCH values (4,2,'The Kitchen seems a better choice',18);
insert into BRANCH values (4,3,'You would take a closer look at the bootprints',9);
insert into BRANCH values (4,4,'You are curious about the trapdoor to the north-east',14);
insert into BRANCH values (4,5,'You would rather leave this floor and take to the stairs in the north-west corner',30);


-- SECTION 5
-- ---------
insert into EPISODE values (5,'Quietly you enter the largest of the sleeping alcoves. In the dark you can see little, but a faint tug at your pant leg tells you that you should have been more careful. In a crushing explosion a booby-trap detonates, throwing your lifeless remains across the cold stone floor and against the opposite wall. In this life your quest is over.');

insert into BRANCH values (5,1,'You fail',0);


-- SECTION 5a (501)
-- ---------------
insert into EPISODE values (501,'In a flurry of robes the Mutan Overseer attacks. About you the storm is a roil of blustering winds and torn cloud, the rain that has deluged the tower leaving the stone slick and your footing unsure. In one sliding arc the Mutan swings his axe, its curving blade cutting through the air near your neck. Against this assault you deflect its edge and thrust forward with your sword against the Mutan''s now exposed right shoulder. Your lunge misses but it causes the Hordim to fall backwards to avoid injury. It is an opportunity you do not let pass. In one fluid movement you rush forward and attempt to drive your sword into the creature as it struggles to regain its feet. In desperation the Mutan kicks out with its leg, sweeping your foot sideways and knocking you off balance.
\n\nBacking away you steady your footing and attack again. The Mutan is on its feet but it has injured itself on the hard stone and you take full advantage of its discomfort. This time you sweep your sword in a wide arc, feinting the Mutan to try and block the stroke. The Hordim obliges, throwing its axe out to foil your strike but it is exactly what you need. As the creature focuses on the blow you rush forward, crashing into the Hordim with all the strength you can muster. The Overseer is caught by surprise and falls back again onto the stone with a jarring crack. Before your foe can react you are upon him, your sword thrusting down into his undefended chest. In a gurgling cry the Mutan dies and you are left alone upon the battlements, only the storm rumbling in the dark.
\n\nStanding straight you consider the Mutan''s prone form and look about the battlement. The pile of boxes seems innocuous but a closer inspection uncovers a large supply of the grey powder secreted within. There is enough here you think, to kill the population of a small town, and you determine that your mission will not be complete until you return all the research notes and samples of the powder to Army Intelligence for proper analysis. 
\n\nUpon the Watchtower however, your task is done.');

insert into BRANCH values (501,1,'The end',999);


-- SECTION 6
-- ---------
insert into EPISODE values (6,'The common area remains dark and quiet, the growing storm a rumbling backdrop that masks your footfalls upon the cold flagstones. In the shadows you consider what you should do next.');

insert into BRANCH values (6,1,'You have not already done so and would investigate the Armoury to the east',28);
insert into BRANCH values (6,2,'The Kitchen seems a good place to continue',18);
insert into BRANCH values (6,3,'You would rather head north and search the Laundry',21);
insert into BRANCH values (6,4,'You would take a closer look at the bootprints',9);
insert into BRANCH values (6,5,'Your interest lies with the trapdoor to the north-east',14);
insert into BRANCH values (6,6,'You would rather leave this floor and take to the stairs in the north-west corner',30);


-- SECTION 7
-- ---------
insert into EPISODE values (7,'You stand at the top of a stairwell that connects the First and Second Levels of the Watchtower. As with the First Level this Second level once served as a barracks, a similar series of sleeping alcoves lining the eastern wall. Looking into the shadows you have no doubt that Hresh have spent some time here, although you cannot yet fathom their purpose. Carefully you move forward.');

insert into BRANCH values (7,1,'Continue',11);


-- SECTION 8
-- ---------
insert into EPISODE values (8,'Quickly you climb the central stairway and find yourself standing upon the watchtower''s battlements. Overhead the night is a patchwork of rushing cloud riding upon a blustering wind, and as you look along the old stone crenellations you can see the remains of weapons mounts in each corner and a jumble of broken packing crates to the south-east. In the uneven light you can sense that there is something else here as well.');

insert into BRANCH values (8,1,'You would begin by conducting a search of each of the ballista mounts',202);
insert into BRANCH values (8,2,'You would search the crates in the south-east instead',2801);


-- SECTION 9
-- ---------
insert into EPISODE values (9,'For a moment you pause and look closer at a bootprint clearly outlined in the dust at your feet. It is as long as a man''s but thicker in form. It has been made by a Hresh warrior and by the number of prints that litter the floor there is definitely more than one of them.');

insert into BRANCH values (9,1,'You would investigate the Armoury to the east',28);
insert into BRANCH values (9,2,'The Kitchen seems a good place to start',18);
insert into BRANCH values (9,3,'You would rather head north and search the Laundry',21);
insert into BRANCH values (9,4,'You are curious about the trapdoor to the north-east',14);
insert into BRANCH values (9,5,'You would rather leave this floor and take to the stairs in the north-west corner',30);


-- SECTION 10
-- ----------
insert into EPISODE values (10,'You have found a stairway that rises towards an all-weather Observation deck above. Here the winds blow freely down the stairwell, the smell of rain evident as you consider your next move.');

insert into BRANCH values (10,1,'You use these stairs and ascend to the Observation Level above',26);
insert into BRANCH values (10,2,'You continue your mission by searching the alcove in the northern corner',2501);
insert into BRANCH values (10,3,'You search instead the other apparently empty alcoves',1802);
insert into BRANCH values (10,4,'You look at a pile of old boxes stacked within the centre alcove',2502);
insert into BRANCH values (10,5,'You rather search the larger alcove at the south-eastern corner of the level',5);


-- SECTION 11
-- ----------
insert into EPISODE values (11,'Outside the storm builds, flashes of lightning illuminating the debris-strewn floor in momentary flickers of brilliant light. Thunder rumbles against the tower''s old stone and from within the gloom you can hear rain spattering upon a series of wooden shutters that block each of the floor''s small windows. Against this backdrop you carefully move into the centre of the level''s common area, the line of alcoves no more than dark cells upon the eastern wall. Each is only larger than the space needed for a bed and small cupboard but most appear to be empty. Only the northern alcove, and one at the centre of the line of sleeping cells appear to hold anything. In a blast of lightning you see movement from one of the alcoves and in that moment realise that something has seen you also. Almost before you can defend yourself a Hresh Warrior charges from the shadows. In a clash of metal you block its first strike then press forward.
\n\nThe Hresh has a combat value of 14 and an endurance of 6. If you win this combat continue with your mission. If however, it is you that falls it must be to another life that you will have to look for greater success.');

insert into BRANCH values (11,1,'You loose the combat',0);
insert into BRANCH values (11,2,'You win and continue your mission by searching the alcove in the northern corner',2501);
insert into BRANCH values (11,3,'You win and search instead the other apparently empty alcoves',1802);
insert into BRANCH values (11,4,'You win and look at a pile of old boxes stacked within the centre alcove',2502);
insert into BRANCH values (11,5,'You win and search the larger alcove at the south-eastern corner of the level',5);
insert into BRANCH values (11,6,'There seems more advantage in making for the stairwell in the north-western corner',10);


-- SECTION 12
-- ----------
insert into EPISODE values (12,'You have found a stairway that rises to the Second Level of the Watchtower. For a moment you pause, listening for any sign of movement upon the floor above. You can hear nothing except the growing tumult of the storm.');

insert into BRANCH values (12,1,'You take this stairway',7);
insert into BRANCH values (12,2,'You rather remain on this floor and continue searching the First Floor',24);


-- SECTION 13
-- ----------
insert into EPISODE values (13,'Quickly you move towards what, in the gloom, appears to be an empty bed covered by a worn cotton sheet. What you find beneath the linen cover is a woman, tightly restrained but still alive. Without a word you remove the makeshift leather straps that bind her and motion for her to make for the stairway. If she is to survive she will have to find her own way out. When you see her taking the stairs you return your attention to what remains on this level. Unfortunately something has found you instead.');

insert into BRANCH values (13,1,'Continue',201);


-- SECTION 14
-- ----------
insert into EPISODE values (14,'In the floor you see the outline of a large trapdoor, of a type that should uncover a stairway to a lower level or cellar. Quickly you move to it and grab at a large iron ring, your intent to pull it open. The door is however, very heavy and locked down tight. For a moment you put your strength against it but find it solid and unmovable. It will not be opened without the iron key that fits its brass escutcheon.
\n\nIf you have an Iron Key you have the option to go down into the basement below. If you do not, then you will have to find the key first.')

insert into BRANCH values (14,1,'You have an Iron Key and you go down into the basement below',3);
insert into BRANCH values (14,2,'You have not already done so and would investigate the Armoury to the east',28);
insert into BRANCH values (14,3,'The Kitchen seems a good place to continue',18);
insert into BRANCH values (14,4,'You rather head north and search the Laundry',21);
insert into BRANCH values (14,5,'You take a closer look at the bootprints',9);
insert into BRANCH values (14,6,'You rather leave this floor and take to the stairs in the north-west corner',30);


-- SECTION 15
-- ----------
insert into EPISODE values (15,'Moving towards the table in the south-west corner you find a collection of scrolls, journals and small paper packets filled with a grey powder. The scrolls are written in a dialect of the Hordim and you recognise them quickly for what they are. What you have found are research notes, and you understand now what the Hordim have been doing here. The grey powder is a poison and from the notes you can see that it is being altered so that it is specific to Humans alone. Luckily the Hordim have not yet perfected its chemistry and you cannot let them succeed. This is no simple raiding party. They are experimenting on human subjects and for you that presents a greater problem. Research is not a function of the Hresh for they serve as warriors alone. There is a Mutan Overseer here and he will not be far from his experiments.');

insert into BRANCH values (15,1,'You have not already done so and would begin a general search of this level',22);
insert into BRANCH values (15,2,'You make directly for the row of beds against the northern wall',20);
insert into BRANCH values (15,3,'You instead make for the lone bed in the south-eastern corner',13);
insert into BRANCH values (15,4,'There is good cause to make for the stairway to the battlements above',17);


-- SECTION 16
-- ----------
insert into EPISODE values (16,'Quickly you search the contents of the Armoury. In a corner you find a small shield discarded upon the floor. It is old and well-used but still serviceable. If you wish to take this shield increase your combat value (CV) by 1 point then return to the main common area');

insert into BRANCH values (16,1,'Continue',6);


-- SECTION 17
-- ----------
insert into EPISODE values (17,'You have found a stairway that leads upwards to the Watchtower''s battlements above. Through the open stairwell the rushing clouds are illuminated by lightning, and silhouetted against the tempest a shadowed figure moves furtively. There are more Hordim above.');

insert into BRANCH values (17,1,'You are ready to leave this level and go after the Hordim on the battlements above',8);
insert into BRANCH values (17,2,'You have not already done so and would make directly for the row of beds against the northern wall',20);
insert into BRANCH values (17,3,'You instead make for the lone bed in the south-eastern corner',13);
insert into BRANCH values (17,4,'You are more curious about the articles resting upon the table in the south-western corner of the level',15);


-- SECTION 18
-- ----------
insert into EPISODE values (18,'Carefully you make your way to the Kitchen and find within a series of tables and wash-sinks, old cupboards and piles of discarded food packets and containers. With only a few moments to spare for the task you search the chamber for anything that might prove of use. Within a collection of baskets you find food that may be edible. Roll 1d6. If you roll an even number the food is edible and can restore 4 endurance points when eaten. Otherwise it is spoiled and must be discarded. As you search further you find also a number of packets of Nahla bread, each wrapped in waxed paper. Most are spoiled but you find two that are still edible. These you take with you. Each will restore 2 points to your endurance level when eaten. When you are done you return to the main common area and consider your next move.');

insert into BRANCH values (18,1,'Continue',6);


-- SECTION 18a (1801)
-- -----------------
insert into EPISODE values (1801,'As you search the alcove you find a large quantity of old wooden boxes, thrown haphazardly into its dark corners. All are broken and most have been pulled apart, no doubt in preparation for their use as firewood. At the entrance you find however, a number of packets of Nahla bread, each wrapped in waxed paper and kept within a small wooden chest. Most are spoiled but three of the breads are still edible. These you take with you. Each will restore 2 points to your endurance level when eaten. When you are done you look out onto the First level and consider your next move.');

insert into BRANCH values (1801,1,'You have not already done so and would search the larger alcove in the south-east corner of the level',27);
insert into BRANCH values (1801,2,'You choose one of the other sleeping alcoves against the eastern wall and search it for further evidence of the Hordims'' purpose',25);
insert into BRANCH values (1801,3,'You leave this floor and use the stairway in the north-wester corner to return to the Ground Level of this watchtower',29);
insert into BRANCH values (1801,4,'You use the stairway in the south-western corner to ascend to the Second Level of this watchtower',12);


-- SECTION 18b (1802)
-- -----------------
insert into EPISODE values (1802,'You search the alcoves and find little but dust and the wind-blown debris of a structure neglected for far too long. In the last of the smaller alcoves you find something however, that gives you reason to pause. Upon the ground is a small packet, wrapped in paper but opened at one end as if something has been pulled from it. You pick up the wrapper and smell its interior. The odour is very familiar, being a type of sweet loaf popular at fairs and country markets. Opening the packet fully you find only the remnants of its contents, but there is enough to indicate that it was opened only within the last day or two. Discarding the wrapper upon the floor you continue on.');

insert into BRANCH values (1802,1,'You have not already done so and would continue your mission by searching the alcove in the northern corner',2501);
insert into BRANCH values (1802,2,'You look at a pile of old boxes stacked within the centre alcove',2502);
insert into BRANCH values (1802,3,'You rather search the larger alcove at the south-eastern corner of the level',5);
insert into BRANCH values (1802,4,'There seems more advantage in making for the stairwell in the north-western corner',10);


-- SECTION 19
-- ----------
insert into EPISODE values (19,'A Mutan! Crouching against the northern battlement the creature is whispering urgently into a small iron device. You shout a challenge to the Hordim Overseer and it answers. From the shadows the creature rises to its full height, its hand reaching for a large, ornately decorated battle-axe. Without a further word the Mutan advances towards you.
\n\nThe Mutan has a combat value of 17 and an endurance of 9. (If you have killed more than five Hresh on this mission increase your combat value by +1 for the duration of this combat.');

insert into BRANCH values (19,1,'You kill this Overseer',501);
insert into BRANCH values (19,2,'You fail!',0);


-- SECTION 20
-- ----------
insert into EPISODE values (20,'Carefully you move towards the line of beds and find in one a man, restrained and unmoving. You check if he is alive but you can find no sign. He is covered only with a sheet and has a grey powder about his lips. Carefully you inspect the man''s body and find no obvious cause of death but you notice the discarded sheets upon the other beds are all stained with the same grey residue. You cannot help this man so you turn and consider what you should do next.');

insert into BRANCH values (20,1,'You have not yet done so and would begin a general search of the Observation Level',22);
insert into BRANCH values (20,2,'You instead make for the lone bed in the south-eastern corner',13);
insert into BRANCH values (20,3,'There is good cause to make for the stairway to the battlements above',17);
insert into BRANCH values (20,4,'You are more curious about the articles resting upon the table in the south-western corner of the level',15);


-- SECTION 21
-- ----------
insert into EPISODE values (21,'In the Laundry you find a pile of clothing, consisting of a mix of human field-wear and Hordim camouflage uniforms. It is an odd accumulation of bits and pieces that has been taken from a large number of individuals, and for a moment you pause and consider what it could mean. The uniforms belong to Hresh and most likely an insurgency crue. This would explain who has been taking the local villagers but the question of why the Hordim are here must yet be answered.');

insert into BRANCH values (21,1,'You wish to return to the main living area',6);
insert into BRANCH values (21,2,'You search this Laundry further',4);


-- SECTION 21a (2101)
-- ------------------
insert into EPISODE values (2101,'With thunder rumbling against the tower''s old stone you take the stairs back to the First Level and continue your mission.');

insert into BRANCH values (2101,1,'You have not already done so and would search the box filled alcove',1801);
insert into BRANCH values (2101,2,'You choose one of the other sleeping alcoves against the eastern wall and search it for further evidence of the Hordims'' purpose',25);
insert into BRANCH values (2101,3,'You rather use the stairway in the south-western corner to make for the Second Floor',12);


-- SECTION 22
-- ----------
insert into EPISODE values (22,'As you look about the Observation Level you hear a noise. From the battlements above a Hresh walks down the stairs cradling a bundle of cut wood. He is unarmed and cannot be allowed to live. Before the Hordim can raise an alarm you drive your sword through his chest, toppling him sideways onto the hard stone floor. Without a further sound you move forward.');

insert into BRANCH values (22,1,'You have not yet done so and would make directly for the row of beds against the northern wall',20);
insert into BRANCH values (22,2,'You instead make for the lone bed in the south-eastern corner',13);
insert into BRANCH values (22,3,'There is good cause to make for the stairway to the battlements above',17);
insert into BRANCH values (22,4,'You are more curious about the articles upon the table in the south-western corner of the level',15);

-- SECTION 23
-- ----------
insert into EPISODE values (23,'Quickly you search the alcove and find nothing but the accoutrements of a warrior, his clothing and equipment neatly arranged upon a series of makeshift shelves. In the shadows you look through these possessions and find nothing of value to your mission nor any further clues to the Hordims'' purpose here. You are about to turn about when you see something heavy seated within a leather purse hanging from a wooden peg hammered into the wall. Curious, you take the purse and loosen its drawstring. Carefully you pull a dust covered metal object from its interior. You have found a large Iron Key. For a moment you inspect the key then place it in your pocket. Leaving the alcove you consider your next move.');

insert into BRANCH values (23,1,'You have not already done so and would conduct a general search of the level',24);
insert into BRANCH values (23,2,'You choose one of the other sleeping alcoves and search it for further evidence of the Hordims'' purpose here',25);
insert into BRANCH values (23,3,'You leave this floor and use the stairway in the north-wester corner to return to the Ground Level of this watchtower',29);
insert into BRANCH values (23,4,'You use the stairway in the south-western corner to ascend to the Second Level of this watchtower',12);


-- SECTION 24
-- ----------
insert into EPISODE values (24,'As you search the First Level you find upon the dust covered floor a set of bootprints you cannot identify. Kneeling down you outline one of the prints with your finger and consider what you have discovered. They are longer than any you have seen before, and judging by the gait, left by a creature of unusual height. Standing, you survey the floor and ponder your next move. In the dark you can see little, but you do notice that one of the sleeping alcoves is filled with boxes and old crates.');

insert into BRANCH values (24,1,'You wish to search the box filled alcove turn',1801);
insert into BRANCH values (24,2,'You search a larger alcove you have noticed in the south-east corner of the level',27);
insert into BRANCH values (24,3,'You choose one of the other sleeping alcoves against the eastern wall and search it for further evidence of the Hordims'' purpose',25);
insert into BRANCH values (24,4,'You leave this floor and use the stairway in the south-western corner',12);
insert into BRANCH values (24,5,'You have reason to return to the Ground Floor at this time make for the stairs in the north-west corner',29);


-- SECTION 25
-- ----------
insert into EPISODE values (25,'Quietly you enter the alcove and find a Hresh warrior asleep upon an old mattress. Before the Hordim can awaken you kill him and search his quarters. What you find is curious indeed. Amongst a pile of sacks lining the eastern wall of the alcove you find boxes containing a multitude of small, finely made paper envelopes. They hold nothing within, but appear to be stored here for use elsewhere. You take one of the envelopes and put it into your pocket. A further search shows that the Hordim has nothing that can aid your mission so you move on.');

insert into BRANCH values (25,1,'You have not yet searched the box filled alcove and wish to do so',1801);
insert into BRANCH values (25,2,'You search a larger alcove you have noticed in the south-east corner of the level',27);
insert into BRANCH values (25,3,'You leave this floor and use the stairway in the south-western corner',12);
insert into BRANCH values (25,4,'You have reason to return to the Ground Floor at this time make for the stairs in the north-west corner',29);


-- SECTION 25a (2501)
-- ------------------
insert into EPISODE values (2501,'Rubbish lies strewn about the floor and within the debris you can see the remnants of discarded clothing and a number of personal items. Stooping you pick up a small comb, its decoration that of a young woman''s liking. Looking around you wonder what has become of its owner and without really thinking you place the item in your pocket. Without any further delay you move forward, making for the alcove in the northern corner of the level. In the shadows you find an unmade bed and the equipment of a Hresh warrior. Nothing is of use so you turn about and consider what you should do next.');

insert into BRANCH values (2501,1,'You search instead the other apparently empty alcoves on this floor',1801);
insert into BRANCH values (2501,2,'You look at a pile of old boxes stacked within the centre alcove',2502);
insert into BRANCH values (2501,3,'You search the larger alcove at the south-eastern corner of the level',5);
insert into BRANCH values (2501,4,'There seems more advantage in making for the stairwell in the north-western corner',10);


-- SECTION 25b (2502)
-- -----------------
insert into EPISODE values (2502,'The alcove is filled with the remnants of old wooden boxes and broken furniture. At first glance it looks like someone has attempted to clean up the living area here but a closer look shows that the alcove is being used to store wood alone, most likely for a fire. There is nothing here that gives any further clue as to the purpose of the Hordim within the Watchtower so you move on.');

insert into BRANCH values (2502,1,'You continue your mission by searching the alcove in the northern corner',2501);
insert into BRANCH values (2502,2,'You search instead the other apparently empty alcoves',1802);
insert into BRANCH values (2502,3,'You search the larger alcove at the south-eastern corner of the level',5);
insert into BRANCH values (2502,4,'There seems more advantage in making for the stairwell in the north-western corner',10);


-- SECTION 26
-- ----------
insert into EPISODE values (26,'You reach the top of the stairs and come to a halt. Within this Observation Level you can see a row of beds across the northern wall, a further bed standing against the south-eastern corner and a central stairway that leads to the battlements above. Curiously all the large viewing windows here have been boarded up and sealed, and in the dark of the night shadows veil all about you. In the lower south-west corner you see also a table covered in papers and a collection of unidentifiable devices and medical instruments. Carefully you move forward. ');

insert into BRANCH values (26,1,'You begin a general search of the Observation Level',22);
insert into BRANCH values (26,2,'You make directly for the row of beds against the northern wall',20);
insert into BRANCH values (26,3,'You make for the lone bed in the south-eastern corner',13);
insert into BRANCH values (26,4,'There is good cause to make for the stairway to the battlements above',17);
insert into BRANCH values (26,5,'You look at the articles resting upon the table in the south-western corner of the level',15);


-- SECTION 27
-- ----------
insert into EPISODE values (27,'Within this alcove you find a Hresh sleeping upon a makeshift bed. Before you can kill the creature the warrior wakes and jumps to his feet. From the dark and shadows the Hordim attacks.
\n\nThe Hresh has a combat value of 16 and an endurance of 9. If you win this combat you can either search the alcove for anything of value or continue with your mission. If you fall it will be here that your adventure will end. ');

insert into BRANCH values (27,1,'You wish to search this alcove',23);
insert into BRANCH values (27,2,'You have not already done so and would conduct a general search of the level',24);
insert into BRANCH values (27,3,'You choose one of the other sleeping alcoves and search it for further evidence of the Hordims'' purpose here',25);
insert into BRANCH values (27,4,'You leave this floor and use the stairway in the south-western corner to ascend to the Second Level',12);
insert into BRANCH values (27,5,'You have reason to return to the Ground Floor at this time make for the stairs in the north-west corner',29);


-- SECTION 28
-- ----------
insert into EPISODE values (28,'Carefully you move towards the Armoury and find within its confines a collection of broken shelves and disused weapon racks. The Watchtower has remained abandoned for many years and the dust and decay here highlights its ongoing neglect. Outside a crash of lightning lights up the sky, and as you move further into the chamber you see the furtive silhouette of something waiting for you in the darkness. Out of the shadows a Hresh Warrior rushes you, its charge no more than a blur in the dark. Determined not to let this Hordim call out an alarm you run straight at it, your sword lunging for its chest. In a clash of metal the combat begins.
\n\nThe Hresh Warrior has a combat value (CV) of 15 and an endurance (EP) of 10. If you win this combat you may either return to the main common area and continue with your mission or conduct a further search of the Armoury. ');

insert into BRANCH values (28,1,'You win this combat and you return to the common area',6);
insert into BRANCH values (28,2,'You win this combat and search the Armoury instead',16);
insert into BRANCH values (28,3,'You loose this combat',0);

-- SECTION 28a (2801)
-- -----------------
insert into EPISODE values (2801,'Upon the battlements you make for the pile of crates but come to a standstill when you see a shadowed form crouching against the far wall. For a moment you wait, hoping to gain a better view of the Hordim. The long arms and elongated head give you reason to take a firmer grip upon your sword.');

insert into BRANCH values (2801,1,'Continue',19);


-- SECTION 29
-- ----------
insert into EPISODE values (29,'In the gloom of the First Level of the Watchtower you stand at the top of a stairway that leads down to the Ground Floor below. All about you is darkness, the First Floor veiled in shadows. It appears that this level served as a barracks, the eastern wall lined with a series of sleeping alcoves, the floor littered with broken furniture and discarded food. In the south-western corner you can also see the dark shadow of a stairway leading to the levels above.');

insert into BRANCH values (29,1,'You wish to explore this First Level turn to section', 2);
insert into BRANCH values (29,2,'You want to use these stairs to return to the Ground Floor turn to section', 30);


-- SECTION 30
-- ----------
insert into EPISODE values (30,'Before you is a stairway that connects the Ground Floor to the First Level above. You listen intently but can hear nothing beyond the howl of the winds and the clatter of wooden shutters loose upon their mountings.');

insert into BRANCH values (30,1,'You would take these stairs and make for the First Level',29);
insert into BRANCH values (30,2,'This is the second time you have used these stairs to make for the First Level turn to section', 2101);
insert into BRANCH values (30,3,'You have used these stairs to return to the Ground Floor, turn instead to section', 6);


-- SECTION 0
-- ---------

insert into EPISODE values (0,'Here ends your adventure.\n   It will be in a latter life that you will have to strive for greater success ');

insert into BRANCH values (0,1,'Quit',-1)


-- SECTION 999
-- -----------

insert into EPISODE values (999,' You win!\nCongratulation.');

insert into BRANCH values (999,1,'Quit',-1)

-- ------------------------------ --
--        The game engine         --
-- ------------------------------ --

-- Just to be prudent, the number of iterations is limited to 1000

outputOpen $fileDirectory$/A-TheWatchTower-Story.txt;
set E = 1;
set step = 1;
while ($E$ not in (0,999) and $step$ < 1000);
  extract txt = select TEXT from EPISODE where EPID = $E$;
  replace txt = \\n,@n;
  write $txt$;
  extract NB = select count(*) from BRANCH where EPID = $E$;
  compute B = 1 + abs(random()) % $NB$;
  extract B,PR,E = select SEQNBR,PROMPT,TARGET from BRANCH
                   where  EPID = $E$ and SEQNBR = $B$;
  if ('PR' <> 'Continue') write-b @n$PR$.;
  compute step = $step$ + 1;
endwhile;
outputAppend window;

execProg $TEXTprocessor$ $fileDirectory$/A-TheWatchTower-Story.txt; 

closeDB;

stop;


-- EPID conversion -

2a  = 201  = 31
2b  = 202  = 32
5a  = 501  = 33
18a = 1801 = 34
18b = 1902 = 35
21a = 2101 = 36
25a = 2501 = 37
25b = 2502 = 38
28a = 2801 = 39
