
openDB KINGS.db;

set maxSelectWidth = 120;

set Closure = select Father,PiD,1,'.'||Father||'.'||PiD||'.'
              from MEMBER where Father is not null
                 union all
              select P.Ancestor,M.PID,P.Len+1,P.Path||M.PID||'.'
              from   PATHS P,MEMBER M
              where  P.Descendant = M.Father;

-- printing the Closure
with recursive PATHS(Ancestor,Descendant,Len,Path) as ($Closure$)
select Ancestor,Descendant,Len,Path
from   PATHS
order  by Len,Ancestor,Descendant;

-- computing the size of the closure
with recursive PATHS(Ancestor,Descendant,Len,Path) as ($Closure$)
select count(*) as Number from PATHS;

-- Group paths by length --
with recursive PATHS(Ancestor,Descendant,Len,Path) as ($Closure$)
select Len,count(*) as Number from PATHS group by Len;

set maxSelectWidth = 60;

closeDB;
