
openDB KINGS.db;

set Closure = select Father,PiD,1,'.'||Father||'.'||PiD||'.'
              from MEMBER where Father is not null
                 union all
              select P.Ancestor,M.PiD,P.Len+1,P.Path||M.PiD||'.'
              from   CTE_PATHS P,MEMBER M
              where  P.Descendant = M.Father;

create temporary view PATHS as
with recursive CTE_PATHS(Ancestor,Descendant,Len,Path) as
($Closure$)
select Ancestor,Descendant,Len,Path
from   CTE_PATHS;

-- =========================================== --

set entryWidth1 = 16;

ask A,B = [/bGive the Id of two members]
           Ancestor:[select PiD from MEMBER order by PiD]
         ||Descendant:[select PiD from MEMBER order by PiD];
   if ('$DIALOGbutton$' = 'Cancel') return;

extract C = select count(*) from PATHS
            where  Ancestor = '$A$' and Descendant = '$B$';

if ($C$ = 0) showMessage $A$ is not an ancestor of $B$;
if ($C$ = 1) showMessage $A$ is an ancestor of $B$;

-- =========================================== --

ask A,B,C = [/bCheck whether B is is the path of A to C] 
            A:[select PiD from MEMBER order by PiD]
           |B:[select PiD from MEMBER order by PiD]
           |C:[select PiD from MEMBER order by PiD];
   if ('$SQLdiag$' = 'Cancel') return;

extract N = select count(*) from PATHS
            where  Ancestor = '$A$' and Descendant = '$C$'
            and    Path like '.%.$B$.%.';

if ($N$ = 1) showMessage Yes, $B$ is between $A$ and $C$.;
if ($N$ = 0) showMessage No, $B$ is not between $A$ and $C$.;

set entryWidth1 = 20;

closeDB;
