-- French monarchs family tree, Capetian Dynasty (9871848) --
-- -------------------------------------------------------- --
-- "simplified family tree of the Capetian dynasty and its cadet branches"
-- Data from three sources
--   http://en.wikipedia.org/wiki/French_monarchs_family_tree
--   http://en.wikipedia.org/wiki/Members_of_the_French_Royal_Families
--   http://en.wikipedia.org/wiki/List_of_French_monarchs

createOrReplaceDB KINGS.db;

create table MEMBER(
   PiD            char(6) not null,
   Name           char(20) not null,
   House          char(12) not null,
   Father         char(6),
   Title          char(20) not null,
   DateBirth      integer not null,
   DateDeath      integer not null,
   DateReignBegin integer,
   DateReignEnd   integer,
   primary key (PiD), 
   foreign key (Father) references MEMBER);

create view KING
as
select PiD,Name,House,Father,DateBirth,DateDeath,DateReignBegin,DateReignEnd 
from MEMBER 
where Title = 'Roi de France';

insert into MEMBER values('C00','HUGHES CAPET','Capet',null,'Roi de France',939,996,987,996);
insert into MEMBER values('C01','ROBERT II','Capet','C00','Roi de France',972,1031,996,1031);
insert into MEMBER values('C02','HENRI I','Capet','C01','Roi de France',1008,1060,1031,1060);
insert into MEMBER values('C03','PHILIPPE I','Capet','C02','Roi de France',1052,1108,1060,1108);
insert into MEMBER values('C04','LOUIS VI','Capet','C03','Roi de France',1077,1137,1108,1137);
insert into MEMBER values('C05','LOUIS VII','Capet','C04','Roi de France',1120,1180,1137,1180);
insert into MEMBER values('C06','PHILIPPE II','Capet','C05','Roi de France',1165,1223,1180,1223);
insert into MEMBER values('C07','LOUIS VIII','Capet','C06','Roi de France',1187,1226,1223,1226);
insert into MEMBER values('C08','LOUIS IX','Capet','C07','Roi de France',1215,1270,1226,1270);
insert into MEMBER values('C09','PHILIPPE III','Capet','C08','Roi de France',1245,1285,1270,1285);
insert into MEMBER values('C10','PHILIPPE IV','Capet','C09','Roi de France',1268,1314,1285,1314);
insert into MEMBER values('C11','LOUIS X','Capet','C10','Roi de France',1289,1316,1314,1316);
insert into MEMBER values('C12','PHILIPPE V','Capet','C10','Roi de France',1291, 1322,1316,1322);
insert into MEMBER values('C13','CHARLES IV','Capet','C10','Roi de France',1295,1328,1322,1328);
insert into MEMBER values('C14','JEAN I','Capet','C11','Roi de France',1316,1316,1316,1316);

insert into MEMBER values('V00','Charles','Valois','C09','Comte de Valois',1270,1325,null,null);
insert into MEMBER values('V01','PHILIPPE VI','Valois','V00','Roi de France',1293,1350,1328,1350);
insert into MEMBER values('V02','JEAN II','Valois','V01','Roi de France',1319,1364,1350,1364);
insert into MEMBER values('V03','CHARLES V','Valois','V02','Roi de France',1337,1380,1364,1380);
insert into MEMBER values('V04','CHARLES VI','Valois','V03','Roi de France',1368,1422,1380,1422);
insert into MEMBER values('V05','CHARLES VII','Valois','V04','Roi de France',1403,1461,1422,1461);
insert into MEMBER values('V06','LOUIS XI','Valois','V05','Roi de France',1423,1483,1461,1483);
insert into MEMBER values('V07','CHARLES VIII','Valois','V06','Roi de France',1470,1498,1483,1498);

insert into MEMBER values('V08','Louis I','Valois','V03','Duc d''Orlans',1372,1407,null,null);
insert into MEMBER values('V09','Charles','Valois','V08','Duc d''Orlans',1394,1465,null,null);
insert into MEMBER values('V10','LOUIS XII','Valois','V09','Roi de France',1462,1515,1498,1515);

insert into MEMBER values('V11','Jean','Valois','V08','Comte d''Angoulme',1399,1467,null,null);
insert into MEMBER values('V12','Charles','Valois','V11','Comte d''Angoulme',1459,1496,null,null);
insert into MEMBER values('V13','FRANCOIS I','Valois','V12','Roi de France',1494,1547,1515,1547);
insert into MEMBER values('V14','HENRI II','Valois','V13','Roi de France',1519,1559,1547,1559);
insert into MEMBER values('V15','FRANCOIS II','Valois','V14','Roi de France',1544,1560,1559,1560);
insert into MEMBER values('V16','CHARLES IX','Valois','V14','Roi de France',1550,1574,1560,1574);
insert into MEMBER values('V17','HENRI III','Valois','V14','Roi de France',1551,1589,1574,1589);

insert into MEMBER values('B00','Robert','Bourbon','C08','Comte de Clermont',1256,1317,null,null);
insert into MEMBER values('B01','Louis I','Bourbon','B00','Duc de Bourbon',1279,1342,null,null);
insert into MEMBER values('B02','Jacques I','Bourbon','B01','Comte de La Marche',1319,1362,null,null);
insert into MEMBER values('B03','Jean I','Bourbon','B02','Comte de La Marche',1344,1393,null,null);
insert into MEMBER values('B04','Louis','Bourbon','B03','Comte de Vendme',1376,1446,null,null);
insert into MEMBER values('B05','Jean VIII','Bourbon','B04','Comte de Vendme',1426,1477,null,null);
insert into MEMBER values('B06','Franois','Bourbon','B05','Comte de Vendme',1470,1495,null,null);
insert into MEMBER values('B07','Charles','Bourbon','B06','Duc de Vendme',1489,1537,null,null);
insert into MEMBER values('B08','Antoine','Bourbon','B07','Duc de Vendme',1518,1562,null,null);
insert into MEMBER values('B09','HENRI IV','Bourbon','B08','Roi de France',1553,1610,1589,1610);
insert into MEMBER values('B10','LOUIS XIII','Bourbon','B09','Roi de France',1601,1643,1610,1643);
insert into MEMBER values('B11','LOUIS XIV','Bourbon','B10','Roi de France',1638,1715,1643,1715);
insert into MEMBER values('B12','Louis','Bourbon','B11','Grand Dauphin',1661,1711,null,null);
insert into MEMBER values('B13','Louis','Bourbon','B12','Petit Dauphin',1682,1712,null,null);
insert into MEMBER values('B14','LOUIS XV','Bourbon','B13','Roi de France',1710,1774,1715,1774);
insert into MEMBER values('B15','Louis','Bourbon','B14','Dauphin de France',1729,1765,null,null);
insert into MEMBER values('B16','LOUIS XVI','Bourbon','B15','Roi de France',1754,1793,1774,1792);
insert into MEMBER values('B17','LOUIS XVIII','Bourbon','B15','Roi de France',1755,1824,1814,1824);
insert into MEMBER values('B18','CHARLES X','Bourbon','B15','Roi de France',1757,1836,1824,1830);

insert into MEMBER values('O00','Philippe I','Orlans','B10','Duc d''Orlans',1640,1701,null,null);
insert into MEMBER values('O01','Philippe II','Orlans','O00','Duc d''Orlans',1674,1723,null,null);
insert into MEMBER values('O02','Louis','Orlans','O01','Duc d''Orlans',1703,1752,null,null);
insert into MEMBER values('O03','Louis Philippe I','Orlans','O02','Duc d''Orlans',1725,1785,null,null);
insert into MEMBER values('O04','Philippe galit','Orlans','O03','Duc d''Orlans',1747,1793,null,null);
insert into MEMBER values('O05','LOUIS PHILIPPE I','Orlans','O04','Roi de France',1773,1850,1830,1848);

select * from MEMBER order by DateBirth;

select Father,group_concat(PiD,',') as Sons from MEMBER group by Father;

commitDB;
closeDB;