-- ------------------ --
-- CONWAY'S LIFE GAME --
-- ------------------ --

set sourceDir = $scriptDirectory$/Case-Studies/Case_Life-Game;
set entryWidth1,entryWidth2 = 20,17;
set maxLin,maxCol = 50,50;

-- Build a list of game names             --
-- -------------------------------------- --
fileNames-s $fileDirectory$/gameFiles.txt = $sourceDir$,sql;
set gList = ;
for line = [file $fileDirectory$/gameFiles.txt]
  if (startsWith('$line$','Create-LIFEGAME-'))
     compute gList = '$gList$'||','||pureNodeName(substr('$line$',17));
compute gList = trim('$gList$',',');
deleteFile $fileDirectory$/gameFiles.txt;

-- Build a list of script names           --
-- -------------------------------------- --
fileNames-s $fileDirectory$/scriptFiles.txt = $sourceDir$,draw;
set sList = ;
for line = [file $fileDirectory$/scriptFiles.txt]
  if (startsWith('$line$','LIFEGAME-'))
     compute sList = '$sList$'||','||pureNodeName(substr('$line$',10));
compute sList = trim('$sList$',',');
deleteFile $fileDirectory$/scriptFiles.txt;

-- ask for a game or script               --
-- -------------------------------------- --
set game,script = ,;
ask game,script = [/bCONWAY'S LIFE GAME - Compile and/or play a game.] 
                  {-  Compile and play a game (may take time)}
                  |Game:[!($gList$)]
                 |{-  Play a compiled game (immediate)}
                  |Game:[!($sList$)];
if ('$DIALOGbutton$' = 'Cancel' or '$game$$script$' = '') stop;

-- Compile and play a game ...            --
-- -------------------------------------- --
if ('$game$' <> '');
   execSQL $sourceDir$/_LIFE-Generate-Script.sql;
   showDrawing $sourceDir$/LIFEGAME-$game$.draw 
               = [/b/x300/y300Life game "$game$".@nClick on "Play" to run the game.];
endif;

-- ... or play a compiled game            --
-- -------------------------------------- --
if ('$script$' <> '');
   showDrawing $sourceDir$/LIFEGAME-$script$.draw 
               = [/b/x300/y300Life game "$script$".@nClick on "Play" to run the game.];
endif;
