-- ----------------------------------- --
-- Create the SQLdraw file of the game --
-- ----------------------------------- --

outputOpen $sourceDir$/LIFEGAME-$game$.draw;

-- Generate the grid                                    --
-- ---------------------------------------------------- --
execSQL $sourceDir$/_LIFE-generate-grid.sql;

-- Compute the bounding window                          --
-- ---------------------------------------------------- --
extract I1,I2,J1,J2 = 
   select max(min(I)-1,0),min(max(I)+1,$Lnbr$-1),
          max(min(J)-1,0),min(max(J)+1,$Cnbr$-1)
   from CELL where C = 1;

-- Compute and insert points of each step in table LINE --
-- ---------------------------------------------------- --
if ('$I1$' <> '');
   insert into LINE values('display $Niter$ generations compiled in $timer$ s.');
   set seq = 0;
   execSQL $sourceDir$/_LIFE-generate-Current-State.sql;
   for seq = [1,$Niter$];
      insert into LINE values('delete last');
      execSQL $sourceDir$/_LIFE-compute-Next-Step.sql;
      if ('$I1$' = '') exit;
      execSQL $sourceDir$/_LIFE-generate-Current-State.sql;
   endfor;
endif;

-- Write the points of LINE in SQLdraw file             --
-- ---------------------------------------------------- --
execSQL UTIL-SELECT-parameters-for-Lists.sql;
select TXT from LINE;
execSQL UTIL-SELECT-parameters-standard-1.sql;

outputAppend window;

