-- ----------------------------------- --
-- Compute the next step in table CELL --
-- ----------------------------------- --

-- Compute in SCORE the score of each cell of the window --
-- ----------------------------------------------------- --
insert into SCORE(I,J,N)
select C0.I, C0.J, sum(C1.C)
from   CELL C0, CELL C1
where  C0.I between $I1$ and $I2$
and    C0.J between $J1$ and $J2$
and    C1.I between (C0.I - 1) and (C0.I + 1)
and    C1.J between (C0.J - 1) and (C0.J + 1)
and    not (C1.I = C0.I and C1.J = C0.J)
group by C0.I, C0.J;

-- Compute the state of each cell of the window          --
-- ----------------------------------------------------- --
update CELL
set C = (select case 
                when N<2 then 0
                when N=2 then CELL.C
                when N=3 then 1
                when N>3 then 0
                end
         from SCORE S
         where S.I = CELL.I and S.J = CELL.J)
where  I between $I1$ and $I2$
and    J between $J1$ and $J2$;

delete from SCORE;

-- Update the bounding window                            --
-- ----------------------------------------------------- --
extract I1,I2,J1,J2 = 
        select max(min(I)-1,0),min(max(I)+1,$Lnbr$-1),
               max(min(J)-1,0),min(max(J)+1,$Cnbr$-1)
        from CELL where C = 1;
