
set encode = 1;

-- =========================== BASIC QUERY ============================== --

insert into EXERCISE values(
   'Q01-01',
   'ORDERS.db',
   'basic',1,1,'List of all the customers',
   'List the Id, name and city of all the customers',
   'select CustID, Name, City from CUSTOMER'
);

insert into EXERCISE values(
   'Q01-02',
   'ORDERS.db',
   'basic',1,1,'List of the customers of Poitiers',
   'List the Ids and the names of customers living in Poitiers',
   'select CustID, Name from CUSTOMER where CITY = ''Poitiers'''
);

insert into EXERCISE values(
   'Q01-03',
   'ORDERS.db'
   ,'basic',1,1,'List of the cities',
   'List of the cities in which at least one customer lives',
   'select distinct City from CUSTOMER'
);

insert into EXERCISE values(
   'Q01-04',
   'ORDERS.db',
   'basic',1,1,'Cities of ''C1'' customers',
   'List of the cities in which at least one customer of category ''C1'' lives',
   'select distinct City from CUSTOMER where Cat = ''C1'''
);

insert into EXERCISE values(
   'Q01-05',
   'ORDERS.db',
   'basic',1,1,'Customers with orders',
   'List the Ids of the customers who passed at least one order',
   'select distinct CustID from CUSTORDER'
);

insert into EXERCISE values(
   'Q01-06',
   'ORDERS.db',
   'basic',1,1,'Customers with unknown category',
   'List the data of the customers the category of which is unknown',
   'select * from CUSTOMER where Cat is null'
);

insert into EXERCISE values(
   'Q01-07',
   'ORDERS.db',
   'basic',1,1,'Customers of category ''C1'', ''C2'' or ''C3''',
   'List the data of the customers with category ''C1'', ''C2'' or ''C3''',
   'select * from CUSTOMER where Cat in (''C1'',''C2'',''C3'')'
);

insert into EXERCISE values(
   'Q01-08',
   'ORDERS.db',
   'basic',1,1,'Customers with account from 1000 to 4000',
   'List the data of the customers whose account is from 1000 to 4000',
   'select * from CUSTOMER where Account between 1000 and 3000'
);

insert into EXERCISE values(
   'Q01-09',
   'ORDERS.db',
   'basic',1,1,'Customers with category ?1',
   'List the data of the customers with category ending with ''1''',
   'select * from CUSTOMER where Cat like ''_1'''
);

insert into EXERCISE values(
   'Q01-10',
   'ORDERS.db',
   'basic',1,1,'Customers with address including ''Neuve''',
   'List the data of the customers, whose address
    includes the word ''Neuve''',
   'select * from CUSTOMER where Address like ''%Neuve%'''
);

insert into EXERCISE values(
   'Q01-11',
   'ORDERS.db',
   'basic',2,2,'Customers whose address includes ''Neuve'' (case insensitive)',
   'List the data of the customers
    whose address includes the word ''Neuve'',
    or ''neuve'', or ''NEUVE'', etc.',
   'select * from CUSTOMER where lower(Address) like ''%neuve%'''
);

insert into EXERCISE values(
   'Q01-12',
   'ORDERS.db',
   'basic',2,3,'Customers with category ''C1'' not in Toulouse',
   'List the Id, name and city of the customers of category ''C1''
    who do not live in Toulouse',
   'select CustID, Name, City from CUSTOMER where Cat = ''C1'' and City <> ''Toulouse'''
);

insert into EXERCISE values(
   'Q01-13',
   'ORDERS.db',
   'basic',2,2,
   'Orders of a list of customers',
   'List the data of the orders of customers ''C123'', ''S127'', ''B062'' and ''L422''.',
   'select * from CUSTORDER where CustID in (''C123'',''S127'',''B062'',''L422'')'
);


-- =========================== SUB QUERY ============================== --

insert into EXERCISE values(
   'Q02-01',
   'ORDERS.db',
   'sub-query',1,3,
   'Orders from a city',
   'Display the information (Id and date) on the orders
    of the customers in Poitiers',
   'select OrdID,DateOrd from CUSTORDER where CustID in 
   (select CustID from CUSTOMER where City = ''Poitiers'')'
);

insert into EXERCISE values(
   'Q02-02',
   'ORDERS.db',
   'sub-query',2,4,
   'Products ordered in a city',
   'Display the data on the products ordered by customers living in Poitiers',
   'select * from PRODUCT
    where  ProdID in (select ProdID from DETAIL
    where  OrdID in (select OrdID from CUSTORDER
    where  CustID in (select CustID from CUSTOMER 
    where  City=''Poitiers'')))'
);

insert into EXERCISE values(
   'Q02-03',
   'ORDERS.db',
   'sub-query',2,4,
   'Customers with an account higher than that of another customer',
   'Display the data of the customers the account of which is higher than that of customer ''C400''',
   'select * from CUSTOMER where Account > (select Account from CUSTOMER where CustID = ''C400'')'
);

insert into EXERCISE values(
   'Q02-04',
   'ORDERS.db',
   'sub-query',2,4,
   'Orders that do not reference a product',
   'List the data of orders that do not reference product ''PA60''',
   'select OrdID,DateOrd,CustID from CUSTORDER
    where  OrdID not in (select OrdID from DETAIL where  ProdID = ''PA60'')'
);

insert into EXERCISE values(
   'Q02-05',
   'ORDERS.db',
   'sub-query',2,5,
   'Orders referencing products other than PA60',
   'Display the data of the orders that reference at least one product different from ''PA60''',
   'select OrdID,DateOrd,CustID from CUSTORDER where OrdID in (select OrdID from DETAIL where ProdID <> ''PA60'')'
);

insert into EXERCISE values(
   'Q02-06',
   'ORDERS.db',
   'sub-query',2,5,
   'Customers living in Poitiers and inactive in 2015',
   'Display the informations on the customers in Poitiers who have not placed any order in 2015',
   'select * from  CUSTOMER where City = ''Poitiers''
    and   CustID not in (select CustID from CUSTORDER where DateOrd like ''2015%'')'
);

insert into EXERCISE values(
   'Q02-07',
   'ORDERS.db',
   'sub-query',2,5,
   'Customers whose account is greater than the average of their city',
   'Display the list of the Id of the customers whose account is greater than the average account of the customers of their city.',
   'select CustID,Name,City,Account from CUSTOMER as CUST
    where  Account > (select avg(Account) from CUSTOMER where City = CUST.City)'
);

insert into EXERCISE values(
   'Q02-08',
   'ORDERS.db',
   'sub-query',2,5,
   'Orders having at least 3 details',
   'Display the data of the orders that comprise at least 3 details.',
   'select OrdID,DateOrd from CUSTORDER C
    where (select count(*) from DETAIL where OrdID = C.OrdID) >= 3'
);

insert into EXERCISE values(
   'Q02-09',
   'ORDERS.db',
   'sub-query',3,5,
   'Products referenced by at least one order',
   'Display the id and the description of the products referenced by at least one order.',
   'select ProdID,Description from PRODUCT as P 
    where exists (select * from DETAIL where ProdID = P.ProdID)'
);

insert into EXERCISE values(
   'Q02-10',
   'ORDERS.db',
   'sub-query',3,6,
   'Orders with a quantity higher than the minimum',
   'Display the id and product id of the details that order more than the minimal quantity ordered for this product',
   'select OrdID,ProdID from DETAIL 
    where Qord > (select min(Qord) from DETAIL
    where ProdID = ''PA60'') and ProdID = ''PA60'''
);

insert into EXERCISE values(
   'Q02-11',
   'ORDERS.db',
   'sub-query',3,4,
   'Where do people order this product?',
   'List the cities in which some customers have ordered product ''CS464''',
   'select distinct City from CUSTOMER where CustID in (select CustID from CUSTORDER
    where  OrdID in (select OrdID from DETAIL where ProdID = ''CS464''))'
);

insert into EXERCISE values(
   'Q02-14',
   'ORDERS.db',
   'sub-query',2,4,
   '''Pine'' product that have been ordered',
   'What are the id of the ''pine'' products that have been ordered?',
   'select ProdID from PRODUCT where Description like ''%PINE%'' and ProdID in (select ProdID from DETAIL)'
);

insert into EXERCISE values(
   'Q02-15',
   'ORDERS.db',
   'sub-query',2,4,
   'How many orders referencing ''steel'' product?',
   'How many orders do reference one or several ''steel'' products?',
   'select count(*) as Number from CUSTORDER where OrdID 
    in (select OrdID from DETAIL where ProdID
    in (select ProdID from PRODUCT where Description like ''%STEEL%''))'
);

insert into EXERCISE values(
   'Q02-16',
   'ORDERS.db',
   'sub-query',3,5,
   'Customers who do not order ''pine'' products',
   'Display the id and name of the customers who have not ordered ''pine'' products',
   'select CustID,Name from CUSTOMER where CustID not in (select CustID
    from CUSTORDER where OrdID in (select OrdID from DETAIL where ProdID in
    (select ProdID from PRODUCT where Description like ''%PINE%'')))'
);

insert into EXERCISE values(
   'Q02-17',
   'ORDERS.db',
   'sub-query',3,5,
   'Products that have not been ordered in 2015',
   'Display the id and description of the products that have not been ordered in 2015',
   'select ProdID, Description from PRODUCT where ProdID
    not in (select ProdID from DETAIL where  OrdID 
    in (select OrdID from CUSTORDER where DateOrd like ''%2015%''))'
);

insert into EXERCISE values(
   'Q02-18',
   'ORDERS.db',
   'sub-query',3,4,
   'Cities without orders',
   'Display the name of the city in which no customer has ever ordered any product',
   'select distinct City from CUSTOMER where City
    not in (select City from CUSTOMER C where exists 
    (select * from CUSTORDER where  CustID = C.CustID))'
);

insert into EXERCISE values(
   'Q02-19',
   'ORDERS.db',
   'sub-query',4,6,
   'Cities in which all the customers have placed orders',
   'Display the name of the cities in which all the customers have placed at least one order.',
   'select distinct City from CUSTOMER C where not exists 
    (select * from CUSTOMER where City = C.City and
    CustID not in (select CustID from CUSTORDER))'
);


-- =========================== 3. JOIN ============================== --

insert into EXERCISE values(
   'Q03-01',
   'ORDERS.db',
   'join',1,3,
   'Orders completed by their customer data',
   'Display the data of all the orders, augmented with data (Name, City) of their customer.',
   'select OrdID,CUSTOMER.CustID,DateOrd,Name,City from CUSTORDER, CUSTOMER where CUSTORDER.CustID = CUSTOMER.CustID'
);

insert into EXERCISE values(
   'Q03-02',
   'ORDERS.db',
   'join',1,3,
   'Details completed by data of their order and customer',
   'Display the data of all de details, augmented with data from their order and their customer (name and city).',
   'select CUSTOMER.CustID,Name,City,DateOrd,ProdID,Qord from CUSTOMER,CUSTORDER,DETAIL where CUSTOMER.CustID = CUSTORDER.CustID and CUSTORDER.OrdID = DETAIL.OrdID'
);

insert into EXERCISE values(
   'Q03-03',
   'ORDERS.db',
   'join',2,4,
   'Commandes antrieures  une date de clients d''une catgorie',
   'Display the data of the orders placed before December 31, 2015 by customers of category C1, augmented with the data of their customer',
   'select OrdID,CUSTOMER.CustID,DateOrd,Name,Address from CUSTORDER, CUSTOMER where CUSTORDER.CustID = CUSTOMER.CustID and Cat = ''C1'' and DateOrd < ''2015-12-31'''
);

insert into EXERCISE values(
   'Q03-04',
   'ORDERS.db',
   'join',4,5,
   'Orders with details on their customer + customers without order',
   'Display the data of the orders, to which name and city of their customer are added. Add the same data of the customer who have not placed any order. Express this query as the union of two simple queries',
   'select OrdID,CUSTOMER.CustID as CustID,DateOrd,Name,City from CUSTORDER, CUSTOMER where CUSTORDER.CustID = CUSTOMER.CustID union select null as OrdID,CustID,null as DateOrd,Name,City from CUSTOMER where not exists (select * from CUSTORDER where CustID = CUSTOMER.CustID) order by CustID,OrdID'
);

insert into EXERCISE values(
   'Q03-05',
   'ORDERS.db',
   'join',3,5,
   'Commandes compltes des informations sur leurs clients + clients sans commande (jointure externe)',
   'Afficher les informations sur les commandes compltes des informations sur leurs clients. Y ajouter une ligne par client qui n''a pas pass de commande. Exprimer la mme requte sous la forme d''une jointure externe.',
   'select OrdID,C.CustID,DateOrd,Name,City from CUSTOMER C left outer join CUSTORDER M on (M.CustID = C.CustID) order by C.CustID,OrdID'
);

insert into EXERCISE values(
   'Q03-06',
   'ORDERS.db',
   'join',2,3,
   'Each order associated to each customer',
   'Display an array composed of each customer associated to each order (even those that are not placed by the customer)',
   'select OrdID,CUSTORDER.CustID,CUSTOMER.CustID,DateOrd,Name,Address from CUSTORDER,CUSTOMER'
);

insert into EXERCISE values(
   'Q03-07',
   'ORDERS.db',
   'join',3,4,
   'Each city associated to each product',
   'Display an array composed of each city associated to each product (even though this product has not been ordered by customers of this city)',
   'select distinct City, ProdID from CUSTOMER,PRODUCT order by City,ProdID'
);

insert into EXERCISE values(
   'Q03-08',
   'ORDERS.db',
   'join',3,4,
   'Each city associated to each product ordered in this city',
   'Display an array composed of each city associated to each product ordered by customers of this city',
   'select distinct City,ProdID from CUSTOMER C,CUSTORDER M,DETAIL D where  C.CustID=M.CustID and M.OrdID=D.OrdID order by City,ProdID'
);

insert into EXERCISE values(
   'Q03-09',
   'ORDERS.db',
   'join',4,5,
   'Each city associated to each product not ordered in this city',
   'Display an array composed of each city associated to each product that is NOT ordered by customers of this city',
   'select City, ProdID from CUSTOMER, PRODUCT except select City,ProdID from CUSTOMER C,CUSTORDER M,DETAIL D where C.CustID=M.CustID and M.OrdID=D.OrdID order by City,ProdID'
);

insert into EXERCISE values(
   'Q03-10',
   'ORDERS.db',
   'join',1,3,
   '"Natural join" operator',
   'Express the following query with a "natural join" operator:
   \nselect CustID,Name,OrdID,DateOrd \nfrom CUSTOMER C, CUSTORDER M where C.CustID = M.OrdID',
   'select * from CUSTOMER natural join CUSTORDER'
);

insert into EXERCISE values(
   'Q03-11',
   'ORDERS.db',
   'join',1,3,
   '"Inner join" operator',
   'Express the following query with an "inner join" operator:
   \nselect CustID,Name,OrdID,DateOrd \nfrom CUSTOMER C, CUSTORDER M where C.CustID = M.OrdID',
   'select * from CUSTOMER inner join CUSTORDER using (CustID)'
);

insert into EXERCISE values(
   'Q03-12',
   'ORDERS.db',
   'join',1,3,
   '"join" operator',
   'Express the following query with a "join" operator:
   \nselect CustID,Name,OrdID,DateOrd \nfrom CUSTOMER C, CUSTORDER M where C.CustID = M.OrdID',
   'select * from CUSTOMER C join CUSTORDER M on (C.CustID = M.CustID)'
);

insert into EXERCISE values(
   'Q03-13',
   'ORDERS.db',
   'join',2,5,
   'Multiple "join" operator',
   'Express the following query with "join" operators:
    \nselect *
    \nfrom   CUSTOMER C,CUSTORDER M, DETAIL D,PRODUCT P
    \nwhere  C.CustID = M.CustID
    \nand    M.OrdID = D.OrdID
    \nand    D.ProdID = P.ProdID',
   'select * from CUSTOMER C join CUSTORDER M on (C.CustID = M.CustID) join DETAIL D on (M.OrdID = D.OrdID) join PRODUCT P on (D.ProdID = P.ProdID)'
);

insert into EXERCISE values(
   'Q03-14',
   'ORDERS.db',
   'join',2,3,
   'Orders of a city through a "join" operator',
   'Display the Id and date of orders of customers of ''Poitiers''. Extract data through a join',
   'select OrdID,DateOrd from CUSTORDER, CUSTOMER where CUSTORDER.CustID = CUSTOMER.CustID and City = ''Poitiers'''
);

insert into EXERCISE values(
   'Q03-15',
   'ORDERS.db',
   'join',4,5,
   'Orders specifying a quantity below that of another order',
   'Which are the orders that specify a quantity of product ''PA60'' below that of order 30182? Use joins.',
   'select distinct M.OrdID, DateOrd, CustID from CUSTORDER M, DETAIL D1, DETAIL D2 where M.OrdID = D1.OrdID and D1.ProdID = ''PA60'' and D2.OrdID = ''30182'' and D2.ProdID = ''PA60'' and D1.Qord < D2.Qord'
);

insert into EXERCISE values(
   'Q03-16',
   'ORDERS.db',
   'join',3,4,
   'Orders specifying products other than ''PA60''',
   'Using joins, list the orders that specify at least one product other than ''PA60''.',
   'select distinct CUSTORDER.OrdID, DateOrd, CustID from CUSTORDER, DETAIL where CUSTORDER.OrdID <> DETAIL.OrdID and ProdID = ''PA60'''
);

insert into EXERCISE values(
   'Q03-17',
   'ORDERS.db',
   'join',3,4,
   'Customers who have placed no order',
   'List the id and name of all the customers who have placed no order. Use an outer join instead of a sub-query.',
   'select C.CustID,Name from CUSTOMER C left outer join CUSTORDER M on (C.CustID = M.CustID) where  M.OrdID is null'
);

insert into EXERCISE values(
   'Q03-18',
   'ORDERS.db',
   'join',3,4,
   'Amount of each detail',
   'Compute the amount of each detil of all the orders.',
   'select OrdID, D.ProdID, Qord*Price as Amount from DETAIL D, PRODUCT P where D.ProdID = P.ProdID'
);

insert into EXERCISE values(
   'Q03-19',
   'ORDERS.db',
   'join',3,4,
   'Amount of an order',
   'What is the total amount of order 30184?',
   'select sum(Qord*Price) as Amount from  DETAIL D, PRODUCT P where  D.OrdID = ''30184'' and D.ProdID = P.ProdID'
);

insert into EXERCISE values(
   'Q03-20',
   'OFFRE.db',
   'join',2,4,
   'Prix de chaque produit dans chaque ville',
   'Produire un tableau indiquant  quel prix chaque produit est vendu dans chaque ville.',
   'select distinct PRODUCT,VILLE,Price from VENTE V, IMPLANTATION I where V.CHAINE = I.CHAINE order by PRODUCT,VILLE'
);

insert into EXERCISE values(
   'Q03-21',
   'CLICOM-2.db',
   'join',3,5,
   'Code of the Account of each customer',
   'We consider database "CLICOM-2.db" wich is an extension of "CLICOM.db", the French version of "ORDERS.db". It includes table CLASSE_CPT, which assigns to account intervals [MIN_CPT,MAX_CPT[ code CODE_CPT. Exercise: associate with each customer of ''C1'' category (Id, Name) the CODE_CPT value assigned to the value of COMPTE.',
   'select NCLI, NOM, CODE_CPT from CLIENT, CLASSE_CPT where CAT = ''C1'' and COMPTE >= MIN_CPT and COMPTE < MAX_CPT order by NCLI'
);

insert into EXERCISE values(
   'Q03-22',
   'ORDERS.db',
   'join',3,4,
   'Amount of the details of a customer',
   'Compute the amount of each detail of customer ''C400''',
   'select D.OrdID, P.ProdID, Qord*Price as AMOUNT from CUSTORDER M, DETAIL D, PRODUCT P where D.OrdID = M.OrdID and D.ProdID = P.ProdID and CustID = ''C400'''
);

insert into EXERCISE values(
   'Q03-23',
   'ORDERS.db',
   'join',3,4,
   'Total amount of ordered "pine" products',
   'Compute the total amount of "pine" products that have been ordered.',
   'select sum(Qord*Price) as AMOUNT from DETAIL D,PRODUCT P where D.ProdID = P.ProdID and P.Description like ''%SAPIN%'''
);

insert into EXERCISE values(
   'Q03-24',
   'ORDERS.db',
   'join',3,4,
   'Count the orders that reference "steel" products',
   'How many orders reference one or more "steel" products? Express this query with joins.',
   'select count(distinct M.OrdID) as Nbr from CUSTORDER M, DETAIL D, PRODUCT P where M.OrdID = D.OrdID and D.ProdID = P.ProdID and Description like ''%STEEL%'''
);

insert into EXERCISE values(
   'Q03-25',
   'ORDERS.db',
   'join',4,6,
   'Total amount of each customer',
   'Show the total amount of the orders of each customer. Don''t forget the customers who placed no order.',
   'select CustID, sum(Qord*Price) as "Amount" from CUSTORDER M, DETAIL D, PRODUCT P where M.OrdID = D.OrdID and D.ProdID = P.ProdID group by CustID union select CustID, 0 from CUSTOMER C where not exists (select * from CUSTORDER where CustID = C.CustID)'
);

insert into EXERCISE values(
   'Q03-26',
   'ORDERS.db',
   'join',4,6,
   'Customer categories not present in cities',
   'List, for each city, the customer categories in which there is no representative. \nSuggestion : build the set of all possible (City,Cat) couples then remove from it the couples that exist in the database. Take care of null values.',
   'select distinct L.City, C.Cat from CUSTOMER L, CUSTOMER C where C.Cat is not null and not exists (select * from  CUSTOMER where City = L.City and Cat = C.Cat)'
);

if ($encode$) update EXERCISE set RefQuery = b64encode(RefQuery,'std');

commitDB;

