-- ----------------------- --
-- Compute metrics         --
-- ----------------------- --

-- --------------------------------------------------------- --
-- Student's query: compute "xN", the size of the result set --
-- --------------------------------------------------------- --
onError continue;
   extract xN = select count(1) from ($xQuery$);
onError stop;

-- Syntactic evaluation of student's query --
if ('$SQLdiag$' not in ('OK','NONE'));
   set status = 2;
   set xDiag = @S4Error detected in your SQL query.
               \n@S4For more detail, ask for its execution then modify it.;
endif;

-- --------------------------------------------------------- --
-- Reference query: compute "rN", the size of the result set --
-- --------------------------------------------------------- --
if ($status$ = 0);
   onError continue;
      extract rN  = select count(1) from ($rQuery$);
   onError stop;
   if ('$SQLdiag$' not in ('OK','NONE'));
      set status = 3;
      set xDiag = @S4ALERT: the reference SQL query is incorrect.
                  \n@S4Please inform the instructor.;
   endif;
endif;

-- --------------------------------------------------------- --
-- Compare result sets: compute "N12" and "N21"              --
-- --------------------------------------------------------- --

if ($status$ = 0);
   -- views are necessary to cope with queries based on set operations --
   create temp view _xview_ as select * from ($xQuery$);
   create temp view _rview_ as select * from ($rQuery$);

   if ($status$ = 0);
      onError continue;
         extract N12 = select count(1) from (select * from _rview_
                                             except 
                                             select * from _xview_);
      onError stop;
      if ('$SQLdiag$' not in ('OK','NONE'));
         set status = 4;
         set xDiag = @S4Error detected in your SQL query. Cause: $SQLdiag$.
                      \n@S4Modify your answer.;
      endif;
   endif;

   if ($status$ = 0);
      onError continue;
         extract N21 = select count(1) from (select * from _xview_
                                             except 
                                             select * from _rview_);
      onError stop;
      if ('$SQLdiag$' not in ('OK','NONE'));
         set status = 4;
         set xDiag = @S4Error detected in your SQL query. Cause: $SQLdiag$.
                     \n@S4Modify your answer.;
      endif;
   endif;
endif;

-- ---------------------------------------------------------
-- USES
-- ---------------------------------------------------------
--  - status: error code (0)
--  - xQuery: student's query
--  - rQuery: reference query
-- ---------------------------------------------------------
-- RETURNS
-- ---------------------------------------------------------
--  - xN: size of the result set of student's query
--  - rN: size of the result set of reference query
--  - N12: 
--  - N21: 
--  - xDiag: explicit diagnostic
--  - status: error code (0 or > 0)
-- ---------------------------------------------------------
