-- ----------------------------------------------- --
-- Evaluating the solution provided by the student --
-- ----------------------------------------------- --

-- Uses: rN  = size of reference result set
--       xN  = size of student's result set
--       N12 = size of [reference] - [student]
--       N21 = size of [student] - [reference]
-- Returns: status (only 0 and > 0 values matter), xDiag

set xDiag = ;
if ($rN$ = 0)
   set xDiag = @S4ATTENTION: the result set of the reference query is empty.
               @n@S4The evaluation may be imprecise!@n;

if ($N12$ + $N21$ = 0);
   -- No row missing --
   if ($xN$ = $rN$);
      -- No row missing, same size --
      set xDiag = $xDiag$
                  @S4The result set of your query is that of the reference query.
                  @n@S4Your query SEEM to be correct but this may be by chance!
                  @n@S4To be sure, compare your query:;
      function ppxQuery = LStr:PrettyPrint {$xQuery$},@n@S7;
      set xDiag = $xDiag$
                  @n@n@S7$ppxQuery$
                  @n@n@S4... with the reference query:;
      function pprQuery = LStr:PrettyPrint {$rQuery$},@n@S7;
      set xDiag = $xDiag$
                  @n@n@S7$pprQuery$;
   else;
      -- No row missing, some duplicates --
      set xDiag = $xDiag$
                  @S4The result set of your query is that of the reference query.
                  @n@S4However, one of them includes duplicate rows.
                  @n@S4Modify your answer.;
      set status = 5;
   endif;
else;
   if ($N12$ > 0 and $N21$ = 0)
      set xDiag = @S4Your answer is incorrect.
                  @n@S4Some rows are missing in your result set.;
   if ($N12$ = 0 and $N21$ > 0)
      set xDiag = @S4Your answer is incorrect.
                  @n@S4Your result set includes erroneous rows.;
   if ($N12$ > 0 and $N21$ > 0);
      if ($rN$ = $N12$)
         set xDiag = @S4Your answer is incorrect.
                     @n@S4All the rows of your result set are erroneous.;
      if ($rN$ > $N12$)
         set xDiag = @S4Your answer is incorrect.
                     @n@S4Some rows of your result set (but not all) are erroneous.;
   endif;

   set status = 6;

endif;
