-- Static loading --
-- -------------- --

openDB CLICOM.db;

create temp table CLI(NCLI     char(10) not null primary key,
                      NOM      char(20) not null,
                      LOCALITE char(20) not null,
                      CAT      char(2),
                      COMPTE   decimal(10,2) not null);

start-timer;
for N = [1,5000]
   insert into CLI select '$N$'||NCLI,NOM,LOCALITE,CAT,COMPTE from CLIENT;
write Static time = $timer$;
select count(*) from CLI;

closeDB;


-- Dynamic loading --
-- --------------- --

openDB CLICOM.db;

set dynaColumns = 1;

create temp table CLI(NCLI char(10) not null primary key);

start-timer;
for N = [1,5000]
   insert into CLI(NCLI,!NOM,!LOCALITE,!CAT,!COMPTE)
       select $N$||NCLI, NOM, LOCALITE, CAT, COMPTE from CLIENT;

write Dynamic time = $timer$;
--select count(*) from CLI;
--select * from CLI #[1,16];
--select NCLI, !NOM, !LOCALITE, !CAT, !COMPTE from CLI #[1,16];

closeDB;