-- ------------------------- --
-- The Universal table model --
-- ------------------------- --

write-b -- ------------------------ --;
write   -- Universal table model    --;
write   -- ------------------------ --;

openDB ORDERS.db;

create temp table if not exists DATA(
   Entity      integer not null primary key autoincrement,
   EType       char(18) not null,
   CustID      char(10),
   Name        char(32),
   Address     char(60),
   City        char(30),
   Cat         char(2),
   Account     decimal(9,2),
   OrdID       char(12),
   DateOrd     date,
   Qord        integer,
   ProdID      char(15),
   Description char(60),
   Price       integer,
   QonHand     integer)

insert into DATA(EType,CustID,Name,Address,City,Cat,Account)
   select 'CUST',CustID,Name,Address,City,Cat,Account from CUSTOMER;
insert into DATA(EType,OrdID,CustID,DateOrd)
   select 'ORD',OrdID,CustID,DateOrd from CUSTORDER;
insert into DATA(EType,OrdID,ProdID,Qord)
   select 'DET',OrdID,ProdID,Qord from DETAIL;
insert into DATA(EType,ProdID,Description,Price,QonHand)
   select 'PROD',ProdID,Description,Price,QonHand from PRODUCT;

write-b -- The Universal table of ORDERS.db --;
select * from DATA;

write-b -- Reconstruction of table CUSTOMER --;
--create temp view V_CUSTOMER(CustID,Name,Address,City,Cat,Account) as
select  CustID,Name,Address,City,Cat,Account
from    DATA where EType = 'CUST';

write-b -- Reconstruction of table PRODUCT --;
--create temp view V_PRODUCT(ProdID,Description,Price,QonHand) as
select  ProdID,Description,Price,QonHand
from    DATA where EType = 'PROD';

write-b -- Reconstruction of table CUSTORDER --;
--create temp view V_CUSTORDER(OrdID,CustID,DateOrd) as
select  OrdID,CustID,DateOrd
from    DATA where EType = 'ORD';

write-b -- Reconstruction of table DETAIL --;
--create temp view V_DETAIL(OrdID,ProdID,Qord) as
select  OrdID,ProdID,Qord
from    DATA where EType = 'DET';


write-b -- Join of CUSTOMER and CUSTORDER --;
select  CustID,Name,Address,City,OrdID,DateOrd
from    DATA 
where   EType in ('CUST','ORD')
and     CustID = 'C400';

select  C.CustID,C.Name,C.Address,C.City,O.OrdID,O.DateOrd
from    DATA C, DATA O
where   C.EType = 'CUST'
and     O.EType = 'ORD'
and     C.CustID = 'C400'
and     O.CustID = C.CustID;

closeDB;
