-- -------------------------- --
-- Inter-City_Solver.sql --
-- -------------------------- --

write-b -- --------------------------------------------------------- --;
write   -- The map used as the first example in the text is "Map 1"  --;
write   -- It is loaded by script "_Inter-City_Loader#1.sql"         --;
write   -- Same for the other 3 maps                                 --;
write   -- --------------------------------------------------------- --;

set displayGRAPH = 1;
set displayNODE  = 1;

createDB InMemory;

-- Create the model database --
-- ------------------------- --
execSQL $sourceDir$/__Shortest-path_DB.sql;

-- Load an inter-city map  --
-- ----------------------- --
ask map = [/bSelect an inter-city map] Map:[(Map 1,Map 2,Map 3,Map 4)];
compute mapNum = substr('$map$',5,1);
execSQL $sourceDir$/_Inter-City_Loader#$mapNum$.sql;

-- Display table GRAPH --
-- ------------------ --
if ($displayGRAPH$) execSQL $sourceDir$/__Display_Graph.sql;

-- Select starting and target nodes --
-- -------------------------------- --
set start = ;
set end = ;
ask start,end = Starting node:[!select Name,NodeID from NODE order by Name]
               |Target node:[!select Name,NodeID from NODE order by Name];
   if ('$DIALOGbutton$' = 'Cancel' or '$start$' = '') stop;

-- Initialize the starting node --
-- ---------------------------- --
update NODE set Mark = 0, Cost = 0, Path = Name where NodeID = '$start$';

-- Solve the shortest path model --
-- ----------------------------- --
execSQL $sourceDir$/__Shortest-path_Engine.sql;

-- Display the shortest path --
-- ------------------------- --
execSQL $sourceDir$/__Display_Shortest-path.sql;

-- Display table NODE --
-- ------------------ --
if ($displayNODE$) execSQL $sourceDir$/__Display_Nodes.sql

closeDB;
