
extract N = select count(1) from NODE;

set-n neighbors = select Node2 from PATH
                  where  Node1 = S and (select Mark from NODE where NodeID = Node2) = 0;
set-n newCost  = (select Cost1 + Cost from ExtPATH 
                  where  Node1 = S and Node2 = NODE.NodeID);

start-timer;
for step = [1,$N$];

   -- Select S = one of the external node with minimal cost --
   extract S = select NodeID from EXTERNAL
               where  Cost = (select min(Cost) from EXTERNAL);

   -- Update the cost of external neighbours of S --
   update NODE
   set    Cost = min(Cost,$newCost$),
          Path = case when Cost > $newCost$
                      then (select Path from NODE where NodeID = S)||'.'||Name
                      else Path
                 end
   where  NodeID in ($neighbors$);

   -- Make S "internal" --
   update NODE set Mark = 1 where NodeID = S;

endfor;

write-b Model solved in $timer$ s.;

