
write-b -- ---------------------------------------------------------- --;
write   -- TEMPORAL PROJECTION                                        --;
write   -- Applicable to valid and transaction time databases         --;
write-a -- ---------------------------------------------------------- --;

openDB TDB.db;

-- Identify transaction vs valid time data --
extract N = select count(*) from H_EMPLOYEE;
if ($N$ > 0);
   extract T = select typeof(start) from H_EMPLOYEE limit 1;
   if ('$T$' = 'int')  set future = 999999;
   if ('$T$' = 'char') set future = '9999-12-31';
else;
   showMessage Database empty.@nOperation aborted.;
endif;


write-b -- Standard projection PROJECT[TITLE,THEME]             --;
write-a -- ---------------------------------------------------- --;

select TITLE,THEME
from   PROJECT;

write-b -- Temporal projection H_PROJECT[TITLE,THEME]           --;
write   -- First trial: not convincing!                         --;
write-a -- ---------------------------------------------------- --;

select TITLE,THEME,start,end
from   H_PROJECT
group by TITLE,start;

write-b -- Temporal projection H_PROJECT[TITLE,THEME]           --;
write   -- Second trial: worse!                                 --;
write-a -- ---------------------------------------------------- --;

select TITLE,THEME,min(start) as "Start",max(end) as "End"
from   H_PROJECT
group by TITLE,THEME;

write-b -- Temporal projection H_PROJECT[TITLE,THEME]           --;
write   -- Now, that's correct:                                 --;
write-a -- ---------------------------------------------------- --;

select P1.TITLE, P1.THEME, P1.start, Pn.end
from   H_PROJECT P1, H_PROJECT Pn
where  (P1.TITLE,P1.THEME)=(Pn.TITLE,Pn.THEME)
and    P1.start <= Pn.start
and not exists (select * from H_PROJECT P0
                where  (P0.TITLE,P0.THEME)=(P1.TITLE,P1.THEME)
                and    P0.end = P1.start)
and not exists (select * from H_PROJECT Pm
                where  (Pm.TITLE,Pm.THEME)=(P1.TITLE,P1.THEME)
                and    Pn.end = Pm.start)
and not exists (select * from H_PROJECT Pi
                where  Pi.TITLE = P1.TITLE
                and    Pi.THEME <> P1.THEME
                and    P1.end <= Pi.start
                and    Pi.end <= Pn.start)
order by P1.TITLE,P1.start;


write-b -- ---------------------------------------------------- --;
write   -- Now we show that this simple algorithm doesn't work  --;
write   -- when the entity identifier is missing                --;
write   -- ---------------------------------------------------- --;

write-b -- Tentative projection H_EMPLOYEE[CITY,PROJECT]        --;
write-a -- ---------------------------------------------------- --;

select P1.CITY, P1.PROJECT, P1.start, Pn.end
from   H_EMPLOYEE P1, H_EMPLOYEE Pn
where  P1.CITY=Pn.CITY and P1.PROJECT=Pn.PROJECT
and    P1.start <= Pn.start
and not exists (select * from   H_EMPLOYEE P0
                where  P0.CITY=P1.CITY and P0.PROJECT=P1.PROJECT
                and    P0.end = P1.start)
and not exists (select * from   H_EMPLOYEE Pm
                where  Pm.CITY=P1.CITY and Pm.PROJECT=P1.PROJECT
                and    Pm.end = Pm.start)
and not exists (select * from   H_EMPLOYEE Pi
                where  Pi.CITY<>P1.CITY or Pi.PROJECT<>P1.PROJECT
                and    P1.end <= Pi.start
                and    Pi.end <= Pn.start)
order by P1.CITY,P1.PROJECT,P1.start;

write-b -- We also show that this doesn't work either           --;
write   -- for tentative projection H_EMPLOYEE[CITY]            --;
write-a -- ---------------------------------------------------- --;

select P1.CITY, P1.start, Pn.end
from   H_EMPLOYEE P1, H_EMPLOYEE Pn
where  P1.CITY=Pn.CITY
and    P1.start <= Pn.start
and not exists (select * from H_EMPLOYEE P0
                where  P0.CITY=P1.CITY and P0.end = P1.start)
and not exists (select * from H_EMPLOYEE Pm
                where  Pm.CITY=P1.CITY and Pn.end = Pm.start)
and not exists (select * from H_EMPLOYEE Pi
                where  Pi.CITY<>P1.CITY
                and    P1.end <= Pi.start and Pi.end <= Pn.start)
order by P1.CITY,P1.start;


write-b -- ---------------------------------------------------- --;
write   -- Using the general algorithm - Predicative expression --;
write   -- ---------------------------------------------------- --;

write-b -- Projection H_PROJECT[TITLE,THEME]                    --;
write   -- (entity identifier INCLUDED)                         --;
write-a -- ---------------------------------------------------- --;

select distinct E1.TITLE, E1.THEME, E1.start, En.end
from   H_PROJECT E1, H_PROJECT En
where  E1.TITLE=En.TITLE and E1.THEME=En.THEME
and    E1.start <= En.start and E1.end <= En.end
and not exists (select *
                from   H_PROJECT E0
                where  E0.TITLE=E1.TITLE and E0.THEME=E1.THEME
                and    E0.start < E1.start
                and E0.end >= E1.start)
and not exists (select *
                from   H_PROJECT Em
                where  Em.TITLE=E1.TITLE and Em.THEME=E1.THEME
                and    Em.start <= En.end
                and    Em.end > En.end)
and not exists (select *
                from   H_PROJECT Eg
                where  Eg.TITLE=E1.TITLE and Eg.THEME=E1.THEME
                and    E1.end <= Eg.end
                and    Eg.end <  En.start
                and    not exists(select *
                                  from   H_PROJECT Ek
                                  where  Ek.TITLE=E1.TITLE and Ek.THEME=E1.THEME
                                  and    Eg.end   <  Ek.end
                                  and    Ek.start <= Eg.end));


write-b -- Projection H_EMPLOYEE[CITY,PROJECT]                  --;
write   -- (entity identifier EXCLUDED)                         --;
write-a -- ---------------------------------------------------- --;

select distinct E1.CITY, E1.PROJECT, E1.start, En.end
from   H_EMPLOYEE E1, H_EMPLOYEE En
where  E1.CITY=En.CITY and E1.PROJECT=En.PROJECT
and    E1.start <= En.start and E1.end <= En.end
and not exists (select *
                from   H_EMPLOYEE E0
                where  E0.CITY=E1.CITY and E0.PROJECT=E1.PROJECT
                and    E0.start < E1.start
                and    E0.end  >= E1.start)
and not exists (select *
                from   H_EMPLOYEE Em
                where  Em.CITY=E1.CITY and Em.PROJECT=E1.PROJECT
                and    Em.start <= En.end
                and    Em.end   >  En.end)
and not exists (select *
                from   H_EMPLOYEE Eg
                where  Eg.CITY=E1.CITY and Eg.PROJECT=E1.PROJECT
                and    E1.end <= Eg.end
                and    Eg.end <  En.start
                and    not exists(select *
                                  from   H_EMPLOYEE Ek
                                  where  Ek.CITY=E1.CITY and Ek.PROJECT=E1.PROJECT
                                  and    Eg.end   <  Ek.end
                                  and    Ek.start <= Eg.end))
order by E1.CITY,E1.PROJECT,E1.start;

write-b -- Projection H_EMPLOYEE[CITY]                          --;
write   -- (entity identifier EXCLUDED)                         --;
write-a -- ---------------------------------------------------- --;

select distinct E1.CITY, E1.start, En.end
from   H_EMPLOYEE E1, H_EMPLOYEE En
where  E1.CITY=En.CITY
and    E1.start <= En.start and E1.end <= En.end
and not exists (select *
                from   H_EMPLOYEE E0
                where  E0.CITY=E1.CITY
                and    E0.start < E1.start
                and    E0.end >= E1.start)
and not exists (select *
                from   H_EMPLOYEE Em
                where  Em.CITY=E1.CITY
                and    Em.start <= En.end
                and    Em.end > En.end)
and not exists (select *
                from   H_EMPLOYEE Eg
                where  Eg.CITY=E1.CITY
                and    E1.end <= Eg.end
                and    Eg.end <  En.start
                and    not exists(select *
                                  from   H_EMPLOYEE Ek
                                  where  Ek.CITY=E1.CITY
                                  and    Eg.end   <  Ek.end
                                  and    Ek.start <= Eg.end))
order by E1.CITY,E1.start;


write-b -- ---------------------------------------------------- --;
write   -- Using the general algorithm - Procedural expression  --;
write   -- (SQLfast version)                                    --;
write   -- ---------------------------------------------------- --;

write-b -- Projection H_EMPLOYEE[CITY]                          --;
write-a -- ---------------------------------------------------- --;

create temp table H_CITY (City char(10),start date,end date);
set first = 1;
for city,sta,end = [select CITY,start,end
                    from   H_EMPLOYEE
                    order by CITY,start];
    if ($first$);
        set curCity,curSta,curEnd = $city$,$sta$,$end$;
        set first = 0;
    else;
        if ('$city$' = '$curCity$' and '$sta$' <= '$curEnd$');
            if ('$end$' > '$curEnd$') set curEnd = $end$;
        else;
            insert into H_CITY values ('$curCity$','$curSta$','$curEnd$');
            set curCity,curSta,curEnd = $city$,$sta$,$end$;
        endif;
    endif;
endfor;
if (not $first$)
    insert into H_CITY values ('$curCity$','$curSta$','$curEnd$');
select * from H_CITY;
drop table H_CITY;


write-b -- ---------------------------------------------------- --;
write   -- Using the general algorithm - Procedural expression  --;
write   -- ("LTemp:project" version)                            --;
write   -- ---------------------------------------------------- --;

write-b -- Projection EMPLOYEE[CITY]                            --;
write-a -- ---------------------------------------------------- --;

-- without pre-existing target table --
function status = LTemp:project {select CITY from H_EMPLOYEE
                                 into H_CITY};
if ($status$ = 0) select * from H_CITY;
if ($status$ > 0) write Error: status = $status$];
drop table H_CITY;

write-b -- Projection H_EMPLOYEE[CITY,PROJECT]                  --;
write-a -- ---------------------------------------------------- --;

function status = LTemp:project {select CITY,PROJECT from H_EMPLOYEE
                                 into H_CITY_PROJECT};
if ($status$ = 0) select * from H_CITY_PROJECT;
if ($status$ > 0) write Error: status = $status$];
drop table H_CITY_PROJECT;

write-b -- Projection H_EMPLOYEE[CITY,PROJECT]                  --;
write   --            where SALARY > 3500                       --;
write-a -- ---------------------------------------------------- --;

-- with pre-existing target table --
create temp table H_CITY_PROJECT(CITY char(10),PROJECT char(20),start date,end date);
function status = LTemp:project {select CITY,PROJECT from H_EMPLOYEE where SALARY > 3500
                                 into H_CITY_PROJECT};
if ($status$ = 0) select * from H_CITY_PROJECT;
if ($status$ > 0) write Error: status = $status$];
drop table H_CITY_PROJECT;

write-b -- ---------------------------------------------------- --;
write   -- Using the general algorithm - Procedural expression  --;
write   -- ("LTemp:reduce" version)                             --;
write   -- ---------------------------------------------------- --;

write-b -- Projection EMPLOYEE[CITY]                            --;
write-a -- ---------------------------------------------------- --;

create temp table H_CITY as 
   select CITY,start,end from H_EMPLOYEE;
function status = LTemp:reduce {select CITY from H_CITY};
if ($status$ = 0) select * from H_CITY;
if ($status$ > 0) write Error: status = $status$];
drop table H_CITY;


closeDB;

write-b End of script;

return;
