-- Prerequisite graph of a set of topics for an SQL book       --
-- This graph is not acyclic. It comprises two super circuits. --

insert into NODE values ('HIST','SQL history');
insert into NODE values ('STRU','Data structures');
insert into NODE values ('SET','Set theory');
insert into NODE values ('LOG','Logic');
insert into NODE values ('CALC','Relational calculus');
insert into NODE values ('ALGE','Relational algebra');
insert into NODE values ('LANG','Database languages');
insert into NODE values ('DDL','DDL intro');
insert into NODE values ('CHECK','Check');
insert into NODE values ('TABLE','Tables');
insert into NODE values ('TRIGG','Triggers');
insert into NODE values ('DML','DML intro');
insert into NODE values ('SELECT','select query');
insert into NODE values ('INSERT','insert query');
insert into NODE values ('UPDATE','update query');
insert into NODE values ('DELETE','delete query');

insert into LINK values (1,'HIST','DDL','N');
insert into LINK values (2,'HIST','DML','N');
insert into LINK values (3,'HIST','STRU','N');
insert into LINK values (4,'STRU','DDL','N');
insert into LINK values (5,'STRU','CALC','N');
insert into LINK values (6,'STRU','ALGE','N');
insert into LINK values (7,'SET','STRU','N');
insert into LINK values (8,'SET','ALGE','N');
insert into LINK values (9,'LOG','CALC','N');
insert into LINK values (10,'CALC','ALGE','N');
insert into LINK values (11,'CALC','LANG','N');
insert into LINK values (12,'CALC','SELECT','N');
insert into LINK values (13,'CALC','CHECK','N');
insert into LINK values (14,'ALGE','CALC','N');
insert into LINK values (15,'ALGE','LANG','N');
insert into LINK values (16,'ALGE','SELECT','N');
insert into LINK values (17,'LANG','DML','N');

insert into LINK values (18,'DDL','DML','N');
insert into LINK values (19,'DDL','CHECK','N');
insert into LINK values (20,'DDL','TRIGG','N');
insert into LINK values (21,'DDL','TABLE','N');
insert into LINK values (22,'CHECK','TRIGG','N');
insert into LINK values (23,'TRIGG','INSERT','N');
insert into LINK values (24,'TRIGG','UPDATE','N');
insert into LINK values (25,'TRIGG','DELETE','N');

insert into LINK values (26,'DML','SELECT','N');
insert into LINK values (27,'DML','INSERT','N');
insert into LINK values (28,'DML','UPDATE','N');
insert into LINK values (29,'DML','DELETE','N');

insert into LINK values (30,'SELECT','CHECK','N');
insert into LINK values (31,'SELECT','TRIGG','N');
insert into LINK values (32,'SELECT','INSERT','N');
insert into LINK values (33,'SELECT','UPDATE','N');
insert into LINK values (34,'SELECT','DELETE','N');

insert into LINK values (35,'INSERT','UPDATE','N');
insert into LINK values (36,'INSERT','TRIGG','N');

insert into LINK values (37,'UPDATE','DELETE','N');
insert into LINK values (38,'UPDATE','TRIGG','N');

insert into LINK values (39,'DELETE','TRIGG','N');

-- Reverse links
update LINK set FromNode = ToNode, ToNode = FromNode;

