-- ------------------------------------------------------------ --
-- Checking whether functional dependency PROD --> PRICE exists --
-- ------------------------------------------------------------ --

createDB InMemory;

create table PURCHASE(CUST text,PROD text,PRICE real);
insert into PURCHASE values('Andrew','sugar',2.2);
insert into PURCHASE values('John','sugar',2.2);
insert into PURCHASE values('John','salt',1.4);
insert into PURCHASE values('Ann','soap',1.4);
insert into PURCHASE values('Ann','salt',1.4);
insert into PURCHASE values('John','salt',1.2);
insert into PURCHASE values('Andrew','sugar',2.0);
insert into PURCHASE values('John','salt',1.6);
insert into PURCHASE values('John','soap',1.4);

select * from PURCHASE;

select distinct A1.PROD,A1.PRICE as PRICE
from PURCHASE A1,PURCHASE A2
where A1.PROD = A2.PROD
and A1.PRICE <> A2.PRICE;

select PROD,count(*) as Nb
from (select distinct PROD,PRICE from PURCHASE)
group by PROD
having count(*) > 1;

select PROD,count(distinct PRICE) as Nb
from PURCHASE
group by PROD
having Nb > 1;

select PROD,count(*) as Nb
from   PURCHASE A
where exists(select 1 from PURCHASE 
            where PROD = A.PROD
            and PRICE < A.PRICE)
group by PROD;

select distinct PROD
from  PURCHASE A
where exists(select 1 from PURCHASE 
            where PROD = A.PROD
            and PRICE < A.PRICE);

closeDB;

write-b End of script;

