-- ---------------------- --
-- Incomplete time series --
-- ---------------------- --

createDB InMemory;

create table STAT(
       StatID   integer not null primary key autoincrement,
       DateStat date    not null,
       Visits   integer);

insert into STAT(DateStat,Visits) values('2016-02-26',63852);
insert into STAT(DateStat,Visits) values('2016-02-27',63967);
insert into STAT(DateStat,Visits) values('2016-03-02',64530);
insert into STAT(DateStat,Visits) values('2016-03-03',64603);
insert into STAT(DateStat,Visits) values('2016-03-04',64699);
insert into STAT(DateStat,Visits) values('2016-03-06',64901);

write-b Table STAT, initial state;
select * from STAT order by DateStat;

create table INTERVAL(
       D1 real,
       D2 real,
       V1 integer,
       V2 integer);

insert into INTERVAL
   select jd(D1.DateStat), jd(D2.DateStat), D1.Visits, D2.Visits
   from   STAT D1, STAT D2
   where  D2.StatID = D1.StatID + 1
   and    jd(D2.DateStat) > jd(D1.DateStat) + 1;

write-b Table INTERVAL;
select * from INTERVAL;

for D1,D2,V1,V2 = [select * from INTERVAL order by D1];
  compute len = $D2$ - $D1$ - 1;
  compute step = ($V2$ - $V1$)/($len$ + 1);
  for I = [1,$len$]
    insert into STAT(DateStat,Visits) 
           values(date($D1$ + $I$), int($V1$ + $I$*$step$));
endfor;

write-b Table STAT, final state;
select * from STAT order by DateStat;

closeDB;

write-b End of script;