-- -------------------------------------------------- --
-- Data-driven multiple aggregations (table pivoting) --
-- -------------------------------------------------- --

-- Example 1 --
-- --------- --

createDB InMemory;

create table EXPENSES (DAY integer not null,AMOUNT integer not null);

insert into EXPENSES values ('Monday',26);
insert into EXPENSES values ('Monday',56);
insert into EXPENSES values ('Monday',21);
insert into EXPENSES values ('Tuesday',15);
insert into EXPENSES values ('Tuesday',92);
insert into EXPENSES values ('Tuesday',70);
insert into EXPENSES values ('Tuesday',8);
insert into EXPENSES values ('Tuesday',11);
insert into EXPENSES values ('Wednesday',49);
insert into EXPENSES values ('Wednesday',35);
insert into EXPENSES values ('Thursday',80);
insert into EXPENSES values ('Thursday',6);
insert into EXPENSES values ('Thursday',54);
insert into EXPENSES values ('Thursday',31);
insert into EXPENSES values ('Thursday',4);
insert into EXPENSES values ('Thursday',86);
insert into EXPENSES values ('Friday',49);
insert into EXPENSES values ('Friday',44);
insert into EXPENSES values ('Friday',91);
insert into EXPENSES values ('Friday',67);
insert into EXPENSES values ('Sunday',32);

select sum(case when DAY = 'Monday' then AMOUNT else 0 end) as 'Monday',
       sum(case when DAY = 'Tuesday' then AMOUNT else 0 end) as 'Tuesday',
       sum(case when DAY = 'Wednesday' then AMOUNT else 0 end) as 'Wednesday',
       sum(case when DAY = 'Thursday' then AMOUNT else 0 end) as 'Thursday',
       sum(case when DAY = 'Friday' then AMOUNT else 0 end) as 'Friday',
       sum(case when DAY = 'Saturday' then AMOUNT else 0 end) as 'Saturday',
       sum(case when DAY = 'Sunday' then AMOUNT else 0 end) as 'Sunday'
from EXPENSES;

closeDB;

-- Example 2 --
-- --------- --

createDB InMemory;

create table EXPENSES (YEAR integer not null,
                       QUARTER integer not null,
                       AMOUNT integer not null);

insert into EXPENSES values (2011,4,220);
insert into EXPENSES values (2011,4,146);
insert into EXPENSES values (2011,4,128);
insert into EXPENSES values (2011,4,115);
insert into EXPENSES values (2012,1,126);
insert into EXPENSES values (2012,1,156);
insert into EXPENSES values (2012,1,121);
insert into EXPENSES values (2012,2,215);
insert into EXPENSES values (2012,2,192);
insert into EXPENSES values (2012,2,170);
insert into EXPENSES values (2012,2,228);
insert into EXPENSES values (2012,2,211);
insert into EXPENSES values (2012,3,249);
insert into EXPENSES values (2012,3,180);
insert into EXPENSES values (2012,3,106);
insert into EXPENSES values (2012,3,154);
insert into EXPENSES values (2012,3,231);
insert into EXPENSES values (2012,3,214);
insert into EXPENSES values (2012,3,186);
insert into EXPENSES values (2012,4,249);
insert into EXPENSES values (2012,4,244);
insert into EXPENSES values (2012,4,191);
insert into EXPENSES values (2012,4,167);
insert into EXPENSES values (2012,4,178);
insert into EXPENSES values (2012,4,232);
insert into EXPENSES values (2013,1,226);
insert into EXPENSES values (2013,1,156);
insert into EXPENSES values (2013,2,192);
insert into EXPENSES values (2013,2,170);
insert into EXPENSES values (2013,2,228);
insert into EXPENSES values (2013,2,211);
insert into EXPENSES values (2012,3,249);
insert into EXPENSES values (2013,3,126);
insert into EXPENSES values (2013,3,154);
insert into EXPENSES values (2013,3,94);
insert into EXPENSES values (2013,3,186);
insert into EXPENSES values (2013,4,249);
insert into EXPENSES values (2013,4,191);
insert into EXPENSES values (2013,4,167);
insert into EXPENSES values (2013,4,232);
insert into EXPENSES values (2014,1,241);
insert into EXPENSES values (2014,1,138);
insert into EXPENSES values (2014,2,192);
insert into EXPENSES values (2014,2,191);
insert into EXPENSES values (2014,2,207);
insert into EXPENSES values (2014,2,198);
insert into EXPENSES values (2014,2,235);

select YEAR,
       sum(case when QUARTER = 1 then AMOUNT else 0 end) as 'Q1',
       sum(case when QUARTER = 2 then AMOUNT else 0 end) as 'Q2',
       sum(case when QUARTER = 3 then AMOUNT else 0 end) as 'Q3',
       sum(case when QUARTER = 4 then AMOUNT else 0 end) as 'Q4',
       sum(AMOUNT) as 'Total'
from EXPENSES
group by YEAR;

closeDB;

write-b End of script;

