-- --------------------------- --
-- Smart writing of data table --
-- --------------------------- --

openDB ORDERS.db;

-- compute maximum column lengths
extract lcid,lnam,lcit,lacc
        = select max(length(custID)),max(length(Name)),
                 max(length(City)),max(length(Account))
          from CUSTOMER;

-- ... including column name length.
compute lcid = max(length('CustID'),$lcid$);
compute lnam = max(length('Name'),$lnam$);
compute lcit = max(length('City'),$lcit$);
compute lacc = max(length('Account'),$lacc$);

-- build bars
set dash = -----------------------------------------------;
compute d1 = substr('$dash$',1,$lcid$);
compute d2 = substr('$dash$',1,$lnam$);
compute d3 = substr('$dash$',1,$lcit$);
compute d4 = substr('$dash$',1,$lacc$);
set bar = +-$d1$-+-$d2$-+-$d3$-+-$d4$-+;

-- build title
compute t1 = Frame('CustID',$lcid$,'^',' ');
compute t2 = Frame('Name',$lnam$,'^',' ');
compute t3 = Frame('City',$lcit$,'^',' ');
compute t4 = Frame('Account',$lacc$,'^',' ');
set title = | $t1$ | $t2$ | $t3$ | $t4$ |;

-- write header
write-b $bar$;
write $title$;
write $bar$

-- write data rows
for cid,nam,cit,acc = [select CustID,Name,City,Account
                       from   CUSTOMER where  Account <> 0];
   compute cid = Frame('$cid$',$lcid$,'<',' ');
   compute nam = Frame('$nam$',$lnam$,'<',' ');
   compute cit = Frame('$cit$',$lcit$,'<',' ');
   compute acc = Frame($acc$,$lacc$,'>',' ');
   set dataline = | $cid$ | $nam$ | $cit$ | $acc$ |;
   write $dataline$;
endfor;

-- write bottom bar
write-a $bar$;

closeDB;

write-b End of script;
