-- ------------------- --
-- Travelling salesman --
-- ------------------- --

createDB InMemory;
create table CITY(Name char(10));
create table ROAD(Source char(10),Destin char(10),
                  Distance integer);
-- Choose one of the two test cases -- 
--goto Case1;
goto Case2;

label Case1;
-- 4-city problem --
insert into CITY values ('A'),('B'),('C'),('D');
insert into ROAD values ('A','B',45),('A','C',20),
                        ('A','D',30),('B','C',40),
                        ('B','D',25),('C','D',35);
goto COMPUTING;

label Case2;
-- 15-city problem --
insert into CITY values ('A'),('B'),('C'),('D'),('E'),('F'),('G'),('H'),
                        ('I'),('J'),('K'),('L'),('M'),('N'),('O');
insert into ROAD values ('B','A',25)
                        ,('C','A',75)
                        ,('D','A',60),('D','B',30)
                        ,('E','C',55),('E','D',50)
                        ,('F','B',80),('F','D',90),('F','E',110)
                        ,('G','C',90),('G','E',45)
                        ,('H','F',25),('H','G',135)
                        ,('I','F',120),('I','H',65)
                        ,('J','G',160),('J','H',90),('J','I',85)
                        ,('K','B',230),('K','F',140),('K','I',95)
                        ,('L','K',110),('L','I',60),('L','J',130)
                        ,('M','G',220),('M','J',80),('M','L',95)
                        ,('N','B',255),('N','K',45),('N','L',80),('N','M',190)
                        ,('O','K',70),('O','L',60),('O','M',190),('O','N',95)
                        ;                      
goto COMPUTING;

label COMPUTING;

-- Complete the graph:
insert into ROAD select Destin,Source,Distance from ROAD;

commitDB;

-- Checking
select Source,group_concat(Destin) as Neighbors from ROAD group by Source;

extract N = select count(distinct Source) from ROAD;

select count(distinct Source) as Cities, count(*) as Roads from ROAD;

set Begin = 'A';

start-timer;
create table PATHS as
 with recursive CTE(Len,Start,End,Path,Dist) as
 (select 0,$Begin$,$Begin$,'.'||$Begin$||'.',0
     union all
  select P.Len + 1, P.Start, R.Destin, P.Path||R.Destin||'.', 
         P.Dist + R.Distance
  from   CTE P,ROAD R
  where  P.End = R.Source
  --and    P.Len < $N$
  and    ((P.Len = $N$-1 and R.Destin = $Begin$)
           or
          (P.Len < $N$-1
           and P.Path not like '%.'||R.Destin||'.%'))
  )
 select Len,Start,End,Path,Dist
 from   CTE P 
 where  P.Len > 0;
commitDB;
set time1 = $timer$;

start-timer;
select count(*) as Paths from PATHS;
set time2 = $timer$;

select * from PATHS order by Path limit 100;

extract count,min,max = select count(*),min(Dist),max(Dist)
from   PATHS
where  Len = $N$;

write-ab There are $count$ full paths (length $N$); Min,Max costs: $min$,$max$;
 
if ($count$ > 0);
   start-timer;
   select Path as "Best paths",Dist as Distance
   from   PATHS
   where  Len = $N$
   --and    Dist = $min$;
   and    Dist = (select min(Dist) from PATHS where Len = $N$);
   set time3 = $timer$;
else;
   write No solution;
   set time3 = 0;
endif;

write-b Times:;
write @S3- Paths: $time1$;
write @S3- Count: $time2$;
write @S3- Best:  $time3$;

closeDB;

write-b End of script;
