-- Create the ORDERS database

createOrReplaceDB ORDERS.db;
 
create table CUSTOMER(
        CustID char(10) not null,
        Name char(32) not null,
        Address char(60) not null,
        City char(30) not null,
        Cat char(2),
        Account decimal(9,2) not null,
        constraint PKCUST primary key (CustID));

create table PRODUCT(
        ProdID char(15) not null,
        Description char(60) not null,
        Price integer not null,
        QonHand integer not null,
        constraint PKPROD primary key (ProdID));

create table CUSTORDER(
        OrdID char(12) not null,
        CustID char(10) not null,
        DateOrd date not null,
        constraint PKORD primary key (OrdID),
        constraint FKORDCUST foreign key (CustID) 
           references CUSTOMER
           on delete no action
           on update cascade);

create table DETAIL(
        OrdID char(12) not null,
        ProdID char(15) not null,
        Qord integer not null,
        constraint PKDET primary key (OrdID,ProdID),
        constraint FKDETORD foreign key (OrdID) 
           references CUSTORDER
           on delete cascade
           on update cascade,
        constraint FKDETPROD foreign key (ProdID)
           references PRODUCT
           on delete no action
           on update cascade);

commitDB;

closeDB;
