-- Time expressions

set T1 = 2014-02-27 11:52:10;
set T2 = current_timestamp;

write;
compute A = date('now');
compute B = date(current_date);
compute C = date('now','1 month');
compute D = time('$T1$');
compute E = datetime($T2$);
compute F = datetime($T2$,'localtime');
compute G = round(julianday('now') - julianday('2000-01-01'));
compute H = strftime('Date = %d/%m/%Y',current_timestamp);

write T1. Today: $A$;
write T2. Today: $B$;
write T3. Today + 1 month: $C$;
write T4. Time: $D$;
write T5. Current standard date-time: $E$;
write T6. Current Brussels date-time: $F$;
write T7. Days since 2000-01-01: $G$;
write T8. Formatted date: "$H$";

write;
compute D1 = datePattern('8.24.89');
compute D2 = normDate('8.24.89','p');
write pattern of '8.24.89' = $D1$;
write normalized form of '8.24.89' = $D2$;

-- Some references:
--   http://sqlite.org/lang_datefunc.html
--   http://zetcode.com/db/sqlite/sqlitefunctions/
--   http://www.tutorialspoint.com/sqlite/sqlite_date_time.htm
--   http://www.somacon.com/p370.php