-- Store and read a document in a database --

createOrReplaceDB DOC.db;
create table DOCUMENT(
       ID       integer not null primary key, 
       Name     varchar(128),
       Contents blob);

set fileName = SQLfast-Tutorial.pdf;
set source = Files/$fileName$;
set target = Files/Copy_$fileName$;

onError continue;

BfileToVariable lob1 = $source$;
if ('$FILEdiag$' = 'OK'); 
  insert into DOCUMENT(ID,Name) values (1,'$fileName$');

  insertLOB lob1 = Contents from DOCUMENT where ID = 1;
  extract name,lob2 = select Name,Contents 
                      from   DOCUMENT where ID = 1;

  variableToFile lob2 = $target$;
else;
  showMessage Source file $source$ not found;
endif;

onError stop;

dropVariable lob1;
dropVariable lob2;

closeDB;
deleteDB DOC.db;

write File "Copy_SQLfast-Tutorial.pdf" created in directory "Files".;
