-- -------------------------------------------------------- --
-- Some tricks to guess the data types of an unknown source --
-- -------------------------------------------------------- --

openDB ORDERS.db;

set columns = CustID;Name;Address;City;Cat;Account;
compute last = item('$columns$',-1,';');
set query = ;
for col = [item(;) $columns$];
  set query = $query$ select '$col$' as "Column",;
  set query = $query$ count(*) as "Rows",;
  set query = $query$ count($col$) as "NotNull",;
  set query = $query$ count(distinct $col$) as "Val",;
  set query = $query$ sum(case when isNumeric($col$) then 1 else 0 end) as "Num",;
  set query = $query$ sum(case when isInteger($col$) then 1 else 0 end) as "Int",;
  set query = $query$ sum(case when isDate($col$) then 1 else 0 end) as "Date",;
  set query = $query$ max(length(trim($col$))) as "MaxLen";
  set query = $query$ from CUSTOMER;
  if ('$col$' <> '$last$') set query = $query$ union ;
endfor;
$query$;

set columns = OrdID;CustID;DateOrd;
compute last = item('$columns$',-1,';');
set query = ;
for col = [item(;) $columns$];
  set query = $query$ select '$col$' as "Column",;
  set query = $query$ count(*) as "Rows",;
  set query = $query$ count($col$) as "NotNull",;
  set query = $query$ count(distinct $col$) as "Val",;
  set query = $query$ sum(case when isNumeric($col$) then 1 else 0 end) as "Num",;
  set query = $query$ sum(case when isInteger($col$) then 1 else 0 end) as "Int",;
  set query = $query$ sum(case when isDate($col$) then 1 else 0 end) as "Date",;
  set query = $query$ max(length(trim($col$))) as "MaxLen";
  set query = $query$ from CUSTORDER;
  if ('$col$' <> '$last$') set query = $query$ union ;
endfor;
$query$;

set columns = OrdID;ProdID;Qord;
compute last = item('$columns$',-1,';');
set query = ;
for col = [item(;) $columns$];
  set query = $query$ select '$col$' as "Column",;
  set query = $query$ count(*) as "Rows",;
  set query = $query$ count($col$) as "NotNull",;
  set query = $query$ count(distinct $col$) as "Val",;
  set query = $query$ sum(case when isNumeric($col$) then 1 else 0 end) as "Num",;
  set query = $query$ sum(case when isInteger($col$) then 1 else 0 end) as "Int",;
  set query = $query$ sum(case when isDate($col$) then 1 else 0 end) as "Date",;
  set query = $query$ max(length(trim($col$))) as "MaxLen";
  set query = $query$ from DETAIL;
  if ('$col$' <> '$last$') set query = $query$ union ;
endfor;
$query$;

set columns = ProdID;Description;Price;QonHand;
compute last = item('$columns$',-1,';');
set query = ;
for col = [item(;) $columns$];
  set query = $query$ select '$col$' as "Column",;
  set query = $query$ count(*) as "Rows",;
  set query = $query$ count($col$) as "NotNull",;
  set query = $query$ count(distinct $col$) as "Val",;
  set query = $query$ sum(case when isNumeric($col$) then 1 else 0 end) as "Num",;
  set query = $query$ sum(case when isInteger($col$) then 1 else 0 end) as "Int",;
  set query = $query$ sum(case when isDate($col$) then 1 else 0 end) as "Date",;
  set query = $query$ max(length(trim($col$))) as "MaxLen";
  set query = $query$ from PRODUCT;
  if ('$col$' <> '$last$') set query = $query$ union ;
endfor;
$query$;

closeDB;

write-b === ================================ ===;
write ===     A more general algorithm     ===;
write === ================================ ===;

openDB ORDERS.db;
createDictionary;
for tid,tnam = [select TableID,TableName from SYS_TABLE where TableType = 'base'];
   write-b --- Table "$tnam$" ---;
   set query = ;
   extract last = select ColName from SYS_COLUMN where TableID = $tid$ order by ColName desc #1;
   for col = [select ColName from SYS_COLUMN where TableID = $tid$ order by ColName];
      set query = $query$ select '$col$' as "Column",;
      set query = $query$ count(*) as "Rows",;
      set query = $query$ count($col$) as "NotNull",;
      set query = $query$ count(distinct $col$) as "Val",;
      set query = $query$ sum(case when isNumeric($col$) then 1 else 0 end) as "Num",;
      set query = $query$ sum(case when isInteger($col$) then 1 else 0 end) as "Int",;
      set query = $query$ sum(case when isDate($col$) then 1 else 0 end) as "Date",;
      set query = $query$ max(length(trim($col$))) as "MaxLen";
      set query = $query$ from $tnam$;
      if ('$col$' <> '$last$') set query = $query$ union ;
   endfor;
   $query$;
endfor;
closeDB;
