
openDB ORDERS.db;

ask N = Enter a number (from 0 to 1000):;

drop table if exists NUMBERS;
create temporary table NUMBERS(Nbr integer);

create temporary trigger TRG_NUMBERS
after insert on NUMBERS
for each row
when new.Nbr < $N$
begin
  insert into NUMBERS select new.Nbr+1; end;

--
write-b Creating a table of $N$ numbers through recursive trigger.;

start-timer;

-- SQLite default recursion limited to 1000 --
onError continue;
insert into NUMBERS values (1);
onError stop;

select count(*) from NUMBERS;
write Insertion time: $timer$;

--
drop table NUMBERS;
create temporary table NUMBERS(Nbr integer);
write-b Creating a table of $N$ numbers through recursive CTE.;

start-timer;

with recursive CTE
as  (select 1 as Nbr
       union all
     select Nbr+1 as Nbr from CTE where Nbr < $N$)
insert into NUMBERS select Nbr from CTE;

select count(*) from NUMBERS;
write Insertion time: $timer$;

closeDB;

