-- Coping with circuits --
-- Same as "STAFF-CTE-circuits.sql" with loops --

write-b WARNING: The STAFF database must be "fresh" for this experiment.;
write-a It would be wise to recreate it through script "STAFF-create.sql"
      @nbefore creating circuits.;

openDB STAFF.db;

select * from PERSON;

create temporary table ORG (Lev integer,PID char(4),
                            Path char(256));

ask P = [Enter a PERSON ID] PersonID:[!select PID from PERSON];

-- First include the standard staff hierarchy
insert into ORG select 1,PID,'.'||PID||'.' 
                from   PERSON where PID = '$P$';

for I = [1,999];
   extract N = select count(*) from ORG where Lev = $I$;
   if ($N$ = 0) exit;
   insert into ORG
   select O.Lev+1,P.PID,O.Path||P.PID||'.'
   from   ORG O,PERSON P
   where  P.Manager = O.PID and O.Lev = $I$;
endfor;

select * from ORG order by Path;
delete from ORG;

-- Then, we create a circuit
update PERSON set Manager = 'p07' where PID = 'p01';

-- Controlling infinite execution: third technique
write-b Third protection: Preventing the query from visiting a person twice;

insert into ORG select 1,PID,'.'||PID||'.' 
                from   PERSON where PID = '$P$';

for I = [1,999];
   extract N = select count(*) from ORG where Lev = $I$;
   if ($N$ = 0) exit;
   insert into ORG
   select O.Lev+1,P.PID,O.Path||P.PID||'.'
   from   ORG O,PERSON P
   where  P.Manager = O.PID and O.Lev = $I$
   and    Path not like '.%'||P.PID||'%.';
endfor;

select * from ORG order by Path;

abortDB;
closeDB;


